package jdbcacsess;

import java.util.ArrayList;

import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * 設定ファイルのGUIコンポーネント保存タグの、形式を新しいものに書き換える
 * 
 * @author sima
 * 
 */
class ConvertToCommponent2 {

	ConvertToCommponent2() {
		SettingFile sf = SettingFile.getInstance();

		Element element = sf.getRootElement("component");
		Element guiElementRoot = sf.getRootElement("component2");

		for (Element e : getChildElements(element)) {
			NamedNodeMap nnm = e.getAttributes();
			if (nnm.getLength() != 0) {
				// createdata以外のときは属性を持っているはず
				if (SettingFile.getElementSearchingAttribute(guiElementRoot,
						"window", "name", e.getTagName()) == null) {
					newAppend(sf, guiElementRoot, e.getTagName(), nnm);
				}
			} else {
				ArrayList<Element> elements = getChildElements(e);
				if (elements.size() == 0) {
					continue;
				}
				Element item = elements.get(0);
				nnm = item.getAttributes();
				if (SettingFile.getElementSearchingAttribute2(guiElementRoot,
						"window", "name", item.getTagName(), "table", e
								.getTagName()) == null) {
					Element newElement = newAppend(sf, guiElementRoot, item
							.getTagName(), nnm);
					newElement.setAttribute("table", e.getTagName());
				}
			}
		}
		((Element) element.getParentNode()).removeChild(element);
	}

	/**
	 * 指定Element配下のElementをリストで返す
	 * 
	 * @param element
	 * @return
	 */
	private ArrayList<Element> getChildElements(Element element) {
		ArrayList<Element> elements = new ArrayList<Element>();
		NodeList list = element.getChildNodes();
		for (int i = 0; i < list.getLength(); i++) {
			if (list.item(i).getNodeType() == Node.ELEMENT_NODE) {
				elements.add((Element) list.item(i));
			}
		}
		return elements;
	}

	private Element newAppend(SettingFile sf, Element guiElementRoot,
			String oldTagName, NamedNodeMap nnm) {
		Element newElement = sf.createElement("window");
		for (int j = 0; j < nnm.getLength(); j++) {
			newElement.setAttribute(nnm.item(j).getNodeName(), nnm.item(j)
					.getNodeValue());
		}
		newElement.setAttribute("name", oldTagName);
		guiElementRoot.appendChild(newElement);
		return newElement;
	}

}
