package jdbcacsess.createdata;

import java.awt.Component;
import java.awt.Font;

import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;

import jdbcacsess.gui.JFrameSetting;

public class CellRendererColumns extends DefaultTableCellRenderer {

	private static final long serialVersionUID = 7761617446993569948L;

	private static final Font font = JFrameSetting.getGuiFont();

	private static final Font fontPrim = new Font(JFrameSetting.getGuiFont().getFamily(), Font.BOLD, JFrameSetting.getGuiFont().getSize());

	@Override
	public Component getTableCellRendererComponent(JTable table, Object value,
			boolean isSelected, boolean hasFocus, int row, int column) {

		super.getTableCellRendererComponent(table, value, isSelected, hasFocus,
				row, column);

		if (table.getModel() instanceof ColumnsTableModel) {
		} else {
			return this;
		}

		ColumnsTableModel columnsTableModel = (ColumnsTableModel) table
				.getModel();
		if (columnsTableModel.getColumnInfo(row).isPrimaryKey()) {
			setFont(fontPrim);
		} else {
			setFont(font);
		}

		setToolTipText(columnsTableModel.getColumnInfo(row).getColumnComment());

		return this;
	}

}
