/**
 * 
 */
package jdbcacsess.createdata;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.ItemEvent;
import java.beans.XMLDecoder;
import java.beans.XMLEncoder;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.border.BevelBorder;
import javax.swing.filechooser.FileFilter;

import jdbcacsess.JTextFieldEdit;
import jdbcacsess.JdbcacsessException;
import jdbcacsess.SettingFile;
import jdbcacsess.csv.CsvExport;
import jdbcacsess.csv.CsvInfo;
import jdbcacsess.csv.CsvInputDataView;
import jdbcacsess.csv.CsvInputImportToDB;
import jdbcacsess.csv.CsvMode;
import jdbcacsess.csv.JDialogCsv;
import jdbcacsess.gui.JFrameImportHistory;
import jdbcacsess.gui.JTextPaneSqlStatement;
import jdbcacsess.gui.common.ColumnWidth;
import jdbcacsess.gui.common.JDialogMessage;
import jdbcacsess.gui.common.JFrameBase;
import jdbcacsess.gui.common.JTextAreaNoEdit;
import jdbcacsess.sql.PrepareExecuteStatement;
import jdbcacsess.sql.QueryExecuteAdapter;
import jdbcacsess.sql.QueryExecuteSync;
import jdbcacsess.sql.SchemaTableName;
import jdbcacsess.sql.SqlAnalyze;
import jdbcacsess.sql.SqlExec;

/**
 * @author sima
 * 
 */
public class JFrameCreateDataSetting extends JFrameBase {
	@Override
	public String getAttrKey(){ 
		return "table";
	}
	@Override
	public String getAttrValue(){ 
		return schemaTableName.getCompleteTableName();
	}


	private static final String CREATEDATA_VER_OLD = "Ver 1.0.1";

	private static final String CREATEDATA_VER = "Ver 1.1.0";

	private static final long serialVersionUID = -2532898130845637801L;

	private JPanel jContentPane = null;

	private JTable jTable = null;

	private ColumnsTableModel columnsTableModel;

	private JPanel jPanel = null;

	private JComboBox jComboBox = null;

	private JButton jButtonApply = null;

	private JPanel jPanel1 = null;

	private JPanel jPanelCreateDataBase = null;

	private JLabel jLabel = null;

	private JLabel jLabel1 = null;

	private JLabel jLabelColumnName = null;

	private JPanelCreateData jPanelCreateDataCurrent;

	private Map<String, JPanelCreateData> createDataMap;

	private JButton jButtonCsvOutput = null;

	private JPanel jPanel3 = null;

	private SchemaTableName schemaTableName;

	private JButton jButtonRead = null;

	private JSplitPane jSplitPane = null;

	private JPanel jPanel4 = null;

	private JPanel jPanel5 = null;

	private JLabel jLabel4 = null;

	private JLabel jLabel5 = null;

	private JTextAreaNoEdit jTextAreaNoEditSettingFileName = null;

	private JTextFieldEdit jTextFieldCreateCount = null;

	private JButton jButtonCsvImportHistory = null;

	private JButton jButtonDataView = null;

	private JButton jButtonCsvImport = null;

	private JLabel jLabel2 = null;

	private CsvInfo csvInfo;

//	private ComponentProperty cp;

	private JPanel jPanel6 = null;

	private JPanel jPanel7 = null;

	private JLabel jLabel7 = null;

	private JButton jButtonSqlValidate = null;

	private JTextFieldEdit jTextFieldFetchCount = null;

	private JTextPaneSqlStatement jTextPaneSqlStatement = null;

	/**
	 * This is the default constructor
	 * 
	 * @param name
	 * @throws IOException 
	 */
	public JFrameCreateDataSetting(SchemaTableName name) throws IOException {
		super();
		this.schemaTableName = name;

		createDataMap = new HashMap<String, JPanelCreateData>();
		JPanelCreateData cd;
		cd = new JPanelSequence();
		createDataMap.put(cd.toString(), cd);
		cd = new JPanelFixList();
		createDataMap.put(cd.toString(), cd);
		cd = new JPanelDateTime();
		createDataMap.put(cd.toString(), cd);
		cd = new JPanelDefault();
		createDataMap.put(cd.toString(), cd);

		JPanelSelectResult cd2;
		cd2 = new JPanelSelectResult();
		cd2.setColumnMap(columnMap);
		createDataMap.put(cd2.toString(), cd2);

		this.setTitle("データ生成 " + schemaTableName.getCompleteTableName());
		initialize();

		// divider位置の復元
		Integer divider = omponentProperty.getToInteger(this.getClass(), "divider");
		if (divider != null) {
			jSplitPane.setDividerLocation(divider);
		}
		Integer divider1 = omponentProperty.getToInteger(this.getClass(), "divider1");
		if (divider1 != null) {
			jSplitPane1.setDividerLocation(divider1);
		}
		// ラジオボタン選択状態の復元
		String oneClick = omponentProperty.getToString(this.getClass(), "oneClick");
		if (oneClick != null) {
			jRadioButtonOneClick.setSelected(Boolean.valueOf(oneClick));
		}
		String twoClick = omponentProperty.getToString(this.getClass(), "twoClick");
		if (twoClick != null) {
			jRadioButtonTwoClick.setSelected(Boolean.valueOf(twoClick));
		}

		// CSV情報は最初は、カレントから始める
		csvInfo = new CsvInfo();
		csvInfo.currentDataLoad();

		guideMessageDisplay(false);
		jTextPaneSqlStatement.addFocusListener(new FocusListener() {
			public void focusGained(FocusEvent e) {
				guideMessageDisplay(true);
			}

			public void focusLost(FocusEvent e) {
				guideMessageDisplay(false);
			}
		});

	}

	private void guideMessageDisplay(boolean onlyClear) {
		String ttt = jTextPaneSqlStatement.getText()
				.replaceAll("[\n\r\t ]", "");
		if (ttt.equals("")) {
			jTextPaneSqlStatement.setText("");

			if (!onlyClear) {
				JLabel jlabel = new JLabel(
						"<html>生成手順『SELECT結果』を指示する場合は、ここにSQL文を入力して下さい。入力が終ったら『"
								+ jButtonSqlValidate.getText()
								+ "』ボタンで、SQL文チェック及びカラム情報取得を行ってください。</html>");
				jlabel.setFont(jlabel.getFont().deriveFont(Font.PLAIN, 10));
				jTextPaneSqlStatement.insertComponent(jlabel);
			}
		}
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 * @throws IOException 
	 */
	private void initialize() throws IOException {
		this.setSize(new java.awt.Dimension(700, 550));
		this.setContentPane(getJContentPane());

		//手順書格納ディレクトリが存在しない場合は作成する
		String userPath = getSettingPathName();
		File path = new File(userPath);
		if (!path.exists()) {
			if(path.mkdir()){
				throw new IOException("Couldnt create diretrory.:"+path.getAbsolutePath());
			}
		}

		// テーブル関連情報
		jTextFieldCreateCount.setText("1");
		jTextAreaNoEditSettingFileName.setText(getSettingFileName());

		// 生成手順コンボボックスのitem設定
		for (String str : createDataMap.keySet()) {
			jComboBox.addItem(str);
		}

		// テーブルモデルの初期化
		try {
			columnsTableModel = new ColumnsTableModel();
			columnsTableModel.setTableName(schemaTableName);
		} catch (SQLException e) {
			jdbcacsess.gui.common.JDialogMessage.errorDialog(e, "データ生成でテーブル情報取得");
			return;
		}
		jTable.setModel(columnsTableModel);
		jTable.getColumnModel().getColumn(0).setCellRenderer(
				new CellRendererColumns());
		jTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		// 表示テーブル分の生成手順パラメータ（mapオブジェクト）を読み込み
		if (new File(getSettingFileName()).isFile()) {
			createDataRead(getSettingFileName());
		}

		// 先頭行を選択状態にする
		jTable.setRowSelectionInterval(0, 0);
		selectTableRow(0);

		// テーブルビューの設定
		jTable.getTableHeader().setReorderingAllowed(false);
		ColumnWidth.setColumnWidthResizeOff(jTable);

	}

	/**
	 * @param f
	 */
	private void createDataRead(String f) {
		InputStream in;
		try {
			in = new BufferedInputStream(new FileInputStream(f));
			XMLDecoder d = new XMLDecoder(in);

			try {
				String version = (String) d.readObject();
				if (CREATEDATA_VER_OLD.equals(version)) {
					SchemaTableName tableName = (SchemaTableName) d
							.readObject();
					columnsTableModel.setCreateDataMap(readObject(d));
					jTextFieldCreateCount.setText(((JTextFieldEdit) d
							.readObject()).getText());
					System.out.println("テーブル生成手順読み込み:" + tableName + " "
							+ version);
				} else if (CREATEDATA_VER.equals(version)) {
					SchemaTableName tableName = (SchemaTableName) d
							.readObject();
					columnsTableModel.setCreateDataMap(readObject(d));
					jTextFieldCreateCount.setText((String) d.readObject());
					jTextFieldFetchCount.setText((String) d.readObject());
					jTextPaneSqlStatement.setText((String) d.readObject());
					jCheckBoxFetchEnd.setSelected((Boolean) d.readObject());

					System.out.println("テーブル生成手順読み込み:" + tableName + " "
							+ version);
				} else {
					JDialogMessage.infoDialog("旧バージョンの生成手順のため、読み込めませんでした。",
							"エラー");
				}
			} catch (Exception e) {
				JDialogMessage.errorDialog(e);
			}
			d.close();
			columnsTableModel.fireTableRowsUpdated(0, columnsTableModel
					.getRowCount() - 1);
		} catch (FileNotFoundException e1) {
			JDialogMessage.errorDialog(e1);
		}
	}

	/**
	 * 生成手順パラメータのread。型変換警告がでるので、このメソッドだけ独立させる
	 * 
	 * @param d
	 * @return
	 */
	@SuppressWarnings("unchecked")
	private Map<String, JPanelCreateData> readObject(XMLDecoder d) {
		return (Map<String, JPanelCreateData>) d.readObject();
	}

	/**
	 * 行選択後の詳細手順表示
	 * 
	 * @param rowIdx
	 *            表示させる行インデックス
	 */
	private void selectTableRow(int rowIdx) {
		// 項目名の設定
		jLabelColumnName.setText((String) columnsTableModel.getValueAt(rowIdx,
				0));

		// テーブルモデルから詳細手順パネルをコピーし、
		JPanelCreateData jpcd = columnsTableModel.getJPanelCreateData(rowIdx);
		JPanelCreateData jpcdCopy = jpcd.copy();

		// コンボボックスは専用のデータモデルを用意していない。１要素だけを置き換えることが出来ないと思う
		// createDataMapはコンボボックスのデータモデル代わり。＝＞ならリストデータモデル作れよ！
		createDataMap.put(jpcd.toString(), jpcdCopy);
		jComboBox.setSelectedItem(jpcd.toString());

		changePanelCreateData(jpcdCopy);
	}

	/**
	 * 指定した内容で、詳細手順パネルの表示内容の切替。行選択時とコンボボックス選択時に動く
	 * 
	 * @param jpcd
	 */
	private void changePanelCreateData(JPanelCreateData jpcd) {
		jPanelCreateDataBase.setVisible(false);
		jPanelCreateDataBase.removeAll();
		jPanelCreateDataBase.add(jpcd, java.awt.BorderLayout.CENTER);
		jPanelCreateDataBase.setVisible(true);
		getJContentPane().revalidate();
		jPanelCreateDataCurrent = jpcd;
	}

	/**
	 * 詳細手順パネルの内容をテーブルに反映する
	 * 
	 * @param e
	 */
	protected void actionPerformedApply(ActionEvent e) {
		if (!jPanelCreateDataCurrent.isVisible()) {
			return;
		}
		int[] indexs = jTable.getSelectedRows();
		// System.out.print("■適用:コピー元");
		// jPanelCreateDataCurrent.debugPrint();
		for (int i = 0; i < indexs.length; i++) {
			JPanelCreateData newJpcd = jPanelCreateDataCurrent
					.copy();
			// System.out.print("■適用:コピー先");
			if (newJpcd == null) {
				return;
			}
			// newJpcd.debugPrint();

			columnsTableModel.setJPanelCreateData(indexs[i], newJpcd);
		}
	}

	/**
	 * 手順のマージ取り込みを行う
	 */
	private void actionPerformedRead() {
		class FileFilterEx extends FileFilter {
			private String extension, msg;

			public FileFilterEx(String extension, String msg) {
				this.extension = extension;
				this.msg = msg;
			}

			@Override
			public boolean accept(java.io.File f) {
				return f.getName().endsWith(extension);
			}

			@Override
			public String getDescription() {
				return msg;
			}
		}
		JFileChooser jFileChooser = new JFileChooser(getSettingPathName());
		FileFilter ff = new FileFilterEx(".xml", "XML ファイル(*.xml)");
		jFileChooser.addChoosableFileFilter(ff);
		jFileChooser.setFileFilter(ff);
		jFileChooser.setMultiSelectionEnabled(false);

		int ans = jFileChooser.showOpenDialog(this);
		if (ans == JFileChooser.APPROVE_OPTION) {
			createDataRead(jFileChooser.getSelectedFile().getPath());
		}
	}

	/**
	 * ＣＳＶ自動生成を行う
	 * 
	 * @throws SQLException
	 */
	protected void actionPerformmedCsvOutput() {
		// 生成件数
		int creatCnt = 0;
		try {
			creatCnt = new Integer(jTextFieldCreateCount.getText());
		} catch (NumberFormatException e2) {
			JDialogMessage.errorDialog(e2);
			return;
		}

		// CSV作成ダイアログを表示
		csvInfo.setPropTableName(schemaTableName);
		JDialogCsv dlg = new JDialogCsv(CsvMode.CREATEDATA, csvInfo);
		CsvInfo ci = dlg.getCsvInfo();
		if (ci == null) {
			// ダイアログで取消の場合は終る
			return;
		}
		csvInfo = ci;

		// CSVファイル出力オブジェクト生成し、行自動生成オブジェクトに登録する
		columnsTableModel.removeOutputQueryExecuteListeners();
		columnsTableModel.addOutputQueryExecuteListener(new CsvExport(csvInfo));

		SelectQueryExecute selectQueryExecute = null;

		for (int i = 0; i < columnsTableModel.getRowCount(); i++) {
			if (columnsTableModel.getJPanelCreateData(i) instanceof JPanelSelectResult) {
				// SQL実行結果を取り込む必要がある時
				JPanelSelectResult new_name = (JPanelSelectResult) columnsTableModel
						.getJPanelCreateData(i);

				if (selectQueryExecute == null) {
					try {
						selectQueryExecute = new SelectQueryExecute();
					} catch (JdbcacsessException e) {
						JDialogMessage.errorDialog(e);
						return;
					}
				}
				// 検索結果の受け取りは、JPanelSelectResultで行う。columnsTableModelで表示される全てのオブジェクトを登録する
				selectQueryExecute.addQueryExecuteListener(new_name);
			}
		}

		try {
			boolean fetchEnd = false;
			int realOutputCnt = 0;
			// 自動生成開始
			columnsTableModel.initOutput();
			for (int rowCnt = 0; rowCnt < creatCnt; rowCnt++) {
				if (selectQueryExecute != null) {
					if (!fetchEnd) {
						fetchEnd = !selectQueryExecute.next();
						if (fetchEnd && jCheckBoxFetchEnd.isSelected()) {
							break;
						}
					}
				}
				realOutputCnt++;
				columnsTableModel.detailOutput();
			}
			columnsTableModel.endOutput(realOutputCnt);

		} catch (IOException e) {
			JDialogMessage.errorDialog(e);
		} catch (JdbcacsessException e) {
			JDialogMessage.errorDialog(e);
		} finally {
			if (selectQueryExecute != null) {
				try {
					selectQueryExecute.end();
				} catch (JdbcacsessException e) {
					JDialogMessage.errorDialog(e);
				}
			}
		}

		// 生成手順パラメータの保存
		OutputStream out = null;
		try {
			out = new BufferedOutputStream(new FileOutputStream(
					getSettingFileName()));
			XMLEncoder e = new XMLEncoder(out);
			e.writeObject(CREATEDATA_VER);
			e.writeObject(schemaTableName);
			e.writeObject(columnsTableModel.getCreateDataMap());
			e.writeObject(jTextFieldCreateCount.getText());
			e.writeObject(jTextFieldFetchCount.getText());
			e.writeObject(jTextPaneSqlStatement.getText());
			e.writeObject(jCheckBoxFetchEnd.isSelected());
			e.close();
		} catch (FileNotFoundException e) {
			JDialogMessage.errorDialog(e);
		}
	}

	class SelectQueryExecute {

		SqlAnalyze sa = null;

		QueryExecuteSync qes = null;

		Connection con = null;

		int fetchCnt = -1;

		int rowFetchCnt = 0;

		Exception exception = null;

		SelectQueryExecute() throws JdbcacsessException {
			try {
				fetchCnt = new Integer(jTextFieldFetchCount.getText());
			} catch (NumberFormatException e) {
				throw new JdbcacsessException("『" + jLabel7.getText()
						+ "』に、１以上の数値を指定してください");
			}
			if (fetchCnt < 1) {
				throw new JdbcacsessException("『" + jLabel7.getText()
						+ "』に、１以上の数値を指定してください");
			}

			sa = new SqlAnalyze(jTextPaneSqlStatement.getText());

			try {
				con = SqlExec.getNewConnection();
			} catch (Exception e) {
				throw new JdbcacsessException(e);
			}

			qes = new QueryExecuteSync(this, sa, con);
			qes.open();
			rowFetchCnt = 0;

			qes.addQueryExecuteListener(new QueryExecuteAdapter() {
				@Override
				public void errorException(Exception ex) {
					exception = ex;
				}
			});

			if (exception != null) {
				throw new JdbcacsessException(exception);
			}
		}

		void addQueryExecuteListener(JPanelSelectResult new_name) {
			qes.addQueryExecuteListener(new_name);
		}

		boolean first = true;

		boolean next() throws JdbcacsessException {
			if (rowFetchCnt == 0) {
				if (!qes.read()) {
					if (exception != null) {
						throw new JdbcacsessException(exception);
					}
					if (first) {
						throw new JdbcacsessException("検索結果が０件なので生成出来ません");
					}
					return false;
				}
			}
			rowFetchCnt++;
			if (rowFetchCnt == fetchCnt) {
				rowFetchCnt = 0;
			}
			first = false;
			return true;
		}

		void end() throws JdbcacsessException {
			if (qes != null) {
				qes.close();
			}
			if (con != null) {
				SqlExec.disconnect(con);
			}
			if (exception != null) {
				throw new JdbcacsessException(exception);
			}
		}
	}

	/**
	 * ＣＳＶ入力を行う
	 */
	private void actionPerformedCsvImport() {
		// Importダイアログの表示
		csvInfo.setPropTableName(schemaTableName);
		JDialogCsv dlg = new JDialogCsv(CsvMode.IMPORT, csvInfo);
		CsvInfo ci = dlg.getCsvInfo();
		if (ci == null) {
			// 取得できなかったなので、取消押下
			return;
		}
		csvInfo = ci;
		new Thread(new CsvInputImportToDB(csvInfo)).start();
	}

	/**
	 * 生成手順パラメータの格納ディレクトリを返却
	 * 
	 * @return
	 */
	private String getSettingPathName() {
		SettingFile.getInstance();
		return SettingFile.getFileName("createData");
	}

	/**
	 * テーブル名から生成手順パラメータファイル名を作成し返却
	 * 
	 * @return
	 * @throws IOException 
	 */
	private String getSettingFileName()  {
		String userPath = getSettingPathName();
		String s = userPath + System.getProperty("file.separator")
				+ schemaTableName.getCompleteTableName() + ".xml";
		return s;
	}

	/**
	 * ダイアログの終了処理。
	 */
	@Override
	public void frameClosing() {
		omponentProperty.put(this.getClass(), "divider", jSplitPane.getDividerLocation());
		omponentProperty.put(this.getClass(), "divider1", jSplitPane1.getDividerLocation());
		omponentProperty.put(this.getClass(), "oneClick", Boolean.valueOf(jRadioButtonOneClick.isSelected()).toString());
		omponentProperty.put(this.getClass(), "twoClick", Boolean.valueOf(jRadioButtonTwoClick.isSelected()).toString());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel3(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getJPanel6(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private JTable getJTable() {
		if (jTable == null) {
			jTable = new JTable();
			jTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
			jTable.addMouseListener(new java.awt.event.MouseAdapter() {
				@Override
				public void mouseClicked(java.awt.event.MouseEvent e) {
					if (e.getButton() == 1
							&& e.getClickCount() == (jRadioButtonTwoClick
									.isSelected() ? 2 : 1)) {
						System.out
								.println("JFrameCreateDataSetting#mouseClicked:start");
						selectTableRow(jTable.rowAtPoint(e.getPoint()));
						System.out
								.println("JFrameCreateDataSetting#mouseClicked:end");
					}
				}
			});
		}
		return jTable;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(new BorderLayout());
			jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null,
					"各カラムのデータ生成方法",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION,
					new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12),
					java.awt.Color.black));
			jPanel.add(getJPanel1(), java.awt.BorderLayout.NORTH);
			jPanel.add(getJPanelCreateDataBase(), java.awt.BorderLayout.CENTER);
		}
		return jPanel;
	}

	/**
	 * This method initializes jComboBox
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBox() {
		if (jComboBox == null) {
			jComboBox = new JComboBox();
			jComboBox.setName("jComboBox");
			jComboBox.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (e.getStateChange() == ItemEvent.DESELECTED) {
						return;
					}
					changePanelCreateData(createDataMap.get(e
							.getItem()));
				}
			});
		}
		return jComboBox;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonApply() {
		if (jButtonApply == null) {
			jButtonApply = new JButton();
			jButtonApply.setText("適用");
			jButtonApply.setToolTipText("選択されているカラム行全てに反映します");
			jButtonApply.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					actionPerformedApply(e);
				}
			});
		}
		return jButtonApply;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			gridBagConstraints17.gridx = 2;
			gridBagConstraints17.insets = new Insets(0, 0, 0, 15);
			gridBagConstraints17.gridwidth = 1;
			gridBagConstraints17.anchor = GridBagConstraints.WEST;
			gridBagConstraints17.gridy = 1;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints3.gridy = 1;
			gridBagConstraints3.ipadx = 7;
			gridBagConstraints3.weightx = 1.0;
			gridBagConstraints3.insets = new java.awt.Insets(0, 0, 5, 5);
			gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints3.gridx = 1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.ipady = 5;
			gridBagConstraints2.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints2.insets = new java.awt.Insets(0, 5, 5, 5);
			gridBagConstraints2.gridy = 1;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 1;
			gridBagConstraints1.ipadx = 11;
			gridBagConstraints1.ipady = 5;
			gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints1.fill = GridBagConstraints.BOTH;
			gridBagConstraints1.insets = new java.awt.Insets(0, 3, 5, 5);
			gridBagConstraints1.gridwidth = 2;
			gridBagConstraints1.gridy = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.ipady = 5;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
			gridBagConstraints.gridy = 0;
			jLabelColumnName = new JLabel();
			jLabelColumnName.setText(" ");
			jLabelColumnName.setFont(new java.awt.Font("Monospaced",
					java.awt.Font.BOLD, 16));
			jLabel1 = new JLabel();
			jLabel1.setText("カラム名");
			jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
			jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			jLabel = new JLabel();
			jLabel.setText("生成手順");
			jLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			jLabel.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
			jLabel.setName("jLabel");
			jPanel1 = new JPanel();
			jPanel1.setLayout(new GridBagLayout());
			jPanel1.setMinimumSize(new java.awt.Dimension(0, 0));
			jPanel1.add(jLabel1, gridBagConstraints);
			jPanel1.add(jLabelColumnName, gridBagConstraints1);
			jPanel1.add(jLabel, gridBagConstraints2);
			jPanel1.add(getJComboBox(), gridBagConstraints3);
			jPanel1.add(getJButtonApply(), gridBagConstraints17);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelCreateDataBase() {
		if (jPanelCreateDataBase == null) {
			jPanelCreateDataBase = new JPanel();
			jPanelCreateDataBase.setLayout(new BorderLayout());
			jPanelCreateDataBase
					.setBorder(javax.swing.BorderFactory
							.createTitledBorder(
									null,
									"生成パラメータ",
									javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
									javax.swing.border.TitledBorder.DEFAULT_POSITION,
									new java.awt.Font("Dialog",
											java.awt.Font.PLAIN, 12),
									java.awt.Color.black));
		}
		return jPanelCreateDataBase;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonCsvOutput() {
		if (jButtonCsvOutput == null) {
			jButtonCsvOutput = new JButton();
			jButtonCsvOutput.setText("CSV出力...");
			jButtonCsvOutput
					.setToolTipText("データ生成＆ＣＳＶファイル出力を行い、成功した場合は設定保存ファイルに自働セーブします");
			jButtonCsvOutput
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformmedCsvOutput();
						}
					});
		}
		return jButtonCsvOutput;
	}

	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new JPanel();
			jPanel3.add(getJButtonRead(), null);
			jPanel3.add(getJButtonCsvOutput(), null);
			jPanel3.add(getJButtonDataView(), null);
			jPanel3.add(getJButtonCsvImport(), null);
			jPanel3.add(getJButtonCsvImportHistory(), null);
		}
		return jPanel3;
	}

	/**
	 * This method initializes jButtonRead
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonRead() {
		if (jButtonRead == null) {
			jButtonRead = new JButton();
			jButtonRead.setText("手順のマージ取込...");
			jButtonRead.setToolTipText("他テーブルの設定を取り込み、カラム名が一致している行の全てを置き換えます");
			jButtonRead.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					actionPerformedRead();
				}
			});
		}
		return jButtonRead;
	}

	/**
	 * This method initializes jSplitPane
	 * 
	 * @return javax.swing.JSplitPane
	 */
	private JSplitPane getJSplitPane() {
		if (jSplitPane == null) {
			jSplitPane = new JSplitPane();
			jSplitPane.setOneTouchExpandable(true);
			jSplitPane.setDividerSize(7);
			jSplitPane.setDividerLocation(370);
			jSplitPane.setLeftComponent(getJPanel4());
			jSplitPane.setRightComponent(getJPanel());
		}
		return jSplitPane;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			jLabel2 = new JLabel();
			jLabel2.setText("右画面での編集開始クリック数");
			jLabel2.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
			jPanel4 = new JPanel();
			jPanel4.setLayout(new BorderLayout());
			jPanel4.add(getJPanel5(), BorderLayout.NORTH);
			jPanel4.add(getJPanel2(), BorderLayout.CENTER);
			jPanel4.add(getJPanel8(), BorderLayout.SOUTH);
		}
		return jPanel4;
	}

	/**
	 * This method initializes jPanel5
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel5() {
		if (jPanel5 == null) {
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			gridBagConstraints16.gridx = 4;
			gridBagConstraints16.gridy = 1;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.fill = GridBagConstraints.NONE;
			gridBagConstraints12.gridy = 2;
			gridBagConstraints12.weightx = 0.0;
			gridBagConstraints12.anchor = GridBagConstraints.WEST;
			gridBagConstraints12.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints12.gridx = 2;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 4;
			gridBagConstraints11.insets = new Insets(2, 5, 2, 0);
			gridBagConstraints11.anchor = GridBagConstraints.CENTER;
			gridBagConstraints11.gridy = 2;
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.gridx = 0;
			gridBagConstraints10.anchor = GridBagConstraints.EAST;
			gridBagConstraints10.gridheight = 2;
			gridBagConstraints10.insets = new Insets(0, 5, 0, 5);
			gridBagConstraints10.gridwidth = 2;
			gridBagConstraints10.gridy = 2;
			jLabel7 = new JLabel();
			jLabel7.setText("FETCH１回の生成行数");
			jLabel7.setToolTipText("");
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.fill = GridBagConstraints.NONE;
			gridBagConstraints8.gridy = 1;
			gridBagConstraints8.weightx = 0.0;
			gridBagConstraints8.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints8.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints8.gridx = 1;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints5.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints5.insets = new java.awt.Insets(0, 5, 0, 5);
			gridBagConstraints5.gridy = 1;
			jLabel5 = new JLabel();
			jLabel5.setText("設定保存ファイル");
			jLabel5.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
			jLabel4 = new JLabel();
			jLabel4.setText("生成行数");
			jPanel5 = new JPanel();
			jPanel5.setLayout(new GridBagLayout());
			jPanel5.add(jLabel4, gridBagConstraints5);
			jPanel5.add(getJTextFieldCreateCount(), gridBagConstraints8);
			jPanel5.add(jLabel7, gridBagConstraints10);
			jPanel5.add(getJButtonSqlValidate(), gridBagConstraints11);
			jPanel5.add(getJTextFieldFetchCount(), gridBagConstraints12);
			jPanel5.add(getJCheckBoxFetchEnd(), gridBagConstraints16);
		}
		return jPanel5;
	}

	/**
	 * This method initializes jTextAreaNoEdit
	 * 
	 * @return jdbcacsess.JTextAreaNoEdit
	 */
	private JTextAreaNoEdit getJTextAreaNoEditSettingFileName() {
		if (jTextAreaNoEditSettingFileName == null) {
			jTextAreaNoEditSettingFileName = new JTextAreaNoEdit();
		}
		return jTextAreaNoEditSettingFileName;
	}

	/**
	 * This method initializes jTextFieldCreateCount
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldCreateCount() {
		if (jTextFieldCreateCount == null) {
			jTextFieldCreateCount = new JTextFieldEdit();
			jTextFieldCreateCount.setColumns(5);
			jTextFieldCreateCount.setMinimumSize(new Dimension(50, 22));
			jTextFieldCreateCount.setHorizontalAlignment(SwingConstants.TRAILING);
		}
		return jTextFieldCreateCount;
	}

	/**
	 * This method initializes jButton2
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonDataView() {
		if (jButtonDataView == null) {
			jButtonDataView = new JButton();
			jButtonDataView.setText("データ100件参照...");
			jButtonDataView
					.setToolTipText("<html>作成したＣＳＶファイルを最高１００件読込し、参照画面に表示します<br>"
							+ "DB定義チェックやDB更新は行わないので、ファイル形式と内容確認のみが出来ます</html>");
			jButtonDataView
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							new CsvInputDataView(csvInfo);
						}
					});
		}
		return jButtonDataView;
	}

	/**
	 * This method initializes jButton3
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonCsvImport() {
		if (jButtonCsvImport == null) {
			jButtonCsvImport = new JButton();
			jButtonCsvImport.setText("CSV入力...");
			jButtonCsvImport.setToolTipText("作成したＣＳＶファイルをインポートします");
			jButtonCsvImport
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedCsvImport();
						}
					});
		}
		return jButtonCsvImport;
	}

	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonCsvImportHistory() {
		if (jButtonCsvImportHistory == null) {
			jButtonCsvImportHistory = new JButton();
			jButtonCsvImportHistory.setText("CSV入力履歴...");
			jButtonCsvImportHistory
					.setToolTipText("<html>ＣＳＶファイル入力の実行履歴画面を表示します<br>"
							+ "インポートの再実行を指示もできます</html>");
			jButtonCsvImportHistory
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							try {
								new JFrameImportHistory();
							} catch (JdbcacsessException e1) {
								JDialogMessage.errorDialog(e1);
							}
						}
					});
		}
		return jButtonCsvImportHistory;
	}

	/**
	 * This method initializes jPanel6
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel6() {
		if (jPanel6 == null) {
			jPanel6 = new JPanel();
			jPanel6.setLayout(new BorderLayout());
			jPanel6.add(getJPanel9(), BorderLayout.NORTH);
			jPanel6.add(getJSplitPane(), BorderLayout.CENTER);
			jPanel6.add(getJPanel7(), BorderLayout.SOUTH);
		}
		return jPanel6;
	}

	/**
	 * This method initializes jPanel7
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel7() {
		if (jPanel7 == null) {
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.anchor = GridBagConstraints.NORTHEAST;
			gridBagConstraints4.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints4.gridx = -1;
			gridBagConstraints4.gridy = -1;
			gridBagConstraints4.fill = GridBagConstraints.NONE;
			jPanel7 = new JPanel();
			jPanel7.setLayout(new BorderLayout());
			jPanel7.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jPanel7.add(jLabel5, BorderLayout.WEST);
			jPanel7.add(getJTextAreaNoEditSettingFileName(),
					BorderLayout.CENTER);
		}
		return jPanel7;
	}

	/**
	 * This method initializes jButtonSqlValidate
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSqlValidate() {
		if (jButtonSqlValidate == null) {
			jButtonSqlValidate = new JButton();
			jButtonSqlValidate.setText("SELECT文検証");
			jButtonSqlValidate.setMargin(new Insets(4, 8, 4, 8));
			jButtonSqlValidate
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedSqlValidate();
						}
					});
		}
		return jButtonSqlValidate;
	}

	TreeMap<Integer, String> columnMap = new TreeMap<Integer, String>();

	private JPanel jPanel8 = null;

	private JRadioButton jRadioButtonOneClick = null;

	private JRadioButton jRadioButtonTwoClick = null;

	private JCheckBox jCheckBoxFetchEnd = null;

	private JTextAreaNoEdit jTextAreaNoEditTableName = null;

	protected void actionPerformedSqlValidate() {
		PrepareExecuteStatement pe = new PrepareExecuteStatement();
		pe.addStm(jTextPaneSqlStatement.getText());

		Connection con = null;
		ResultSet rs = null;

			try {
				con = SqlExec.getNewConnection();
			} catch (Exception e) {
				JDialogMessage.errorDialog(e);
				return;
			}
			try {
			pe.prepare(con);
			rs = pe.executeQuery();
			ResultSetMetaData rsmd = rs.getMetaData();

			columnMap.clear();
			for (int i = 1; i < rsmd.getColumnCount() + 1; i++) {
				columnMap.put(i, rsmd.getColumnName(i));
			}
			for (JPanelCreateData item : createDataMap.values()) {
				if (item instanceof JPanelSelectResult) {
					JPanelSelectResult jpsr = (JPanelSelectResult) item;
					jpsr.setColumnMap(columnMap);
				}
			}
			System.out.println(columnMap.toString());

		} catch (SQLException e) {
			jdbcacsess.gui.common.JDialogMessage.errorDialog(e, "SQL文の検証");
			columnMap.clear();
		} finally {
			if (rs != null) {
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
			if (con != null) {
				SqlExec.disconnect(con);
			}
		}
	}

	/**
	 * This method initializes jTextFieldFetchCount
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldFetchCount() {
		if (jTextFieldFetchCount == null) {
			jTextFieldFetchCount = new JTextFieldEdit();
			jTextFieldFetchCount.setColumns(5);
			jTextFieldFetchCount.setMinimumSize(new Dimension(50, 22));
			jTextFieldFetchCount.setHorizontalAlignment(SwingConstants.TRAILING);
		}
		return jTextFieldFetchCount;
	}

	/**
	 * This method initializes jTextPaneSqlStatement
	 * 
	 * @return jdbcacsess.gui.JTextPaneSqlStatement
	 */

	private JSplitPane jSplitPane1 = null;

	private JScrollPane jScrollPane1 = null;

	private JScrollPane jScrollPane = null;

	private JPanel jPanel2 = null;

	private JPanel jPanel9 = null;

	private JTextPaneSqlStatement getJTextPaneSqlStatement() {
		if (jTextPaneSqlStatement == null) {
			jTextPaneSqlStatement = new JTextPaneSqlStatement();
			jTextPaneSqlStatement.setBorder(getJTextFieldCreateCount()
					.getBorder());
		}
		return jTextPaneSqlStatement;
	}

	/**
	 * This method initializes jPanel8
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel8() {
		if (jPanel8 == null) {
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.gridx = 2;
			gridBagConstraints15.gridy = 0;
			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
			gridBagConstraints14.gridx = 1;
			gridBagConstraints14.gridy = 0;
			jPanel8 = new JPanel();
			jPanel8.setLayout(new GridBagLayout());
			jPanel8.add(jLabel2, new GridBagConstraints());
			jPanel8.add(getJRadioButtonOneClick(), gridBagConstraints14);
			jPanel8.add(getJRadioButtonTwoClick(), gridBagConstraints15);

			ButtonGroup group = new ButtonGroup();
			group.add(getJRadioButtonOneClick());
			group.add(getJRadioButtonTwoClick());
		}
		return jPanel8;
	}

	/**
	 * This method initializes jRadioButtonOneClick
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonOneClick() {
		if (jRadioButtonOneClick == null) {
			jRadioButtonOneClick = new JRadioButton();
			jRadioButtonOneClick.setText("１回");
			jRadioButtonOneClick.setSelected(true);
		}
		return jRadioButtonOneClick;
	}

	/**
	 * This method initializes jRadioButtonTwoClick
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonTwoClick() {
		if (jRadioButtonTwoClick == null) {
			jRadioButtonTwoClick = new JRadioButton();
			jRadioButtonTwoClick.setText("２回");
		}
		return jRadioButtonTwoClick;
	}

	/**
	 * This method initializes jCheckBoxFetchEnd
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBoxFetchEnd() {
		if (jCheckBoxFetchEnd == null) {
			jCheckBoxFetchEnd = new JCheckBox();
			jCheckBoxFetchEnd.setText("FETCH終了で打切る");
		}
		return jCheckBoxFetchEnd;
	}

	/**
	 * This method initializes jTextAreaNoEditTableName
	 * 
	 * @return jdbcacsess.gui.common.JTextAreaNoEdit
	 */
	private JTextAreaNoEdit getJTextAreaNoEditTableName() {
		if (jTextAreaNoEditTableName == null) {
			jTextAreaNoEditTableName = new JTextAreaNoEdit();
			jTextAreaNoEditTableName.setFont(new Font("Monospaced", Font.BOLD,
					16));
			jTextAreaNoEditTableName.setText(schemaTableName
					.getCompleteTableName());
		}
		return jTextAreaNoEditTableName;
	}

	/**
	 * This method initializes jSplitPane1
	 * 
	 * @return javax.swing.JSplitPane
	 */
	private JSplitPane getJSplitPane1() {
		if (jSplitPane1 == null) {
			jSplitPane1 = new JSplitPane();
			jSplitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
			jSplitPane1.setOneTouchExpandable(true);
			jSplitPane1.setDividerLocation(50);
			jSplitPane1.setTopComponent(getJScrollPane());
			jSplitPane1.setBottomComponent(getJScrollPane1());
		}
		return jSplitPane1;
	}

	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setViewportView(getJTable());
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTextPaneSqlStatement());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
			jPanel2.setLayout(new BorderLayout());
			jPanel2.add(getJSplitPane1(), BorderLayout.CENTER);
		}
		return jPanel2;
	}

	/**
	 * This method initializes jPanel9
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel9() {
		if (jPanel9 == null) {
			jPanel9 = new JPanel();
			jPanel9.setLayout(new BorderLayout());
			jPanel9.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jPanel9.add(getJTextAreaNoEditTableName(), BorderLayout.CENTER);
		}
		return jPanel9;
	}
}
