/**
 * 
 */
package jdbcacsess.createdata;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import jdbcacsess.JTextFieldEdit;
import jdbcacsess.gui.common.JTextAreaNoEdit;

/**
 * @author sima
 * 
 */
public class JPanelDateTime extends JPanelCreateData {

	/**
	 * 
	 */
	private static final long serialVersionUID = 279372249069096124L;

	private JTextAreaNoEdit jTextAreaNoEdit = null;

	private JPanel jPanel3 = null;

	private JCheckBox jCheckBoxMilliSec = null;

	private JLabel jLabel = null;

	private JLabel jLabel1 = null;

	private JLabel jLabel2 = null;

	private JTextFieldEdit jTextFieldStepValue = null;

	private JTextFieldEdit jTextFieldInitialValue = null;

	private JPanel jPanel1 = null;

	private JRadioButton jRadioButtonAuto = null;

	private JRadioButton jRadioButtonManul = null;

	private JTextFieldEdit jTextFieldFormat = null;

	private JLabel jLabel3 = null;

	private JRadioButton jRadioButtonYear = null;

	private JRadioButton jRadioButtonMonth = null;

	private JRadioButton jRadioButtonDay = null;

	private JRadioButton jRadioButtonHour = null;

	private JRadioButton jRadioButtonMin = null;

	private JRadioButton jRadioButtonSec = null;

	private JRadioButton jRadioButtonMiliSec = null;

	/**
	 * 
	 */
	public JPanelDateTime() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		this.setLayout(new BorderLayout());
		this.add(getJTextAreaNoEdit(), java.awt.BorderLayout.NORTH);
		this.add(getJPanel(), java.awt.BorderLayout.CENTER);
		ButtonGroup bg = new ButtonGroup();
		bg.add(getJRadioButtonAuto());
		bg.add(getJRadioButtonManul());

		ButtonGroup bgTanni = new ButtonGroup();
		bgTanni.add(getJRadioButtonYear());
		bgTanni.add(getJRadioButtonMonth());
		bgTanni.add(getJRadioButtonDay());
		bgTanni.add(getJRadioButtonWeekOfMonth());
		bgTanni.add(getJRadioButtonHour());
		bgTanni.add(getJRadioButtonMin());
		bgTanni.add(getJRadioButtonSec());
		bgTanni.add(getJRadioButtonMiliSec());

		jRadioButtonSec.setSelected(true);

	}

	private long dateTime;

	private SimpleDateFormat sdf;

	private GregorianCalendar gc;

	private JRadioButton jRadioButtonWeekOfMonth = null;

	private JLabel jLabel5 = null;

	private JPanel jPanel = null;

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#dataInitial()
	 */
	@Override
	public void dataInitial() {
		sdf = new SimpleDateFormat(getFormat());

		if (getInitialValue().equals("")) {
			dateTime = System.currentTimeMillis();
		} else {
			dateTime = 0;
			try {
				Date date = sdf.parse(getInitialValue());
				dateTime = date.getTime();
			} catch (ParseException e) {
				// TODO 自動生成された catch ブロック
				e.printStackTrace();
			}
		}

		gc = new GregorianCalendar();
		gc.setTime(new Date(dateTime));
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#dataNext()
	 */
	@Override
	public String dataNext() {
		String rtn = sdf.format(gc.getTime().getTime());
		int amount = Integer.parseInt(getStepValue());
		if (getUnitYear()) {
			gc.add(Calendar.YEAR, amount);
		}
		if (getUnitMonth()) {
			gc.add(Calendar.MONTH, amount);
		}
		if (getUnitDay()) {
			gc.add(Calendar.DAY_OF_MONTH, amount);
		}
		if (getUnitWeekOfMonth()) {
			gc.add(Calendar.WEEK_OF_MONTH, amount);
		}
		if (getUnitHour()) {
			gc.add(Calendar.HOUR_OF_DAY, amount);
		}
		if (getUnitMin()) {
			gc.add(Calendar.MINUTE, amount);
		}
		if (getUnitSec()) {
			gc.add(Calendar.SECOND, amount);
		}
		if (getUnitMiliSec()) {
			gc.add(Calendar.MILLISECOND, amount);
		}
		return rtn;
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#dataFinal()
	 */
	@Override
	public void dataFinal() {
		// TODO 自動生成されたメソッド・スタブ

	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#debugPrint()
	 */
	@Override
	public void debugPrint() {
		// TODO 自動生成されたメソッド・スタブ

	}

	@Override
	public String toString() {
		return "日時連続値生成";
	}

	/**
	 * This method initializes jTextAreaNoEdit
	 * 
	 * @return jdbcacsess.JTextAreaNoEdit
	 */
	private JTextAreaNoEdit getJTextAreaNoEdit() {
		if (jTextAreaNoEdit == null) {
			jTextAreaNoEdit = new JTextAreaNoEdit();
			jTextAreaNoEdit.setText("日付・時刻の連続値データを作成します。"
					+ "テーブル定義データ型と異なる形式で作成しても、JDBCドライバで適切に扱われます。");
			jTextAreaNoEdit.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 10));
		}
		return jTextAreaNoEdit;
	}

	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			GridBagConstraints gridBagConstraints91 = new GridBagConstraints();
			gridBagConstraints91.gridx = 3;
			gridBagConstraints91.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints91.gridy = 1;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 4;
			gridBagConstraints7.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints7.gridy = 2;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 3;
			gridBagConstraints6.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints6.gridy = 2;
			GridBagConstraints gridBagConstraints51 = new GridBagConstraints();
			gridBagConstraints51.gridx = 2;
			gridBagConstraints51.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints51.gridy = 2;
			GridBagConstraints gridBagConstraints41 = new GridBagConstraints();
			gridBagConstraints41.gridx = 1;
			gridBagConstraints41.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints41.gridy = 2;
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.gridx = 4;
			gridBagConstraints31.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints31.gridy = 1;
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.gridx = 2;
			gridBagConstraints21.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints21.gridy = 1;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 1;
			gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints1.gridy = 1;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints5.gridy = 4;
			gridBagConstraints5.ipadx = 0;
			gridBagConstraints5.weightx = 1.0;
			gridBagConstraints5.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints5.gridwidth = 4;
			gridBagConstraints5.gridx = 1;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.ipadx = 0;
			gridBagConstraints4.ipady = 0;
			gridBagConstraints4.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints4.gridy = 4;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints3.gridy = 0;
			gridBagConstraints3.ipadx = 0;
			gridBagConstraints3.weightx = 1.0;
			gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints3.gridwidth = 4;
			gridBagConstraints3.gridx = 1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.ipadx = 0;
			gridBagConstraints2.ipady = 0;
			gridBagConstraints2.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints2.gridy = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.ipadx = 0;
			gridBagConstraints.ipady = 0;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints.gridy = 1;
			jLabel2 = new JLabel();
			jLabel2.setText("増分値");
			jLabel2
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			jLabel1 = new JLabel();
			jLabel1.setText("初期値");
			jLabel1
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			jLabel = new JLabel();
			jLabel.setText("増分単位");
			jLabel
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			jLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			jPanel3 = new JPanel();
			jPanel3.setMinimumSize(new java.awt.Dimension(0, 0));
			jPanel3.setLayout(new GridBagLayout());
			jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(
					null, "初期値と増分値",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION,
					new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12),
					java.awt.Color.black));
			jPanel3.add(jLabel, gridBagConstraints);
			jPanel3.add(getJRadioButtonYear(), gridBagConstraints1);
			jPanel3.add(getJRadioButtonMonth(), gridBagConstraints21);
			jPanel3.add(getJRadioButtonDay(), gridBagConstraints31);
			jPanel3.add(getJRadioButtonWeekOfMonth(), gridBagConstraints91);
			jPanel3.add(getJRadioButtonHour(), gridBagConstraints41);
			jPanel3.add(getJRadioButtonMin(), gridBagConstraints51);
			jPanel3.add(getJRadioButtonSec(), gridBagConstraints6);
			jPanel3.add(getJRadioButtonMiliSec(), gridBagConstraints7);
			jPanel3.add(jLabel1, gridBagConstraints2);
			jPanel3.add(getJTextFieldInitialValue(), gridBagConstraints3);
			jPanel3.add(jLabel2, gridBagConstraints4);
			jPanel3.add(getJTextFieldStepValue(), gridBagConstraints5);
		}
		return jPanel3;
	}

	/**
	 * This method initializes jRadioButton3
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JCheckBox getJCheckBoxMilliSec() {
		if (jCheckBoxMilliSec == null) {
			jCheckBoxMilliSec = new JCheckBox();
			jCheckBoxMilliSec.setText("㍉秒:を扱う");
			jCheckBoxMilliSec.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jCheckBoxMilliSec;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldStepValue() {
		if (jTextFieldStepValue == null) {
			jTextFieldStepValue = new JTextFieldEdit();
			jTextFieldStepValue.setText("1");
			jTextFieldStepValue.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jTextFieldStepValue;
	}

	/**
	 * This method initializes jTextField1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldInitialValue() {
		if (jTextFieldInitialValue == null) {
			jTextFieldInitialValue = new JTextFieldEdit();
			jTextFieldInitialValue.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jTextFieldInitialValue;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
			gridBagConstraints20.gridx = 1;
			gridBagConstraints20.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints20.gridy = 6;
			jLabel5 = new JLabel();
			jLabel5.setText("書式");
			jLabel5
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
			gridBagConstraints18.gridx = 0;
			gridBagConstraints18.gridy = 2;
			jLabel3 = new JLabel();
			jLabel3.setText("　　");
			jLabel3
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			gridBagConstraints17.gridwidth = 5;
			gridBagConstraints17.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints17.gridx = 0;
			gridBagConstraints17.gridy = 1;
			gridBagConstraints17.anchor = java.awt.GridBagConstraints.WEST;
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			gridBagConstraints16.gridx = 1;
			gridBagConstraints16.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints16.gridwidth = 2;
			gridBagConstraints16.gridy = 2;
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.gridx = 0;
			gridBagConstraints15.gridwidth = 4;
			gridBagConstraints15.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints15.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints15.gridy = 4;
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints10.gridx = 2;
			gridBagConstraints10.gridy = 6;
			gridBagConstraints10.gridwidth = 1;
			gridBagConstraints10.weightx = 1.0;
			jPanel1 = new JPanel();
			jPanel1.setLayout(new GridBagLayout());
			jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(
					null, "書式",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION,
					new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12),
					java.awt.Color.black));
			jPanel1.add(getJRadioButtonAuto(), gridBagConstraints17);
			jPanel1.add(getJCheckBoxMilliSec(), gridBagConstraints16);
			jPanel1.add(getJRadioButtonManul(), gridBagConstraints15);
			jPanel1.add(getJTextFieldFormat(), gridBagConstraints10);
			jPanel1.add(jLabel3, gridBagConstraints18);
			jPanel1.add(jLabel5, gridBagConstraints20);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jRadioButton
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonAuto() {
		if (jRadioButtonAuto == null) {
			jRadioButtonAuto = new JRadioButton();
			jRadioButtonAuto.setText("書式は自動設定");
			jRadioButtonAuto.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jRadioButtonAuto.setSelected(true);
		}
		return jRadioButtonAuto;
	}

	/**
	 * This method initializes jRadioButton1
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonManul() {
		if (jRadioButtonManul == null) {
			jRadioButtonManul = new JRadioButton();
			jRadioButtonManul.setText("書式を指定する");
			jRadioButtonManul.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jRadioButtonManul;
	}

	/**
	 * This method initializes jTextField2
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldFormat() {
		if (jTextFieldFormat == null) {
			jTextFieldFormat = new JTextFieldEdit();

			StringWriter writer = new StringWriter();
			try {
				InputStream fs = JPanelDateTime.class
						.getResourceAsStream("dateFormat.html");
				BufferedReader in = null;
				in = new BufferedReader(new InputStreamReader(fs, "UTF-8"));
				String line;
				while ((line = in.readLine()) != null) {
					writer.write(line);
				}
				in.close();
			} catch (UnsupportedEncodingException e1) {
				e1.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}

			jTextFieldFormat.setToolTipText(writer.toString());
			jTextFieldFormat.setFont(new java.awt.Font("Monospaced",
					java.awt.Font.PLAIN, 12));
		}
		return jTextFieldFormat;
	}

	/**
	 * This method initializes jRadioButton
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonYear() {
		if (jRadioButtonYear == null) {
			jRadioButtonYear = new JRadioButton();
			jRadioButtonYear.setText("年");
			jRadioButtonYear.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jRadioButtonYear;
	}

	/**
	 * This method initializes jRadioButton1
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonMonth() {
		if (jRadioButtonMonth == null) {
			jRadioButtonMonth = new JRadioButton();
			jRadioButtonMonth.setText("月");
			jRadioButtonMonth.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jRadioButtonMonth;
	}

	/**
	 * This method initializes jRadioButton2
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonDay() {
		if (jRadioButtonDay == null) {
			jRadioButtonDay = new JRadioButton();
			jRadioButtonDay.setText("日");
			jRadioButtonDay.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jRadioButtonDay;
	}

	/**
	 * This method initializes jRadioButton1
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonWeekOfMonth() {
		if (jRadioButtonWeekOfMonth == null) {
			jRadioButtonWeekOfMonth = new JRadioButton();
			jRadioButtonWeekOfMonth.setText("週");
			jRadioButtonWeekOfMonth.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jRadioButtonWeekOfMonth;
	}

	/**
	 * This method initializes jRadioButton3
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonHour() {
		if (jRadioButtonHour == null) {
			jRadioButtonHour = new JRadioButton();
			jRadioButtonHour.setText("時");
			jRadioButtonHour.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jRadioButtonHour;
	}

	/**
	 * This method initializes jRadioButton4
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonMin() {
		if (jRadioButtonMin == null) {
			jRadioButtonMin = new JRadioButton();
			jRadioButtonMin.setText("分");
			jRadioButtonMin.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jRadioButtonMin;
	}

	/**
	 * This method initializes jRadioButton5
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonSec() {
		if (jRadioButtonSec == null) {
			jRadioButtonSec = new JRadioButton();
			jRadioButtonSec.setText("秒");
			jRadioButtonSec.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jRadioButtonSec;
	}

	/**
	 * This method initializes jRadioButton6
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonMiliSec() {
		if (jRadioButtonMiliSec == null) {
			jRadioButtonMiliSec = new JRadioButton();
			jRadioButtonMiliSec.setText("㍉秒");
			jRadioButtonMiliSec.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jRadioButtonMiliSec;
	}

	/**
	 * @return autoFromat を戻します。
	 */
	public boolean isAutoFromat() {
		return jRadioButtonAuto.isSelected();
	}

	/**
	 * @param autoFromat
	 *            設定する autoFromat。
	 */
	public void setAutoFromat(boolean autoFromat) {
		jRadioButtonAuto.setSelected(autoFromat);
		jRadioButtonManul.setSelected(!autoFromat);
		if (jRadioButtonManul.isSelected()) {
			jTextFieldFormat.setEditable(true);
		} else {
			jTextFieldFormat.setEditable(false);
		}
	}

	public boolean getUseMilliSec() {
		return jCheckBoxMilliSec.isSelected();
	}

	public void setUseMilliSec(boolean selected) {
		jCheckBoxMilliSec.setSelected(selected);
	}

	/**
	 * @return format を戻します。
	 */
	public String getFormat() {
		String format;
		if (isAutoFromat()) {
			format = "yyyy-MM-dd HH:mm:ss";
			if (jCheckBoxMilliSec.isSelected()) {
				format = format + ".SSS";
			}
		} else {
			format = jTextFieldFormat.getText();
		}
		return format;
	}

	/**
	 * @param format
	 *            設定する format。
	 */
	public void setFormat(String format) {
		jTextFieldFormat.setText(format);
	}

	public boolean getUnitMiliSec() {
		return jRadioButtonMiliSec.isSelected();
	}

	public void setUnitMiliSec(boolean selected) {
		jRadioButtonMiliSec.setSelected(selected);
	}

	public boolean getUnitSec() {
		return jRadioButtonSec.isSelected();
	}

	public void setUnitSec(boolean selected) {
		jRadioButtonSec.setSelected(selected);
	}

	public boolean getUnitMin() {
		return jRadioButtonMin.isSelected();
	}

	public void setUnitMin(boolean selected) {
		jRadioButtonMin.setSelected(selected);
	}

	public boolean getUnitHour() {
		return jRadioButtonHour.isSelected();
	}

	public void setUnitHour(boolean selected) {
		jRadioButtonHour.setSelected(selected);
	}

	public boolean getUnitWeekOfMonth() {
		return jRadioButtonWeekOfMonth.isSelected();
	}

	public void setUnitWeekOfMonth(boolean selected) {
		jRadioButtonWeekOfMonth.setSelected(selected);
	}

	public boolean getUnitDay() {
		return jRadioButtonDay.isSelected();
	}

	public void setUnitDay(boolean selected) {
		jRadioButtonDay.setSelected(selected);
	}

	public boolean getUnitMonth() {
		return jRadioButtonMonth.isSelected();
	}

	public void setUnitMonth(boolean selected) {
		jRadioButtonMonth.setSelected(selected);
	}

	public boolean getUnitYear() {
		return jRadioButtonYear.isSelected();
	}

	public void setUnitYear(boolean selected) {
		jRadioButtonYear.setSelected(selected);
	}

	/**
	 * @return initialValue を戻します。
	 */
	public String getInitialValue() {
		return jTextFieldInitialValue.getText();
	}

	/**
	 * @param initialValue
	 *            設定する initialValue。
	 */
	public void setInitialValue(String initialValue) {
		jTextFieldInitialValue.setText(initialValue);
	}

	/**
	 * @return stepValue を戻します。
	 */
	public String getStepValue() {
		return jTextFieldStepValue.getText();
	}

	/**
	 * @param stepValue
	 *            設定する stepValue。
	 */
	public void setStepValue(String stepValue) {
		jTextFieldStepValue.setText(stepValue);
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(new BorderLayout());
			jPanel.add(getJPanel1(), java.awt.BorderLayout.NORTH);
			jPanel.add(getJPanel3(), java.awt.BorderLayout.SOUTH);
		}
		return jPanel;
	}

}
