/**
 * 
 */
package jdbcacsess.createdata;

import java.awt.BorderLayout;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.event.ActionEvent;
import java.io.BufferedReader;
import java.io.StringReader;

import javax.swing.JMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import jdbcacsess.gui.common.ColumnWidth;
import jdbcacsess.gui.common.JPopupMenuCnageUI;
import jdbcacsess.gui.common.JTextAreaNoEdit;
import jdbcacsess.gui.common.PopupKeybordAndMouse;

/**
 * @author sima
 * 
 */
public class JPanelFixList extends JPanelCreateData {

	/**
	 * 
	 */
	private static final long serialVersionUID = 410113009288030941L;

	private JScrollPane jScrollPane = null;

	private JTable jTable = null;

	private FixListTableModel tableModelFixList;

	private JTextAreaNoEdit jTextAreaNoEdit = null;

	private JPopupMenuCnageUI jPopupMenu = null;

	private JMenuItem jMenuItemDelete = null;

	private JMenuItem jMenuItemInsert = null;

	protected int mouseRowIndex;

	/**
	 * This method initializes
	 * 
	 */
	public JPanelFixList() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		this.setLayout(new BorderLayout());
		this.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
		this.add(getJTextAreaNoEdit(), java.awt.BorderLayout.NORTH);
		tableModelFixList = new FixListTableModel();
		jTable.setModel(tableModelFixList);
		new PopupKeybordAndMouse(jTable, getJPopupMenu());
		ColumnWidth.setHeaderWidth(jTable, 1);
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#debugPrint()
	 */
	@Override
	public void debugPrint() {
		// TODO 自動生成されたメソッド・スタブ

	}

	@Override
	public String toString() {
		return "固定値リスト";
	}

	@Override
	public JPanelCreateData copy() {
		JPanelFixList jps = (JPanelFixList) super.copy();
		return jps;
	}

	/**
	 * @param e
	 */
	protected void actionPerformedPaste(ActionEvent e) {
		// クリップボードオブジェクトを得る
		Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
		// クリップボードから取り出す
		Transferable trans = clipboard.getContents(null);
		String str = null;
		try {
			str = (String) trans.getTransferData(DataFlavor.stringFlavor);
			BufferedReader bur = new BufferedReader(new StringReader(str));
			String s;
			int line = 0;
			while ((s = bur.readLine()) != null) {
				tableModelFixList.insert(mouseRowIndex + line, s);
				++line;
			}
			bur.close();
		} catch (Exception ex) {
		}
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTable());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private JTable getJTable() {
		if (jTable == null) {
			jTable = new JTable();
			jTable.getTableHeader().setReorderingAllowed(false); // 列の入れ替えを禁止
			jTable.setRowSelectionAllowed(false);
			jTable
					.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
			jTable.addMouseListener(new java.awt.event.MouseAdapter() {
				@Override
				public void mousePressed(java.awt.event.MouseEvent e) {
					mouseRowIndex = jTable.rowAtPoint(e.getPoint());
				}

				@Override
				public void mouseReleased(java.awt.event.MouseEvent e) {
					mouseRowIndex = jTable.rowAtPoint(e.getPoint());
				}
			});
		}
		return jTable;
	}

	/**
	 * This method initializes jTextArea
	 * 
	 * @return javax.swing.JTextArea
	 */
	private JTextAreaNoEdit getJTextAreaNoEdit() {
		if (jTextAreaNoEdit == null) {
			jTextAreaNoEdit = new JTextAreaNoEdit();
			jTextAreaNoEdit.setText("順番のとおりにデータが作成されます。最後に到達したら先頭に戻ります。"
					+ "改行区切りデータをクリップボード経由で貼り付け出来ます。");
			jTextAreaNoEdit.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 10));
		}
		return jTextAreaNoEdit;
	}

	/**
	 * This method initializes jPopupMenu
	 * 
	 * @return javax.swing.JPopupMenu
	 */
	private JPopupMenuCnageUI getJPopupMenu() {
		if (jPopupMenu == null) {
			jPopupMenu = new JPopupMenuCnageUI();
			jPopupMenu.add(getJMenuItemPaste());
			jPopupMenu.addSeparator();
			jPopupMenu.add(getJMenuItemDelete());
			jPopupMenu.add(getJMenuItemInsert());
		}
		return jPopupMenu;
	}

	/**
	 * This method initializes jMenuItem3
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemDelete() {
		if (jMenuItemDelete == null) {
			jMenuItemDelete = new JMenuItem();
			jMenuItemDelete.setText("行削除");
			jMenuItemDelete
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							tableModelFixList.delete(mouseRowIndex);
						}
					});
		}
		return jMenuItemDelete;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemInsert() {
		if (jMenuItemInsert == null) {
			jMenuItemInsert = new JMenuItem();
			jMenuItemInsert.setText("新規行挿入");
			jMenuItemInsert
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							tableModelFixList.insert(mouseRowIndex);
						}
					});
		}
		return jMenuItemInsert;
	}

	private int counter;

	private JMenuItem jMenuItemPaste = null;

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#dataInitial()
	 */
	@Override
	public void dataInitial() {
		counter = -1;
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#dataNext()
	 */
	@Override
	public String dataNext() {
		if (tableModelFixList.getFixList().isEmpty()) {
			return null;
		}
		counter++;
		if (tableModelFixList.getFixList().size() <= counter) {
			counter = 0;
		}
		return tableModelFixList.getFixList().get(counter);
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#dataFinal()
	 */
	@Override
	public void dataFinal() {
	}

	/**
	 * @return tableModelFixList を戻します。
	 */
	public FixListTableModel getTableModelFixList() {
		return tableModelFixList;
	}

	/**
	 * @param tableModelFixList
	 *            設定する tableModelFixList。
	 */
	public void setTableModelFixList(FixListTableModel tableModelFixList) {
		this.tableModelFixList = tableModelFixList;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemPaste() {
		if (jMenuItemPaste == null) {
			jMenuItemPaste = new JMenuItem();
			jMenuItemPaste.setText("貼り付け");
			jMenuItemPaste
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedPaste(e);
						}
					});
		}
		return jMenuItemPaste;
	}

}
