package jdbcacsess.createdata;

import java.awt.BorderLayout;
import java.io.IOException;
import java.util.ArrayList;
import java.util.TreeMap;

import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JScrollPane;

import jdbcacsess.sql.QueryExecuteListener;

public class JPanelSelectResult extends JPanelCreateData implements QueryExecuteListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private JList jList = null;

	private DefaultListModel listModel;

	private ArrayList<Object> rowData;

	public JPanelSelectResult() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		this.setLayout(new BorderLayout());
		this.add(getJScrollPane(), BorderLayout.CENTER);
		listModel = new DefaultListModel(); // @jve:decl-index=0:
		jList.setModel(listModel);
	}

	TreeMap<Integer, String> columnMap; // @jve:decl-index=0:

	private JScrollPane jScrollPane = null;

	public void fireDataUpdate() {
		listModel.clear();
		for (String item : columnMap.values()) {
			listModel.addElement(item);
		}
		jList.setSelectedIndex(0);

		if (columnMap.size() == 0) {
			setVisible(false);
		} else {
			setVisible(true);
		}
	}

	@Override
	public String toString() {
		return "SELECT結果";
	}

	@Override
	public void dataInitial() {
	}

	/*
	 * 最後に結果通知を受けた内容を返します
	 */
	@Override
	public Object dataNext() {
		if (rowData == null) {
			return "未検索";
		}
		return rowData.get(getSelectIndex());
	}

	@Override
	public void dataFinal() {
	}

	@Override
	public void debugPrint() {
	}

	/**
	 * This method initializes jList
	 * 
	 * @return javax.swing.JList
	 */
	private JList getJList() {
		if (jList == null) {
			jList = new JList();
		}
		return jList;
	}

	public TreeMap<Integer, String> getColumnMap() {
		return columnMap;
	}

	public void setColumnMap(TreeMap<Integer, String> columnMap) {
		this.columnMap = columnMap;
		fireDataUpdate();
	}

	// columnMap => selectIndexというソースに書かれた順にxml化され、setterが呼ばれるようだ。
	// つまり、このメソッドをgetColumnMapの前に記述すると動かなくなるはず。
	public Integer getSelectIndex() {
		return jList.getSelectedIndex();
	}

	public void setSelectIndex(Integer selectIndex) {
		jList.setSelectedIndex(selectIndex);
	}

	@Override
	public void setResultDetail(ArrayList<Object> rowData) throws IOException {
		this.rowData = rowData;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJList());
		}
		return jScrollPane;
	}

}
