/**
 * 
 */
package jdbcacsess.createdata;

import java.awt.BorderLayout;

import javax.swing.DefaultCellEditor;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import jdbcacsess.createdata.chararctor.JComboboxCharType;
import jdbcacsess.gui.common.ColumnWidth;
import jdbcacsess.gui.common.JPopupMenuCnageUI;
import jdbcacsess.gui.common.JTextAreaNoEdit;
import jdbcacsess.gui.common.PopupKeybordAndMouse;
import jdbcacsess.sql.SchemaTableColumnName;

/**
 * @author sima
 * 
 */
public class JPanelSequence extends JPanelCreateData {
	/**
	 * 
	 */
	private static final long serialVersionUID = 7686216994778990116L;

	private JTextAreaNoEdit jTextArea = null;

	private JScrollPane jScrollPane = null;

	private JTable jTable = null;

	private JComboboxCharType jComboBoxCharType = null;

	private SequenceParmTableModel sequenceParmTableModel;

	private JPopupMenuCnageUI jPopupMenu = null;

	private JMenuItem jMenuItemDelete = null;

	private JMenuItem jMenuItemInsert = null;

	protected int mouseRowIndex;

	/**
	 * This is the default constructor
	 */
	public JPanelSequence() {
		super();
		sequenceParmTableModel = new SequenceParmTableModel();
		initialize();
	}

	/**
	 * @param stcn
	 */
	public JPanelSequence(SchemaTableColumnName stcn) {
		super();
		sequenceParmTableModel = new SequenceParmTableModel(stcn);
		initialize();
	}

	/**
	 * @return sequenceParmTableModel を戻します。
	 */
	public SequenceParmTableModel getSequenceParmTableModel() {
		return sequenceParmTableModel;
	}

	/**
	 * @param sequenceParmTableModel
	 *            設定する sequenceParmTableModel。
	 */
	public void setSequenceParmTableModel(
			SequenceParmTableModel sequenceParmTableModel) {
		this.sequenceParmTableModel = sequenceParmTableModel;
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "連続値生成";
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#dataInitial()
	 */
	@Override
	public void dataInitial() {
		sequenceParmTableModel.resetItemData();
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#dataNext()
	 */
	@Override
	public String dataNext() {
		return sequenceParmTableModel.getNextItemData();
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#dataFinal()
	 */
	@Override
	public void dataFinal() {

	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#copy()
	 */
	@Override
	public JPanelCreateData copy() {
		JPanelSequence jps = (JPanelSequence) super.copy();
		return jps;
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.createdata.JPanelCreateData#debugPrint()
	 */
	@Override
	public void debugPrint() {
		System.out.println(hashCode() + "#JPanelSequence" + ":"
				+ sequenceParmTableModel);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new BorderLayout());
		this.setOpaque(true);
		this.add(getJTextArea(), java.awt.BorderLayout.NORTH);
		this.add(getJScrollPane(), java.awt.BorderLayout.CENTER);

		jTable.setModel(sequenceParmTableModel);
		jTable.getColumnModel().getColumn(1).setCellEditor(
				new DefaultCellEditor(getJComboBoxCharType()));
		new PopupKeybordAndMouse(jTable, getJPopupMenu());
		ColumnWidth.setHeaderWidth(jTable, -1);
	}

	/**
	 * This method initializes jTextArea
	 * 
	 * @return javax.swing.JTextArea
	 */
	private JTextAreaNoEdit getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextAreaNoEdit();
			jTextArea.setText("アルファベット順・数値順・あいうえお順の連続値でデータを作成します。"
					+ "また、複数の文字種で１カラムを構成する事が出来ます。");
			jTextArea.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
					10));
		}
		return jTextArea;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTable());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private JTable getJTable() {
		if (jTable == null) {
			jTable = new JTable();
			jTable.getTableHeader().setReorderingAllowed(false); // 列の入れ替えを禁止
			jTable.setRowSelectionAllowed(false);
			jTable
					.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
			jTable.addMouseListener(new java.awt.event.MouseAdapter() {
				@Override
				public void mousePressed(java.awt.event.MouseEvent e) {
					mouseRowIndex = jTable.rowAtPoint(e.getPoint());
				}

				@Override
				public void mouseReleased(java.awt.event.MouseEvent e) {
					mouseRowIndex = jTable.rowAtPoint(e.getPoint());
				}
			});
		}
		return jTable;
	}

	/**
	 * This method initializes jComboBoxCharType
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboboxCharType getJComboBoxCharType() {
		if (jComboBoxCharType == null) {
			jComboBoxCharType = new JComboboxCharType();
		}
		return jComboBoxCharType;
	}

	/**
	 * This method initializes jPopupMenu
	 * 
	 * @return javax.swing.JPopupMenu
	 */
	private JPopupMenuCnageUI getJPopupMenu() {
		if (jPopupMenu == null) {
			jPopupMenu = new JPopupMenuCnageUI();
			jPopupMenu.add(getJMenuItemDelete());
			jPopupMenu.add(getJMenuItemInsert());
		}
		return jPopupMenu;
	}

	/**
	 * This method initializes jMenuItem3
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemDelete() {
		if (jMenuItemDelete == null) {
			jMenuItemDelete = new JMenuItem();
			jMenuItemDelete.setText("行削除");
			jMenuItemDelete
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							sequenceParmTableModel.delete(mouseRowIndex);
						}
					});
		}
		return jMenuItemDelete;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemInsert() {
		if (jMenuItemInsert == null) {
			jMenuItemInsert = new JMenuItem();
			jMenuItemInsert.setText("新規行挿入");
			jMenuItemInsert
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							sequenceParmTableModel.insert(mouseRowIndex);
						}
					});
		}
		return jMenuItemInsert;
	}
}
