/**
 * 
 */
package jdbcacsess.createdata.chararctor;

import java.io.Serializable;
import java.util.ArrayList;

/**
 * @author sima
 * 
 */

public abstract class CharType implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -7808642928432158781L;

	public abstract String[] getStrings();

	
	/**
	 * １０進値を文字列表現に変換します。桁数分左端に文字集合の最小値を埋め込みます。 桁数を超えた場合の動作は保証されません。
	 * 
	 * @param index
	 * @param keta
	 * @return
	 */
	public String getStringAtIndex(long index, int keta) {
		StringBuilder sb = new StringBuilder();
		if (getStrings().length != 0) {
			sb = atIndex(index, sb);
		}
		return fullKeta(keta, sb.reverse().toString());
	}

	/**
	 * @param idx
	 * @param sb
	 * @return
	 */
	private StringBuilder atIndex(long idx, StringBuilder sb) {
		if (idx < 0) {
			idx = idx * -1;
		}
		long len = getStrings().length;
		int amari = (int) (idx % len);
		long shou = idx / len;

		sb.append(getStrings()[amari]);
		if (shou > 0) {
			return atIndex(shou, sb);
		} else {
			return sb;
		}
	}

	/**
	 * 桁数の最大値に対する１０進値を返却します。算出方法は、桁数＾文字集合数－１です。
	 * 
	 * @param keta
	 *            桁数
	 * @return 最大値の１０進値
	 */
	public long getMaxIndex(int keta) {
		double x = getStrings().length;
		double y = keta;
		long rtn = ((long) Math.pow(x, y)) - 1;
		return rtn;
	}

	/**
	 * 文字列の各桁を文字集合の順番に従って１０進数値に変換します。
	 * 
	 * @param str
	 *            文字列
	 * @return 文字列を数値化した１０進値
	 */
	public long getIndexOfString(String str) {
		int rtn = 0;
		ArrayList<Integer> list = new ArrayList<Integer>();
		for (int i = str.length() - 1; i >= 0; i--) {
			for (int j = 0; j < getStrings().length; j++) {
				if (str.substring(i, i + 1).equals(getStrings()[j])) {
					list.add(j);
					break;
				}
			}
		}
		for (int i = 0; i < list.size(); i++) {
			double x = getStrings().length;
			double y = i;
			rtn = rtn + list.get(i) * ((int) Math.pow(x, y));
		}
		return rtn;
	}

	/**
	 * 桁数に不足している文字を左端に埋め込みます。埋め込む文字は、継承先クラスで保持する０番目の文字です。
	 * 
	 * @param keta
	 *            桁数
	 * @param initialValue
	 *            初期値
	 * @return 桁合わせした文字列
	 */
	public String fullKeta(int keta, String str) {
		if (str == null) {
			return str;
		}
		if (getStrings().length < 1) {
			return str;
		}
		StringBuffer atama = new StringBuffer();
		for (int i = 0; i < keta - str.length(); i++) {
			atama.append( getStrings()[0] );
		}
		return atama.append(str).toString();
	}

	@Override
	public boolean equals(Object o) {
		if (o == null) {
			return false;
		}
		if (o.toString().equals(toString())) {
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		return toString().hashCode();
	}
}
