/**
 * 
 */
package jdbcacsess.csv;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.Reader;
import java.io.StringWriter;

/**
 * @author sima
 * 
 */
public class CsvBufferedReader extends BufferedReader {

	/**
	 * @param in
	 */
	public CsvBufferedReader(Reader in) {
		super(in);
		// TODO 自動生成されたコンストラクター・スタブ
	}

	private static final int CR = '\r';

	private static final int LF = '\n';

	/**
	 * １行分を読込みます。 但し、ダブルクォートで括られた時の改行コードを文字列として扱います。 ファイル終端の場合はNullを返します
	 * 
	 * @return １行の文字列
	 * @throws IOException
	 */
	public String readCsvLine() throws IOException {
		StringWriter sw = new StringWriter();
		boolean data = false;

		int c;
		boolean quote = false;
		boolean quoteInquote = false;
		while ((c = read()) != -1) {
			data = true;

			if (c == '"') {
				quote = true;
				quoteInquote = !quoteInquote;
			} else {
				if (quote && !quoteInquote) {
					quote = false;
					quoteInquote = false;
				}
			}

			if (!quote) {
				if (c == LF) {
					break;
				}
				if (c == CR) {
					mark(2);
					int tmp = read();
					if (tmp != -1 && tmp != LF) {
						reset();
					}
					break;
				}
			}
			sw.write(c);
			// System.out.print("[");
			// System.out.write(c);
			// System.out.println("]"+quote+":"+quoteInquote);
		}

		if (c == -1 && !data) {
			return null;

		}
		return sw.toString();
	}

}
