/**
 * 
 */
package jdbcacsess.csv;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Vector;

import javax.swing.JDialog;
import javax.swing.ProgressMonitorInputStream;

import jdbcacsess.JdbcacsessException;
import jdbcacsess.gui.common.JDialogMessage;

/**
 * @author sima
 * 
 */
public class CsvInput {

	protected CsvInfo csvInfo;

	protected CsvBufferedReader in;

	protected int inputCnt;

	/**
	 * @param info
	 * 
	 */
	public CsvInput(CsvInfo info) {
		csvInfo = info;
	}

	/**
	 * 入力ファイルのOPEN
	 * 
	 * @throws JdbcacsessException
	 */
	protected void openInputFile() throws JdbcacsessException {
		try {
			InputStream fos = new ProgressMonitorInputStream(new JDialog(), csvInfo.getPropTableName()
					.getCompleteTableName()
					+ "  import... ", new FileInputStream(csvInfo.getFileName()));
			in = new CsvBufferedReader(new InputStreamReader(fos, csvInfo.getEncoding().getValue()));
		} catch (FileNotFoundException e) {
			JDialogMessage.errorDialog(e);
			throw new JdbcacsessException(e);
		}
	}

	/**
	 * 入力ファイルのCLOSE
	 */
	protected void closeInputFile() {
		if (in == null) {
			return;
		}
		try {
			in.close();
		} catch (IOException e) {
			JDialogMessage.errorDialog(e);
		}
	}

	/**
	 * レコードの入力
	 * 
	 * @throws JdbcacsessException
	 */
	protected Vector<String> readFile() throws IOException {
		Vector<String> v = new Vector<String>();

		String rec = null;
		rec = in.readCsvLine();
		if (rec == null) {
			return null;
		}
		inputCnt++;
		CSVTokenizer csvt = new CSVTokenizer(rec);
		csvt.setToken(csvInfo.getColumnDelimiter().getValue());
		while (csvt.hasMoreTokens()) {
			v.add(csvt.nextToken());
		}
		return v;
	}
}
