package jdbcacsess.dbconnect;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import jdbcacsess.JTextFieldEdit;
import jdbcacsess.JdbcacsessException;
import jdbcacsess.gui.common.ComponentProperty;
import jdbcacsess.gui.common.JDialogMessage;
import jdbcacsess.gui.common.JPopupMenuEdit;
import jdbcacsess.gui.common.JTextAreaNoEdit;
import jdbcacsess.sql.SqlExec;

import org.xml.sax.SAXException;

public class JDialogConnect extends JDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1752836929960335893L;

	private DefaultComboBoxModel modelDBMS = new DefaultComboBoxModel();

	private DefaultComboBoxModel modelProfName;

	private ConnectInfo connectInfo;

	private JPanel jContentPane = null;

	private JButton jButtonConnect = null;

	private JButton jButtonCancel = null;

	private JButton jButtonDelete = null;

	private JPanel jPanel = null;

	private JLabel jLabel9 = null;

	private JComboBox jComboBoxProfName = null;

	private JPanel jPanel6 = null;

	private JPanel jPanel7 = null;

	private JLabel jLabel7 = null;

	private JLabel jLabel12 = null;

	private JLabel jLabel13 = null;

	private JLabel jLabel14 = null;

	private JLabel jLabel15 = null;

	private JLabel jLabel16 = null;

	private JComboBox jComboBoxDBMS = null;

	private JTextFieldEdit jTextFieldHostName = null;

	private JTextFieldEdit jTextFieldPortNumber = null;

	private JTextFieldEdit jTextFieldDataBaseName = null;

	private JTextFieldEdit jTextFieldUserID = null;

	private JPasswordField jPasswordField = null;

	private JPanel jPanel8 = null;

	private JPanel jPanel1 = null;

	private JTextAreaNoEdit jTextAreaURL = null;

	private JLabel jLabel1 = null;

	private JTextFieldEdit jTextFieldOptionString = null;

	private JLabel jLabelClassName = null;

	private JTextFieldEdit jTextFieldClassName = null;

	private JLabel jLabel2 = null;

	private JLabel jLabel3 = null;

	private JTextArea jTextAreaDriverPath = null;

	private JButton jButton = null;

	private JTextAreaNoEdit jTextAreaNoEdit = null;

	private JCheckBox jCheckBoxSavePassword = null;

	private JScrollPane jScrollPane;  //  @jve:decl-index=0:

	private boolean ansOK = false;
	
	public JDialogConnect() throws JdbcacsessException, SAXException, IOException {
		initialize();
	}

	// コンポーネントの初期化
	private void initialize() throws JdbcacsessException, SAXException, IOException {
		setAlwaysOnTop(true);
		setModal(true);
		this.setContentPane(getJContentPane());
		this.setTitle("DB接続");

		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		new ComponentProperty().restoreWindowPosition(this, 550, 450);
		addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent e) {
				dialogClosing();
			}
		});

		// DBMSコンボボックスのデータモデル作成
		for (String e : new DBMSinfo().getDBMSList()) {
			modelDBMS.addElement(e);
		}
		modelDBMS.setSelectedItem(null);

		// DBMSコンボボックスのデータモデル設定
		jComboBoxDBMS.setModel(modelDBMS);

		connectInfo = new ConnectInfo();

		// PrfoNameコンボボックスのデータモデル作成
		Vector<String> profNames = new Vector<String>();
		for (ConnectInfo ci : connectInfo.getInfoList()) {
			profNames.add(ci.getKeyValue());
		}
		modelProfName = new DefaultComboBoxModel(profNames);

		// ユーザ設定情報名コンボボックスのデータモデル設定
		jComboBoxProfName.setModel(modelProfName);

		this.addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent e) {
				actionPerformedCancel();
			}
		});

		// コンボボックスの初期選択と情報初期表示
		connectInfo.currentDataLoad();

		setConnectInfo(connectInfo);

		new JPopupMenuEdit(jTextAreaDriverPath);

		getRootPane().setDefaultButton(jButtonConnect);
		setVisible(true);
	}

	public void dialogClosing() {
		new ComponentProperty().storeWindowPosition(this);
	}

	/**
	 * 現在編集中の内容でurlを表示する。
	 */
	private void displayEdittingUrl() {
		jTextAreaURL.setText(getConnectInfo().getUrl());
	}

	/**
	 * 画面の各値を取得する
	 * 
	 * @return 画面表示中の接続情報
	 */
	private ConnectInfo getConnectInfo() {
		ConnectInfo ci = new ConnectInfo();
		ci.setProfName((String) jComboBoxProfName.getSelectedItem());
		ci.setDBMS((String) jComboBoxDBMS.getSelectedItem());
		ci.setHostName(jTextFieldHostName.getText());
		ci.setPortNumber(jTextFieldPortNumber.getText());
		ci.setDataBaseName(jTextFieldDataBaseName.getText());
		ci.setOptionString(jTextFieldOptionString.getText());
		ci.setUserID(jTextFieldUserID.getText());
		ci.setPassword(jCheckBoxSavePassword.isSelected() ? new String(
				jPasswordField.getPassword()) : "");
		ci.setDriverPath(jTextAreaDriverPath.getText());
		ci.setClassPathTextInput(jTextFieldClassName.getText());
		ci.setSavePassword(jCheckBoxSavePassword.isSelected() ? "" : "no");
		return ci;
	}

	/**
	 * 接続情報を元に画面表示する
	 */
	private void setConnectInfo(ConnectInfo ci) {
		jComboBoxProfName.setSelectedItem(ci.getProfName());

		jTextFieldHostName.setText(ci.getHostName());
		jTextFieldPortNumber.setText(ci.getPortNumber());
		jTextFieldDataBaseName.setText(ci.getDataBaseName());
		jTextFieldOptionString.setText(ci.getOptionString());
		jTextFieldUserID.setText(ci.getUserID());
		jPasswordField.setText(ci.getPassword());
		//よくわからないが、一度FALSEし、TRUEにすると、最初から編集できる。
		jPasswordField.setEditable(false);	jPasswordField.setEditable(true);
		jTextAreaDriverPath.setText(ci.getDriverPath());
		jContentPane.revalidate();
		jTextFieldClassName.setText(ci.getClassPathTextInput());

		// コンボボックスはインスタンスデータから探す
		jComboBoxDBMS.setSelectedItem(modelDBMS.getElementAt(modelDBMS
				.getIndexOf(ci.getDBMS())));

		jCheckBoxSavePassword
				.setSelected(ci.getSavePassword().equals("no") ? false : true);
	}

	/**
	 * 接続ボタンが押されたので、画面の接続情報を設定する
	 * @throws JdbcacsessException 
	 */
	private void actionPerformedConnect(ActionEvent e) throws JdbcacsessException {
		connectInfo = getConnectInfo();

		connectInfo.currentDataSave();

		try {
			URL[] driverUrlPath = null;
			if (!jTextAreaDriverPath.getText().equals("")) {
				StringTokenizer st = new StringTokenizer(jTextAreaDriverPath
						.getText(), System.getProperty("path.separator"));
				ArrayList<URL> jarUrlList = new ArrayList<URL>();
				while (st.hasMoreTokens()) {
					if (st.equals("")) {
						continue;
					}
					File file = new File(st.nextToken());
					jarUrlList.add(file.toURI().toURL());

				}
				driverUrlPath = jarUrlList.toArray(new URL[jarUrlList.size()]);
			}
			// 画面情報とjdbcのURLを渡し、conncect処理
			SqlExec.connect(connectInfo.getUserID(),
					new String(jPasswordField.getPassword()), 
					connectInfo.getUrl(), 
					("Free Format".equals(connectInfo.getDBMS()) ? connectInfo.getClassPathTextInput() : connectInfo.getClassPath()),
					driverUrlPath);
		} catch (Exception ex) {
			JDialogMessage.errorDialog(ex);
			return;
		}

		ansOK = true;
		dialogClosing();
		dispose();
	}

	public boolean isAnsOK() {
		return ansOK;
	}

	/**
	 * 取り消しが押されたので、画面の接続情報クリアし終了
	 */
	private void actionPerformedCancel() {
		connectInfo.setProfName("");
		connectInfo.setDBMS("");
		connectInfo.setHostName("");
		connectInfo.setPortNumber("");
		connectInfo.setDataBaseName("");
		connectInfo.setOptionString("");
		connectInfo.setUserID("");
		connectInfo.setPassword("");
		connectInfo.setClassPathTextInput("");
		dialogClosing();
	}

	private void actionPerformedDelete(ActionEvent e) throws JdbcacsessException {
		String profName = (String) modelProfName.getSelectedItem();
		if (connectInfo.keyDataLoad(profName)) {
			connectInfo.removeParameter();
		}
		modelProfName.removeElement(profName);
	}

	private void actionPerformedProfName_itemStateChanged(ItemEvent e) {
		if (e.getStateChange() == ItemEvent.DESELECTED) {
			return;
		}
		String profName = (String) modelProfName.getSelectedItem();
		if (connectInfo.keyDataLoad(profName)) {
			// 見つかった時はconnectInfoに設定ファイルの内容がセットされる
			setConnectInfo(connectInfo);
		}
	}

	private void actionPerformedFileChoice(ActionEvent e) {
		File file = new File(jTextAreaDriverPath.getText());
		JFileChooser jFileChooser = new JFileChooser(file.getAbsolutePath());
		jFileChooser.setMultiSelectionEnabled(false);

		int ans = jFileChooser.showOpenDialog(this);
		if (ans == JFileChooser.APPROVE_OPTION) {
			String driverPath = jTextAreaDriverPath.getText();
			if (driverPath.equals("")) {
				jTextAreaDriverPath.setText(jFileChooser.getSelectedFile()
						.getPath());
			} else {
				jTextAreaDriverPath.setText(driverPath
						+ System.getProperty("path.separator")
						+ jFileChooser.getSelectedFile().getPath());
			}
			jContentPane.revalidate();
		}
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel6(), java.awt.BorderLayout.NORTH);
			jContentPane.add(getJPanel8(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getJPanel(), java.awt.BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonConnect() {
		if (jButtonConnect == null) {
			jButtonConnect = new JButton();
			jButtonConnect.setText("接続");
			jButtonConnect
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							try {
								actionPerformedConnect(e);
							} catch (JdbcacsessException e1) {
								JDialogMessage.errorDialog(e1);
							}
						}
					});
		}
		return jButtonConnect;
	}

	/**
	 * This method initializes jButton2
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonCancel() {
		if (jButtonCancel == null) {
			jButtonCancel = new JButton();
			jButtonCancel.setText("取消");
			jButtonCancel
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedCancel();
							dispose();
						}
					});
		}
		return jButtonCancel;
	}

	/**
	 * This method initializes jButton3
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonDelete() {
		if (jButtonDelete == null) {
			jButtonDelete = new JButton();
			jButtonDelete.setText("設定削除");
			jButtonDelete
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							try {
								actionPerformedDelete(e);
							} catch (JdbcacsessException e1) {
								JDialogMessage.errorDialog(e1);
							}
						}
					});
		}
		return jButtonDelete;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jLabel9 = new JLabel();
			jLabel9.setText("（接続押下で自動保存）");
			jLabel9
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			jPanel = new JPanel();
			jPanel.add(getJButtonConnect(), null);
			jPanel.add(jLabel9, null);
			jPanel.add(getJButtonCancel(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes jComboBox
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBoxProfName() {
		if (jComboBoxProfName == null) {
			jComboBoxProfName = new JComboBox();
			jComboBoxProfName.setPreferredSize(new java.awt.Dimension(150, 25));
			jComboBoxProfName.setFont(new java.awt.Font("Monospaced",
					java.awt.Font.PLAIN, 12));
			jComboBoxProfName
					.addItemListener(new java.awt.event.ItemListener() {
						public void itemStateChanged(ItemEvent e) {
							actionPerformedProfName_itemStateChanged(e);
						}
					});
			jComboBoxProfName.setEditable(true);
		}
		return jComboBoxProfName;
	}

	/**
	 * This method initializes jPanel6
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel6() {
		if (jPanel6 == null) {
			jLabel2 = new JLabel();
			jLabel2.setText("接続名称");
			jLabel2
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			jPanel6 = new JPanel();
			jPanel6.add(jLabel2, null);
			jPanel6.add(getJComboBoxProfName(), null);
			jPanel6.add(getJButtonDelete(), null);
		}
		return jPanel6;
	}

	/**
	 * This method initializes jPanel7
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel7() {
		if (jPanel7 == null) {
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.gridx = 5;
			gridBagConstraints13.anchor = java.awt.GridBagConstraints.NORTHWEST;
			gridBagConstraints13.insets = new java.awt.Insets(0, 0, 5, 0);
			gridBagConstraints13.gridwidth = 2;
			gridBagConstraints13.gridy = 5;
			GridBagConstraints gridBagConstraints26 = new GridBagConstraints();
			gridBagConstraints26.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints26.gridy = 7;
			gridBagConstraints26.weightx = 1.0;
			gridBagConstraints26.weighty = 1.0;
			gridBagConstraints26.gridwidth = 6;
			gridBagConstraints26.insets = new java.awt.Insets(0, 0, 5, 0);
			gridBagConstraints26.gridx = 1;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 6;
			gridBagConstraints12.insets = new java.awt.Insets(5, 0, 0, 0);
			gridBagConstraints12.gridy = 6;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.fill = GridBagConstraints.BOTH;
			gridBagConstraints7.gridy = 6;
			gridBagConstraints7.weightx = 1.0;
			gridBagConstraints7.gridwidth = 4;
			gridBagConstraints7.insets = new java.awt.Insets(5, 3, 0, 5);
			gridBagConstraints7.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints7.gridx = 2;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 1;
			gridBagConstraints5.insets = new java.awt.Insets(5, 5, 0, 0);
			gridBagConstraints5.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints5.gridy = 6;
			jLabel3 = new JLabel();
			jLabel3.setText("ドライバファイル名");
			jLabel3
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints2.gridy = 9;
			gridBagConstraints2.weightx = 1.0;
			gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints2.gridwidth = 4;
			gridBagConstraints2.insets = new java.awt.Insets(5, 3, 0, 5);
			gridBagConstraints2.gridx = 2;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 1;
			gridBagConstraints11.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints11.insets = new java.awt.Insets(5, 5, 0, 0);
			gridBagConstraints11.gridy = 9;
			jLabelClassName = new JLabel();
			jLabelClassName.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jLabelClassName.setText("ドライバクラス名");
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints1.gridy = 3;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.gridwidth = 5;
			gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints1.insets = new java.awt.Insets(5, 3, 5, 5);
			gridBagConstraints1.gridx = 2;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 1;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 0);
			gridBagConstraints.gridy = 3;
			jLabel1 = new JLabel();
			jLabel1.setText("接続URL付加文字列");
			jLabel1
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			GridBagConstraints gridBagConstraints25 = new GridBagConstraints();
			gridBagConstraints25.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints25.gridy = 4;
			gridBagConstraints25.weightx = 1.0;
			gridBagConstraints25.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints25.insets = new java.awt.Insets(5, 3, 0, 5);
			gridBagConstraints25.gridx = 5;
			GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
			gridBagConstraints24.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints24.gridy = 4;
			gridBagConstraints24.weightx = 1.0;
			gridBagConstraints24.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints24.insets = new java.awt.Insets(5, 3, 0, 0);
			gridBagConstraints24.gridx = 2;
			GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
			gridBagConstraints23.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints23.gridy = 2;
			gridBagConstraints23.weightx = 1.0;
			gridBagConstraints23.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints23.insets = new java.awt.Insets(5, 3, 0, 0);
			gridBagConstraints23.gridwidth = 3;
			gridBagConstraints23.gridx = 2;
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints22.gridy = 1;
			gridBagConstraints22.weightx = 1.0;
			gridBagConstraints22.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints22.insets = new java.awt.Insets(5, 3, 0, 5);
			gridBagConstraints22.gridx = 5;
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints21.gridy = 1;
			gridBagConstraints21.weightx = 1.0;
			gridBagConstraints21.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints21.insets = new java.awt.Insets(5, 3, 0, 0);
			gridBagConstraints21.gridx = 2;
			GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
			gridBagConstraints20.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints20.gridy = 0;
			gridBagConstraints20.weightx = 1.0;
			gridBagConstraints20.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints20.gridwidth = 3;
			gridBagConstraints20.insets = new java.awt.Insets(5, 3, 5, 0);
			gridBagConstraints20.gridx = 2;
			GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
			gridBagConstraints19.gridx = 4;
			gridBagConstraints19.insets = new java.awt.Insets(5, 5, 0, 0);
			gridBagConstraints19.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints19.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints19.gridy = 4;
			jLabel16 = new JLabel();
			jLabel16.setText("パスワード");
			jLabel16.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
					12));
			GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
			gridBagConstraints18.gridx = 1;
			gridBagConstraints18.insets = new java.awt.Insets(5, 5, 0, 0);
			gridBagConstraints18.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints18.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints18.gridy = 4;
			jLabel15 = new JLabel();
			jLabel15.setText("ユーザID");
			jLabel15.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
					12));
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			gridBagConstraints17.gridx = 1;
			gridBagConstraints17.insets = new java.awt.Insets(5, 5, 0, 0);
			gridBagConstraints17.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints17.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints17.gridy = 2;
			jLabel14 = new JLabel();
			jLabel14.setText("データベース名");
			jLabel14.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
					12));
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			gridBagConstraints16.gridx = 4;
			gridBagConstraints16.insets = new java.awt.Insets(5, 5, 0, 0);
			gridBagConstraints16.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints16.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints16.gridy = 1;
			jLabel13 = new JLabel();
			jLabel13.setText("ポート番号");
			jLabel13.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
					12));
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.gridx = 1;
			gridBagConstraints15.insets = new java.awt.Insets(5, 5, 0, 0);
			gridBagConstraints15.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints15.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints15.gridy = 1;
			jLabel12 = new JLabel();
			jLabel12.setText("ホスト名");
			jLabel12.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
					12));
			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
			gridBagConstraints14.gridx = 1;
			gridBagConstraints14.insets = new java.awt.Insets(5, 5, 5, 0);
			gridBagConstraints14.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints14.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints14.gridy = 0;
			jLabel7 = new JLabel();
			jLabel7.setText("DBMS");
			jLabel7
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			jPanel7 = new JPanel();
			jPanel7.setLayout(new GridBagLayout());
			jPanel7.add(jLabel7, gridBagConstraints14);
			jPanel7.add(jLabel12, gridBagConstraints15);
			jPanel7.add(jLabel13, gridBagConstraints16);
			jPanel7.add(jLabel14, gridBagConstraints17);
			jPanel7.add(jLabel15, gridBagConstraints18);
			jPanel7.add(jLabel16, gridBagConstraints19);
			jPanel7.add(getJComboBoxDBMS(), gridBagConstraints20);
			jPanel7.add(getJTextFieldHostName(), gridBagConstraints21);
			jPanel7.add(getJTextFieldPortNumber(), gridBagConstraints22);
			jPanel7.add(getJTextFieldDataBaseName(), gridBagConstraints23);
			jPanel7.add(getJTextFieldUserID(), gridBagConstraints24);
			jPanel7.add(getJPasswordField(), gridBagConstraints25);
			jPanel7.add(jLabel1, gridBagConstraints);
			jPanel7.add(getJTextFieldOptionString(), gridBagConstraints1);
			jPanel7.add(jLabelClassName, gridBagConstraints11);
			jPanel7.add(getJTextFieldClassName(), gridBagConstraints2);
			jPanel7.add(jLabel3, gridBagConstraints5);
			jPanel7.add(getJScrollPane(), gridBagConstraints7);
			jPanel7.add(getJButton(), gridBagConstraints12);
			jPanel7.add(getJTextAreaNoEdit(), gridBagConstraints26);
			jPanel7.add(getJCheckBoxSavePassword(), gridBagConstraints13);
		}
		return jPanel7;
	}

	/**
	 * This method initializes jComboBox1
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBoxDBMS() {
		if (jComboBoxDBMS == null) {
			jComboBoxDBMS = new JComboBox();
			jComboBoxDBMS.setPreferredSize(new java.awt.Dimension(150, 20));
			jComboBoxDBMS
					.setToolTipText("<html>一覧に無い時は『Free Format』を選択して下さい。<br>"
							+ "ドライバクラス名が入力できるようになります。</html>");
			jComboBoxDBMS.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jComboBoxDBMS.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (e.getStateChange() == ItemEvent.SELECTED) {
						displayEdittingUrl();
						if (e.getItem().equals("Free Format")) {
							jTextFieldClassName.setEditable(true);
							// jLabelClassName.setVisible(true);

							jTextFieldHostName.setEditable(false);
							jTextFieldPortNumber.setEditable(false);
							jTextFieldDataBaseName.setEditable(false);

						} else {
							jTextFieldClassName.setEditable(false);
							// jLabelClassName.setVisible(false);
							jTextFieldClassName.setText(getConnectInfo()
									.getClassPath());

							jTextFieldHostName.setEditable(true);
							jTextFieldPortNumber.setEditable(true);
							jTextFieldDataBaseName.setEditable(true);
						}
					}
				}
			});
		}
		return jComboBoxDBMS;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldHostName() {
		if (jTextFieldHostName == null) {
			jTextFieldHostName = new JTextFieldEdit();
			jTextFieldHostName
					.setPreferredSize(new java.awt.Dimension(100, 20));
			jTextFieldHostName.setFont(new java.awt.Font("Monospaced",
					java.awt.Font.PLAIN, 12));
			jTextFieldHostName
					.addCaretListener(new javax.swing.event.CaretListener() {
						public void caretUpdate(javax.swing.event.CaretEvent e) {
							displayEdittingUrl();
						}
					});
		}
		return jTextFieldHostName;
	}

	/**
	 * This method initializes jTextField1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldPortNumber() {
		if (jTextFieldPortNumber == null) {
			jTextFieldPortNumber = new JTextFieldEdit();
			jTextFieldPortNumber.setPreferredSize(new java.awt.Dimension(100,
					20));
			jTextFieldPortNumber.setColumns(5);
			jTextFieldPortNumber
					.setToolTipText("<html>DBMSサーバの設定によりますがデフォルトでは、<br>"
							+ "Oracle：1521 PostgreSQL：5432 MySQL：3306 等です。<br>"
							+ "但し、デフォルト設定ならば省略出来ると思います</html>");
			jTextFieldPortNumber.setFont(new java.awt.Font("Monospaced",
					java.awt.Font.PLAIN, 12));
			jTextFieldPortNumber
					.addCaretListener(new javax.swing.event.CaretListener() {
						public void caretUpdate(javax.swing.event.CaretEvent e) {
							displayEdittingUrl();
						}
					});
		}
		return jTextFieldPortNumber;
	}

	/**
	 * This method initializes jTextField2
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldDataBaseName() {
		if (jTextFieldDataBaseName == null) {
			jTextFieldDataBaseName = new JTextFieldEdit();
			jTextFieldDataBaseName.setPreferredSize(new java.awt.Dimension(100,
					20));
			jTextFieldDataBaseName.setFont(new java.awt.Font("Monospaced",
					java.awt.Font.PLAIN, 12));
			jTextFieldDataBaseName
					.addCaretListener(new javax.swing.event.CaretListener() {
						public void caretUpdate(javax.swing.event.CaretEvent e) {
							displayEdittingUrl();
						}
					});
		}
		return jTextFieldDataBaseName;
	}

	/**
	 * This method initializes jTextField3
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldUserID() {
		if (jTextFieldUserID == null) {
			jTextFieldUserID = new JTextFieldEdit();
			jTextFieldUserID.setPreferredSize(new java.awt.Dimension(100, 20));
			jTextFieldUserID.setColumns(15);
			jTextFieldUserID.setFont(new java.awt.Font("Monospaced",
					java.awt.Font.PLAIN, 12));
		}
		return jTextFieldUserID;
	}

	/**
	 * This method initializes jTextField4
	 * 
	 * @return javax.swing.JTextField
	 */
	private JPasswordField getJPasswordField() {
		if (jPasswordField == null) {
			jPasswordField = new JPasswordField("");
			jPasswordField.setPreferredSize(new java.awt.Dimension(100, 20));
			jPasswordField.setColumns(15);
			jPasswordField.setFont(new java.awt.Font("Monospaced",
					java.awt.Font.PLAIN, 12));
		}
		return jPasswordField;
	}

	/**
	 * This method initializes jPanel8
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel8() {
		if (jPanel8 == null) {
			jPanel8 = new JPanel();
			jPanel8.setLayout(new BorderLayout());
			jPanel8.add(getJPanel1(), java.awt.BorderLayout.SOUTH);
			jPanel8.add(getJPanel7(), java.awt.BorderLayout.NORTH);
		}
		return jPanel8;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(new BorderLayout());
			jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(
					null, "JDBCドライバに渡す接続URL",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION,
					new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12),
					java.awt.Color.black));
			jPanel1.add(getJTextAreaURL(), java.awt.BorderLayout.CENTER);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jTextAreaURL
	 * 
	 * @return javax.swing.JTextArea
	 */
	private JTextAreaNoEdit getJTextAreaURL() {
		if (jTextAreaURL == null) {
			jTextAreaURL = new JTextAreaNoEdit();
		}
		return jTextAreaURL;
	}

	/**
	 * This method initializes jTextFieldOptionString
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldOptionString() {
		if (jTextFieldOptionString == null) {
			jTextFieldOptionString = new JTextFieldEdit();
			jTextFieldOptionString.setPreferredSize(new java.awt.Dimension(100,
					20));
			jTextFieldOptionString
					.setToolTipText("<html>接続URLの後ろに、オプションで文字列を追加したい時は、ここに入力して下さい。<br>"
							+ "DBMSを『Free Format』にした時は、『jdbc』以降のURLを全て入力して下さい</html>");
			jTextFieldOptionString.setFont(new java.awt.Font("Monospaced",
					java.awt.Font.PLAIN, 12));
			jTextFieldOptionString
					.addCaretListener(new javax.swing.event.CaretListener() {
						public void caretUpdate(javax.swing.event.CaretEvent e) {
							displayEdittingUrl();
						}
					});
		}
		return jTextFieldOptionString;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldClassName() {
		if (jTextFieldClassName == null) {
			jTextFieldClassName = new JTextFieldEdit();
			jTextFieldClassName.setFont(new Font("Monospaced", Font.PLAIN, 12));
			jTextFieldClassName.setText("");
			jTextFieldClassName
					.setToolTipText("DBMSを『Free Format』にしたときだけ入力できます。");
			jTextFieldClassName.setPreferredSize(new Dimension(100, 20));
		}
		return jTextFieldClassName;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTextAreaDriverPath());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextArea getJTextAreaDriverPath() {
		if (jTextAreaDriverPath == null) {
			jTextAreaDriverPath = new JTextArea();
			jTextAreaDriverPath.setLineWrap(true);
			jTextAreaDriverPath.setFont(new java.awt.Font("Monospaced",java.awt.Font.PLAIN, 12));
			jTextAreaDriverPath.setToolTipText("<html>ファイル名を絶対パスで入力して下さい。<br>"
					+ "複数ファイル指定する時は、｢" + System.getProperty("path.separator")
					+ "｣で区切って下さい。また、ダブルクォートで括らないで下さい。</html>");
		}
		return jTextAreaDriverPath;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("参照...");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					actionPerformedFileChoice(e);
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jTextAreaNoEdit
	 * 
	 * @return jdbcacsess.JTextAreaNoEdit
	 */
	private JTextAreaNoEdit getJTextAreaNoEdit() {
		if (jTextAreaNoEdit == null) {
			jTextAreaNoEdit = new JTextAreaNoEdit();
			jTextAreaNoEdit
					.setText("※『ドライバファイル名』はjavaコマンドで起動する時のみ指定できます。"
							+ "JavaWebStartにて起動する場合は空文字列にして、ドライバファイルをjre/lib/extに格納して下さい。m(__)m");
			jTextAreaNoEdit.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 10));
		}
		return jTextAreaNoEdit;
	}

	/**
	 * This method initializes jCheckBoxSavePassword
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBoxSavePassword() {
		if (jCheckBoxSavePassword == null) {
			jCheckBoxSavePassword = new JCheckBox();
			jCheckBoxSavePassword.setText("パスワードを保存する");
			jCheckBoxSavePassword
					.setToolTipText("<html>パスワードを設定ファイルに保存しない場合は、チェックをはずして下さい。<br>"
							+ "なお、保存は平文です。</html>");
			jCheckBoxSavePassword.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jCheckBoxSavePassword.setSelected(true);
		}
		return jCheckBoxSavePassword;
	}

} // @jve:decl-index=0:visual-constraint="38,10"
