/**
 * 
 */
package jdbcacsess.gui;

import java.awt.Component;
import java.awt.Font;

import javax.swing.Icon;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

import jdbcacsess.sql.DBObject;

/**
 * @author sima
 * 
 */
public class CellRendererDataBaseObject extends DefaultTreeCellRenderer {
	private static final long serialVersionUID = 7889976104679174292L;

	public static final Font treeFont = JFrameSetting.getGuiFont();

	public static final Font treeFontPrim = new Font(JFrameSetting.getGuiFont().getFamily(), Font.BOLD, JFrameSetting.getGuiFont().getSize());

	
	/*
	 * (非 Javadoc)
	 * 
	 * @see javax.swing.tree.TreeCellRenderer#getTreeCellRendererComponent(javax.swing.JTree,
	 *      java.lang.Object, boolean, boolean, boolean, int, boolean)
	 */
	@Override
	public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, boolean expanded,
			boolean leaf, int row, boolean hasFocus) {

		setOpenIcon(null);
		setClosedIcon(null);
		setLeafIcon(null);

		setToolTipText(null);

		setOpaque(false);
		DefaultMutableTreeNode node = (DefaultMutableTreeNode) value;
		DBObject dbObject = (DBObject)node.getUserObject();

		if(dbObject!=null){
			setNodeIcon(dbObject.getIconImage());

			if( dbObject.isStrong() ){
				setFont(treeFontPrim);
			}else{
				setFont(treeFont);
			}

			String summary = dbObject.getSummary();
			if ( summary!=null && !summary.equals("") ){
				if ( dbObject.isStrong() ){
					setToolTipText("<HTML><B>" + summary + "</B></HTML>");
				}else{
					setToolTipText("<HTML>" + summary + "</HTML>");
				}
			}
		}
		
		super.getTreeCellRendererComponent(tree, value, selected, expanded, leaf, row, hasFocus);

		return this;
	}

	void setNodeIcon(Icon icon) {
		setOpenIcon(icon);
		setClosedIcon(icon);
		setLeafIcon(icon);
	}

}
