package jdbcacsess.gui;

import java.util.LinkedList;

/**
 * @author sima 入力されたSQL文を遡れるように履歴保持する
 */
public class ComanndBuffer {
	private LinkedList<String> buff;

	private int idx;

	public ComanndBuffer() {
		buff = new LinkedList<String>();
		idx = -1;
	}

	public void add(String command) {
		if (command.trim().equals("")) {
			return;
		}

		// 最終データと同じ内容なら追加しない
		if (buff.size() != 0 && command.equals(buff.getLast())) {
			return;
		}

		buff.add(command);
		idx = buff.size() - 1;
	}

	/**
	 * @return idx を戻します。
	 * @uml.property name="idx"
	 */
	public int getIdx() {
		return idx;
	}

	public String next() {
		if (buff.size() == 0) {
			return "";
		}
		if (idx < buff.size() - 1) {
			return buff.get(++idx);
		}
		return buff.get(idx);
	}

	public String prev() {
		if (buff.size() == 0) {
			return "";
		}
		if (idx > 0) {
			return buff.get(--idx);
		}
		return buff.get(idx);
	}

	public int size() {
		return buff.size();
	}
}