/**
 * 
 */
package jdbcacsess.gui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.io.File;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

import jdbcacsess.JdbcAcsess;
import jdbcacsess.JdbcacsessException;
import jdbcacsess.SettingFile;
import jdbcacsess.gui.common.JDialogMessage;
import jdbcacsess.gui.common.JFrameBase;
import jdbcacsess.gui.common.JPopupMenuNoEdit;
import jdbcacsess.gui.common.JTextAreaNoEdit;
import jdbcacsess.sql.SqlExec;

/**
 * @author sima
 * 
 */
public class JFrameAboutBox extends JFrameBase {

	@Override
	public String getAttrKey(){ 
		return null;
	}
	@Override
	public String getAttrValue(){ 
		return null;
	}

	private static final String VERSION = "バージョン " + JdbcAcsess.major + "." + JdbcAcsess.minor + " (" + JdbcAcsess.date
			+ ")";

	private static final long serialVersionUID = -5093047074088125192L;

	private static JFrameAboutBox jFrameAboutBox;

	private JPanel jContentPane = null;

	private JPanel jPanel1 = null;

	private JTextField jTextFieldDownLoad = null;

	private JTextField jTextFieldVersion = null;

	private JTextField jTextFieldApplicationName = null;

	private JTextField jTextFieldSign = null;

	private JTextAreaNoEdit jTextAreaEnvInfos = null;

	private JButton jButtonOk = null;

	private JPanel jPanel = null;

	private JPanel jPanel2 = null;

	private JTextField jTextField = null;

	private JTextField jTextFieldHomePage = null;

	public static JFrameAboutBox getInstance() {
		if (jFrameAboutBox == null) {
			jFrameAboutBox = new JFrameAboutBox();
		}
		return jFrameAboutBox;
	}

	/**
	 * This is the default constructor
	 */
	private JFrameAboutBox() {
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		setTitle("このプログラムについて");
		this.setSize(new java.awt.Dimension(500, 400));
		setContentPane(getJContentPane());

		getRootPane().setDefaultButton(jButtonOk);
		jTextAreaEnvInfos.setText(getEnvInfo());

	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel1(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(new BoxLayout(getJPanel1(), BoxLayout.Y_AXIS));
			jPanel1.add(getJTextFieldApplicationName(), null);
			jPanel1.add(getJTextField(), null);
			jPanel1.add(getJTextFieldVersion(), null);
			jPanel1.add(getJTextFieldHomePage(), null);
			jPanel1.add(getJTextFieldDownLoad(), null);
			jPanel1.add(getJTextFieldSign(), null);
			jPanel1.add(getJPanel(), null);
			jPanel1.add(getJPanel2(), null);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jTextFieldHomePage2
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextFieldHomePage() {
		if (jTextFieldHomePage == null) {
			jTextFieldHomePage = new JTextField();
			jTextFieldHomePage.setText("http://sidujdbc.sourceforge.jp");
			jTextFieldHomePage.setHorizontalAlignment(SwingConstants.CENTER);
			jTextFieldHomePage.setEditable(false);
			jTextFieldHomePage.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
			new JPopupMenuNoEdit(jTextFieldHomePage);
		}
		return jTextFieldHomePage;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextFieldDownLoad() {
		if (jTextFieldDownLoad == null) {
			jTextFieldDownLoad = new JTextField();
			jTextFieldDownLoad.setText("http://sourceforge.jp/projects/sidujdbc/");
			jTextFieldDownLoad.setHorizontalAlignment(SwingConstants.CENTER);
			jTextFieldDownLoad.setEditable(false);
			jTextFieldDownLoad.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
			new JPopupMenuNoEdit(jTextFieldDownLoad);
		}
		return jTextFieldDownLoad;
	}

	/**
	 * This method initializes jTextField1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextFieldVersion() {
		if (jTextFieldVersion == null) {
			jTextFieldVersion = new JTextField();
			jTextFieldVersion.setText(VERSION);
			jTextFieldVersion.setEditable(false);
			jTextFieldVersion.setHorizontalAlignment(SwingConstants.CENTER);
			jTextFieldVersion.setFont(new java.awt.Font("SansSerif", java.awt.Font.PLAIN, 14));
			jTextFieldVersion.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
		}
		return jTextFieldVersion;
	}

	/**
	 * This method initializes jTextField2
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextFieldApplicationName() {
		if (jTextFieldApplicationName == null) {
			jTextFieldApplicationName = new JTextField();
			jTextFieldApplicationName.setText("JdbcAcsess");
			jTextFieldApplicationName.setEditable(false);
			jTextFieldApplicationName.setHorizontalAlignment(SwingConstants.CENTER);
			jTextFieldApplicationName.setFont(new java.awt.Font("SansSerif", java.awt.Font.BOLD | java.awt.Font.ITALIC,
					14));
			jTextFieldApplicationName.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
		}
		return jTextFieldApplicationName;
	}

	/**
	 * This method initializes jTextField3
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextFieldSign() {
		if (jTextFieldSign == null) {
			jTextFieldSign = new JTextField();
			jTextFieldSign.setText("shimakazuro");
			jTextFieldSign.setEditable(false);
			jTextFieldSign.setHorizontalAlignment(SwingConstants.CENTER);
			jTextFieldSign.setFont(new java.awt.Font("SansSerif", java.awt.Font.PLAIN, 14));
			jTextFieldSign.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
		}
		return jTextFieldSign;
	}

	/**
	 * This method initializes jTextArea
	 * 
	 * @return javax.swing.JTextArea
	 */
	private JTextAreaNoEdit getJTextAreaEnvInfos() {
		if (jTextAreaEnvInfos == null) {
			jTextAreaEnvInfos = new JTextAreaNoEdit();
		}
		return jTextAreaEnvInfos;
	}

	/**
	 * 
	 */
	private String getEnvInfo() {
		StringBuffer sb = new StringBuffer();

		// 設定ファイル
		sb.append("Setting File    : ").append(SettingFile.getInstance().getFile().getPath());
		sb.append("\n");

		sb.append("Driver Info     : ").append(SqlExec.getDriverInfo());
		sb.append("\n");

		// 拡張ディレクトリ
		String[] paths = System.getProperty("java.ext.dirs").split(File.pathSeparator);
		for (String pathName : paths) {
			sb.append("java.ext.dirs   : ").append(pathName);
			sb.append("\n");
			String[] fileNames = new File(pathName).list();
			if (fileNames != null) {
				sb.append(" ->");
				for (String string : fileNames) {
					sb.append(" " + string);
				}
				sb.append("\n");
			}
		}
		// クラスパス
		sb.append("java.class.path : ").append(System.getProperty("java.class.path"));
		sb.append("\n");

		return sb.toString();
	}

	/**
	 * This method initializes jButtonOk
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonOk() {
		if (jButtonOk == null) {
			jButtonOk = new JButton();
			jButtonOk.setText("閉じる");
			jButtonOk.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jButtonOk.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						closeFrame();
					} catch (JdbcacsessException e1) {
						JDialogMessage.errorDialog(e1);
					}
				}
			});
		}
		return jButtonOk;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(new FlowLayout());
			jPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jPanel.add(getJButtonOk(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
			jPanel2.setLayout(new BorderLayout());
			jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "環境情報",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			jPanel2.add(getJTextAreaEnvInfos(), java.awt.BorderLayout.CENTER);
		}
		return jPanel2;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setEditable(false);
			jTextField.setText("綴り間違いは仕様です(笑)　正しくは\"access\"");
			jTextField.setHorizontalAlignment(SwingConstants.CENTER);
			jTextField.setFont(new java.awt.Font("SansSerif", java.awt.Font.PLAIN, 10));
			jTextField.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
		}
		return jTextField;
	}
	@Override
	public void frameClosing() throws JdbcacsessException {
		// TODO 自動生成されたメソッド・スタブ
		
	}
}
