package jdbcacsess.gui;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.KeyEvent;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.logging.Level;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.table.AbstractTableModel;
import javax.xml.transform.TransformerException;

import jdbcacsess.JTextFieldEdit;
import jdbcacsess.JdbcacsessException;
import jdbcacsess.LogOutput;
import jdbcacsess.SettingFile;
import jdbcacsess.gui.common.ColumnWidth;
import jdbcacsess.gui.common.ComponentProperty;
import jdbcacsess.gui.common.ConstEncoding;
import jdbcacsess.gui.common.GUIManager;
import jdbcacsess.gui.common.JDialogMessage;
import jdbcacsess.gui.common.JFrameBase;
import jdbcacsess.gui.common.JPopupMenuCnageUI;
import jdbcacsess.sql.SqlMappingInfo;

import org.w3c.dom.Element;

import say.swing.JFontChooser;

public class JFrameSetting extends JFrameBase {
	@Override
	public String getAttrKey(){ 
		return null;
	}
	@Override
	public String getAttrValue(){ 
		return null;
	}

	private static final String DEFAULT_NULLVALUE = "#$%&NULL&%$#";

	private static final String DEFAULT_TIMEZONE = "GMT-00:00";

	private static final Level DEFAULT_LOGGERLEVEL = Level.INFO;
	
	private static final int DEFAULT_AUTORESIZEWIDTH = 20;

	private static final long serialVersionUID = 4207458859175871604L;

	private JPanel jContentPane = null;

	private JTabbedPane jTabbedPane = null;

	private JPanel jPanelCommon = null;

	private JPanel jPanelOracle = null;

	private JLabel jLabel = null;

	private JTextFieldEdit jTextFieldColumnOutNullValue = null;

	private JPanel jPanel = null;

	private JButton jButtonSaveAndExit = null;

	private JButton jButtonNoSaveAndExit = null;

	private JLabel jLabel1 = null;

	private JTextFieldEdit jTextFieldTimeZoneOfDBserver = null;

	private JLabel jLabel3 = null;

	private JComboBox jComboBoxColumnInOutEncodeing = null;

	private JLabel jLabel2 = null;

	private JLabel jLabel4 = null;

	private JScrollPane jScrollPane = null;

	private JTable jTableSqlMapping = null;

	private JLabel jLabel5 = null;

	private JPopupMenuCnageUI jPopupMenuCnageUI = null;

	private JMenuItem jMenuItemEdit = null;

	private JMenuItem jMenuItemDelete = null;

	private SqlMappingTableModel tableModel;

	private JPanel jPanelLogger = null;

	private JLabel jLabel6 = null;

	private JComboBox jComboBoxLoggerLevel = null;

	private JButton jButtonAllClear = null;

	private JLabel jLabel7 = null;

	private JSlider jSliderAutoResizeWidth = null;

	private JLabel jLabel8 = null;

	private JPanel jPanelOverview = null;

	private JFontChooser jFontChooser;

	/**
	 * This is the default constructor
	 * @throws JdbcacsessException 
	 */
	public JFrameSetting() throws JdbcacsessException {
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 * @throws JdbcacsessException 
	 */
	private void initialize() throws JdbcacsessException {
		this.setTitle("設定");
		this.setSize(new java.awt.Dimension(750, 700));
		this.setContentPane(getJContentPane());

		jTextFieldColumnOutNullValue.setText(getColumnOutNullValue());
		jTextFieldTimeZoneOfDBserver.setText(getOracleTimeZoneOfDbserver());
		jComboBoxColumnInOutEncodeing.setSelectedItem(getColumnInOutEncodeing());
		jSliderAutoResizeWidth.setValue(getAutoResizeWidth());

		tableModel = new SqlMappingTableModel();
		jTableSqlMapping.setModel(tableModel);
		jTableSqlMapping.setComponentPopupMenu(getJPopupMenuCnageUI());
		ColumnWidth.setColumnWidthResizeOff(jTableSqlMapping);

		jComboBoxLoggerLevel.setSelectedItem(getLoggerLevel());
		setVisible(true);
	}

	private void datSave() throws TransformerException, IOException, JdbcacsessException {
		omponentProperty.put(JFrameSetting.class,"columnOutNullValue",	jTextFieldColumnOutNullValue.getText());
		omponentProperty.put(JFrameSetting.class,"oracleTimeZoneOfDbserver",jTextFieldTimeZoneOfDBserver.getText());
		omponentProperty.put(JFrameSetting.class,"columnInOutEncodeing", jComboBoxColumnInOutEncodeing.getSelectedItem().toString());
		omponentProperty.put(JFrameSetting.class,"autoResizeWidth", jSliderAutoResizeWidth.getValue());
		omponentProperty.put(JFrameSetting.class,"fontFamily", jFontChooser.getSelectedFontFamily());
		omponentProperty.put(JFrameSetting.class,"fontstyle", jFontChooser.getSelectedFontStyle());
		omponentProperty.put(JFrameSetting.class,"fontsize", jFontChooser.getSelectedFontSize());
		
		tableModel.save();
		omponentProperty.put(JFrameSetting.class, "loggerLevel", jComboBoxLoggerLevel.getSelectedItem().toString());
		LogOutput.setLevel((Level) jComboBoxLoggerLevel.getSelectedItem());
		SettingFile.getInstance().save();
	}

	public static String getColumnOutNullValue() {
		String rtn = new ComponentProperty().getToString(JFrameSetting.class,
				"columnOutNullValue");
		if (rtn.equals("")) {
			rtn = DEFAULT_NULLVALUE;
		}
		return rtn;
	}

	public static String getOracleTimeZoneOfDbserver() {
		String rtn = new ComponentProperty().getToString(JFrameSetting.class,
				"oracleTimeZoneOfDbserver");
		if (rtn.equals("")) {
			rtn = DEFAULT_TIMEZONE;
		}
		return rtn;
	}

	public static ConstEncoding getColumnInOutEncodeing() {
		String rtn = new ComponentProperty().getToString(JFrameSetting.class,
				"columnInOutEncodeing");
		return ConstEncoding.searchName(rtn);
	}

	public static int getAutoResizeWidth() {
		Integer rtn = new ComponentProperty().getToInteger(JFrameSetting.class,
				"autoResizeWidth");
		if (rtn==null) {
			rtn = DEFAULT_AUTORESIZEWIDTH;
		}
		return rtn;
	}

	public static Level getLoggerLevel() {
		String str = new ComponentProperty().getToString(JFrameSetting.class,
				"loggerLevel");
		if (str.equals("")) {
			return DEFAULT_LOGGERLEVEL;
		}
		return Level.parse(str);
	}
	
	public static Font getGuiFont(){
		String family = new ComponentProperty().getToString(JFrameSetting.class,"fontFamily");
		Integer style = new ComponentProperty().getToInteger(JFrameSetting.class,"fontstyle");
		Integer size = new ComponentProperty().getToInteger(JFrameSetting.class,"fontsize");
		
		if ( family == null || style == null || size == null ){
			return new Font("Dialog",0,10);
		}
		Font font = new Font(family,style,size);
		return font;
	}

	static class SqlMappingTableModel extends AbstractTableModel {
		private static final long serialVersionUID = -4489565625774646866L;

		String[] header = { "有効/無効", "DBMS名称", "DBMSデータ型", "取得メソッド",
				"データ取得クラス名", "SQLtype値" };

		List<SqlMappingInfo> sqlMappingList;

		public SqlMappingTableModel() throws JdbcacsessException {
			sqlMappingList = new SqlMappingInfo().getInfoList();
		}

		@Override
		public String getColumnName(int columnIndex) {
			return header[columnIndex];
		}

		public int getRowCount() {
			return sqlMappingList.size();
		}

		public int getColumnCount() {
			return header.length;
		}

		public Object getValueAt(int rowIndex, int columnIndex) {
			SqlMappingInfo sqlMapping = sqlMappingList.get(rowIndex);

			switch (columnIndex) {
			case 0:
				return sqlMapping.getEnable() ? "有効" : "無効";
			case 1:
				return sqlMapping.getDbms();
			case 2:
				return sqlMapping.getType();
			case 3:
				return sqlMapping.getResultSetMethodName();
			case 4:
				return sqlMapping.getGetResultSetClassName();
			case 5:
				return sqlMapping.getSqlTypes();
			}
			return null;
		}

		public void editData(int rowIndex) {
			SqlMappingInfo sqlMapping = sqlMappingList.get(rowIndex);
			JFrameSqlMapping dlg = new JFrameSqlMapping(this, rowIndex);
			dlg.setSqlMappingInfo(sqlMapping);
			dlg.setVisible(true);
		}

		private ArrayList<SqlMappingInfo> deleteList = new ArrayList<SqlMappingInfo>();

		public void delete(int rowIndex) {
			deleteList.add(sqlMappingList.remove(rowIndex));
			fireTableRowsDeleted(rowIndex, rowIndex);
		}

		public void save() throws JdbcacsessException {
			for (SqlMappingInfo item : deleteList) {
				item.removeParameter();
			}
		}
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJTabbedPane(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getJPanel(), java.awt.BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jTabbedPane
	 * 
	 * @return javax.swing.JTabbedPane
	 */
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.setName("");
			jTabbedPane.addTab("共通", null, getJPanelCommon(), null);
			jTabbedPane.addTab("Oracle", null, getJPanelOracle(), null);
			jTabbedPane.addTab("Logger", null, getJPanelLogger(), null);
			jTabbedPane.addTab("外観", null, getJPanelOverview(), null);
		}
		return jTabbedPane;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelCommon() {
		if (jPanelCommon == null) {
			GridBagConstraints gridBagConstraints41 = new GridBagConstraints();
			gridBagConstraints41.gridx = 1;
			gridBagConstraints41.anchor = GridBagConstraints.WEST;
			gridBagConstraints41.gridy = 9;
			jLabel8 = new JLabel();
			jLabel8.setText("（ゼロの場合自動調整を行いません）");
			jLabel8.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			GridBagConstraints gridBagConstraints33 = new GridBagConstraints();
			gridBagConstraints33.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints33.gridy = 10;
			gridBagConstraints33.weightx = 1.0;
			gridBagConstraints33.anchor = GridBagConstraints.WEST;
			gridBagConstraints33.gridx = 1;
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.gridx = 1;
			gridBagConstraints13.anchor = GridBagConstraints.WEST;
			gridBagConstraints13.insets = new Insets(10, 0, 0, 0);
			gridBagConstraints13.gridy = 8;
			jLabel7 = new JLabel();
			jLabel7.setText("検索結果カラムの自動調整文字数");
			GridBagConstraints gridBagConstraints32 = new GridBagConstraints();
			gridBagConstraints32.gridx = 1;
			gridBagConstraints32.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints32.insets = new java.awt.Insets(10, 0, 0, 0);
			gridBagConstraints32.gridwidth = 2;
			gridBagConstraints32.gridy = 11;
			jLabel5 = new JLabel();
			jLabel5.setText("データ型マッピング");
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints22.gridy = 12;
			gridBagConstraints22.weightx = 1.0;
			gridBagConstraints22.weighty = 1.0;
			gridBagConstraints22.gridwidth = 3;
			gridBagConstraints22.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints22.gridx = 1;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 1;
			gridBagConstraints11.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints11.gridwidth = 2;
			gridBagConstraints11.gridy = 1;
			jLabel4 = new JLabel();
			jLabel4.setText("（ＣＳＶ入出及びクリップボードコピー時に使用されます）");
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints7.gridy = 7;
			gridBagConstraints7.weightx = 0.0;
			gridBagConstraints7.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints7.gridx = 1;
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.gridx = 0;
			gridBagConstraints31.gridwidth = 2;
			gridBagConstraints31.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints31.insets = new java.awt.Insets(10, 0, 0, 0);
			gridBagConstraints31.gridy = 5;
			jLabel3 = new JLabel();
			jLabel3.setText("カラム単位のテキスト入出力の文字コード");
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints21.gridy = 3;
			gridBagConstraints21.weightx = 1.0;
			gridBagConstraints21.weighty = 1.0;
			gridBagConstraints21.gridx = 1;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints1.gridy = 2;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.ipadx = 0;
			gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints1.gridwidth = 1;
			gridBagConstraints1.gridx = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridwidth = 2;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
			gridBagConstraints.gridy = 0;
			jLabel = new JLabel();
			jLabel.setText("NULL値表現文字列");
			jPanelCommon = new JPanel();
			jPanelCommon.setLayout(new GridBagLayout());
			jPanelCommon.add(jLabel, gridBagConstraints);
			jPanelCommon.add(getJTextFieldColumnOutNullValue(),
					gridBagConstraints1);
			jPanelCommon.add(jLabel3, gridBagConstraints31);
			jPanelCommon.add(getJComboBoxColumnInOutEncodeing(),
					gridBagConstraints7);
			jPanelCommon.add(jLabel4, gridBagConstraints11);
			jPanelCommon.add(getJScrollPane(), gridBagConstraints22);
			jPanelCommon.add(jLabel5, gridBagConstraints32);
			jPanelCommon.add(jLabel7, gridBagConstraints13);
			jPanelCommon.add(getJSliderAutoResizeWidth(), gridBagConstraints33);
			jPanelCommon.add(jLabel8, gridBagConstraints41);
		}
		return jPanelCommon;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelOracle() {
		if (jPanelOracle == null) {
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints4.gridy = 1;
			jLabel2 = new JLabel();
			jLabel2.setText("(DBサーバのタイムゾーンです)");
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints3.gridy = 2;
			gridBagConstraints3.weightx = 1.0;
			gridBagConstraints3.gridx = 0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints2.insets = new java.awt.Insets(10, 0, 0, 0);
			gridBagConstraints2.gridy = 0;
			jLabel1 = new JLabel();
			jLabel1.setText("TIMESTAMP LOCAL TIME ZONE型のタイムゾーン");
			jPanelOracle = new JPanel();
			jPanelOracle.setLayout(new GridBagLayout());
			jPanelOracle.add(jLabel1, gridBagConstraints2);
			jPanelOracle.add(getJTextFieldTimeZoneOfDBserver(),
					gridBagConstraints3);
			jPanelOracle.add(jLabel2, gridBagConstraints4);
		}
		return jPanelOracle;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldColumnOutNullValue() {
		if (jTextFieldColumnOutNullValue == null) {
			jTextFieldColumnOutNullValue = new JTextFieldEdit();
			jTextFieldColumnOutNullValue.setToolTipText("ＣＳＶ及びクリップボード時に使用されます");
			jTextFieldColumnOutNullValue
					.setPreferredSize(new java.awt.Dimension(10, 22));
		}
		return jTextFieldColumnOutNullValue;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.add(getJButtonSaveAndExit(), null);
			jPanel.add(getJButtonNoSaveAndExit(), null);
			jPanel.add(getJButtonAllClear(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSaveAndExit() {
		if (jButtonSaveAndExit == null) {
			jButtonSaveAndExit = new JButton();
			jButtonSaveAndExit.setText("保存して閉じる");
			jButtonSaveAndExit
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							try {
								datSave();
								GUIManager.setUIManager();
								closeFrame();
							} catch (Exception err) {
								JDialogMessage.errorDialog(err);
							}
						}
					});
		}
		return jButtonSaveAndExit;
	}

	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonNoSaveAndExit() {
		if (jButtonNoSaveAndExit == null) {
			jButtonNoSaveAndExit = new JButton();
			jButtonNoSaveAndExit.setText("保存せず閉じる");
			jButtonNoSaveAndExit
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							try {
								closeFrame();
							} catch (JdbcacsessException e1) {
								JDialogMessage.errorDialog(e1);
							}
						}
					});
		}
		return jButtonNoSaveAndExit;
	}

	/**
	 * This method initializes jTextField1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldTimeZoneOfDBserver() {
		if (jTextFieldTimeZoneOfDBserver == null) {
			jTextFieldTimeZoneOfDBserver = new JTextFieldEdit();
		}
		return jTextFieldTimeZoneOfDBserver;
	}

	/**
	 * This method initializes jComboBox
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBoxColumnInOutEncodeing() {
		if (jComboBoxColumnInOutEncodeing == null) {
			jComboBoxColumnInOutEncodeing = new JComboBox(ConstEncoding.values());
		}
		return jComboBoxColumnInOutEncodeing;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTableSqlMapping());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private JTable getJTableSqlMapping() {
		if (jTableSqlMapping == null) {
			jTableSqlMapping = new JTable();
			jTableSqlMapping
					.setSelectionMode(javax.swing.ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		}
		return jTableSqlMapping;
	}

	/**
	 * This method initializes jPopupMenuCnageUI
	 * 
	 * @return jdbcacsess.JPopupMenuCnageUI
	 */
	private JPopupMenuCnageUI getJPopupMenuCnageUI() {
		if (jPopupMenuCnageUI == null) {
			jPopupMenuCnageUI = new JPopupMenuCnageUI();
			jPopupMenuCnageUI.add(getJMenuItemEdit());
			jPopupMenuCnageUI.add(getJMenuItemDelete());
		}
		return jPopupMenuCnageUI;
	}

	private int getSelectRowCountZeroCheck() {
		int row = jTableSqlMapping.getSelectedRowCount();
		if (row < 1) {
			JDialogMessage.infoDialog("行を選択して下さい", "行未選択エラー");
		}
		return row;
	}

	/**
	 * This method initializes jMenuItemEdit
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemEdit() {
		if (jMenuItemEdit == null) {
			jMenuItemEdit = new JMenuItem();
			jMenuItemEdit.setText("編集");
			jMenuItemEdit
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							int rowCount = getSelectRowCountZeroCheck();
							if (rowCount > 1){
								JDialogMessage.infoDialog("複数行を選択出来ません", "行選択エラー");
								return;
							}
							for (int row : jTableSqlMapping.getSelectedRows()){
								tableModel.editData(row);
							}
						}
					});
		}
		return jMenuItemEdit;
	}

	/**
	 * This method initializes jMenuItemDelete
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemDelete() {
		if (jMenuItemDelete == null) {
			jMenuItemDelete = new JMenuItem();
			jMenuItemDelete.setText("削除");
			jMenuItemDelete
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							getSelectRowCountZeroCheck();
							List<Integer> rows = new ArrayList<Integer>();
							for (int row : jTableSqlMapping.getSelectedRows()){
								rows.add(row);
							}
							Collections.reverse(rows);
							for (int row : rows){
								tableModel.delete(row);
							}
						}
					});
		}
		return jMenuItemDelete;
	}

	/**
	 * This method initializes jPanelLogger
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelLogger() {
		if (jPanelLogger == null) {
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints6.gridy = 1;
			gridBagConstraints6.weightx = 1.0;
			gridBagConstraints6.gridx = 0;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints5.gridy = 0;
			jLabel6 = new JLabel();
			jLabel6.setText("Loggerのログ出力レベル");
			jPanelLogger = new JPanel();
			jPanelLogger.setLayout(new GridBagLayout());
			jPanelLogger.add(jLabel6, gridBagConstraints5);
			jPanelLogger.add(getJComboBoxLoggerLevel(), gridBagConstraints6);
		}
		return jPanelLogger;
	}

	/**
	 * This method initializes jComboBox
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBoxLoggerLevel() {
		if (jComboBoxLoggerLevel == null) {
			jComboBoxLoggerLevel = new JComboBox();
			jComboBoxLoggerLevel.addItem(Level.SEVERE);
			jComboBoxLoggerLevel.addItem(Level.WARNING);
			jComboBoxLoggerLevel.addItem(Level.INFO);
			jComboBoxLoggerLevel.addItem(Level.CONFIG);
			jComboBoxLoggerLevel.addItem(Level.FINE);
			jComboBoxLoggerLevel.addItem(Level.FINER);
			jComboBoxLoggerLevel.addItem(Level.FINEST);
		}
		return jComboBoxLoggerLevel;
	}

	/**
	 * This method initializes jButtonAllClear
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonAllClear() {
		if (jButtonAllClear == null) {
			jButtonAllClear = new JButton();
			jButtonAllClear.setText("全ての設定を初期化");
			jButtonAllClear
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedAllClear();
							try {
								closeFrame();
							} catch (JdbcacsessException e1) {
								JDialogMessage.errorDialog(e1);
							}
						}
					});
		}
		return jButtonAllClear;
	}

	protected void actionPerformedAllClear() {
		Element e = SettingFile.getInstance().getRootElement(
				SqlMappingInfo.BASETABNAME + "s");
		e.getParentNode().removeChild(e);

		ComponentProperty cp = new ComponentProperty();
		cp.remove(this.getClass());
	}

	/**
	 * This method initializes jSliderAutoResizeWidth	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getJSliderAutoResizeWidth() {
		if (jSliderAutoResizeWidth == null) {
			jSliderAutoResizeWidth = new JSlider();
			jSliderAutoResizeWidth.setMaximum(100);
			jSliderAutoResizeWidth.setPaintTicks(true);
			jSliderAutoResizeWidth.setPaintLabels(true);
			jSliderAutoResizeWidth.setMinorTickSpacing(10);
			jSliderAutoResizeWidth.setMajorTickSpacing(20);
			jSliderAutoResizeWidth.setMinimum(0);
		}
		return jSliderAutoResizeWidth;
	}

	/**
	 * This method initializes jPanelOverview	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelOverview() {
		if (jPanelOverview == null) {
			jPanelOverview = new JPanel();
			jPanelOverview.setLayout(new BorderLayout());
			jPanelOverview.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED), "フォント", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, null, null));
			jFontChooser = new JFontChooser();
			jFontChooser.setSelectedFont(getGuiFont());
			jPanelOverview.add(jFontChooser,BorderLayout.CENTER);
			
		}
		return jPanelOverview;
	}
	@Override
	public void frameClosing() throws JdbcacsessException {
		// TODO 自動生成されたメソッド・スタブ
		
	}

}
