/**
 * 
 */
package jdbcacsess.gui;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import jdbcacsess.JTextFieldEdit;
import jdbcacsess.JdbcacsessException;
import jdbcacsess.gui.JFrameSetting.SqlMappingTableModel;
import jdbcacsess.gui.common.JComboboxGetResultSetMethod;
import jdbcacsess.gui.common.JDialogMessage;
import jdbcacsess.gui.common.JFrameBase;
import jdbcacsess.sql.ConstSqlTypes;
import jdbcacsess.sql.SqlExec;
import jdbcacsess.sql.SqlMappingInfo;

/**
 * @author sima
 * 
 */
public class JFrameSqlMapping extends JFrameBase {
	@Override
	public String getAttrKey(){ 
		return null;
	}
	@Override
	public String getAttrValue(){ 
		return null;
	}


	private static final long serialVersionUID = 6441783663821575882L;

	private JPanel jContentPane = null;

	private JPanel jPanel1 = null;

	private JPanel jPanel2 = null;

	private JButton jButtonSaveAndExit = null;

	private JButton jButtonDiscardAndExit = null;

	private JLabel jLabel0 = null;

	private JLabel jLabel1 = null;

	private JLabel jLabel2 = null;

	private JLabel jLabel3 = null;

	private JTextFieldEdit jTextFieldDbms = null;

	private JTextFieldEdit jTextFieldType = null;

	private JComboboxGetResultSetMethod jComboboxGetResultSetMethod = null;

	private JTextFieldEdit jTextFieldGetResultSetClass = null;

	private JLabel jLabel4 = null;

	private JTextFieldEdit jTextFieldCellRendererClass = null;

	private JLabel jLabel5 = null;

	private JTextFieldEdit jTextFieldCellEditorClass = null;

	/**
	 * This method initializes
	 * 
	 */
	public JFrameSqlMapping() {
		initialize();
	}

	SqlMappingTableModel model = null;

	int rowIndex;

	public JFrameSqlMapping(SqlMappingTableModel model, int rowIndex) {
		this.model = model;
		this.rowIndex = rowIndex;
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		this.setTitle("SQLマッピング設定");
		this.setSize(new java.awt.Dimension(550, 400));
		this.setContentPane(getJContentPane());

		jComboBoxSqlTypes.setModel(new DefaultComboBoxModel(ConstSqlTypes.values()));
	}

	private SqlMappingInfo sqlMappingInfo;

	private JLabel jLabel = null;

	private JCheckBox jCheckBoxDataEnable = null;

	private JLabel jLabel6 = null;

	private JComboBox jComboBoxSqlTypes = null;

	private JLabel jLabel7 = null;

	public void setSqlMappingInfo(SqlMappingInfo sqlMappingInfo) {
		this.sqlMappingInfo = sqlMappingInfo;
		displayData();
	}

	private void displayData() {
		jCheckBoxDataEnable.setSelected(sqlMappingInfo.getEnable());
		jTextFieldDbms.setText(sqlMappingInfo.getDbms());
		jTextFieldType.setText(sqlMappingInfo.getType());
		jComboboxGetResultSetMethod.setSelectMethodName(sqlMappingInfo
				.getResultSetMethodName());
		jTextFieldGetResultSetClass.setText(sqlMappingInfo
				.getGetResultSetClassName());
		jTextFieldCellRendererClass.setText(sqlMappingInfo
				.getCellRendererClassName());
		jTextFieldCellEditorClass.setText(sqlMappingInfo
				.getCellEditorClassName());
		jComboBoxSqlTypes.setSelectedItem(sqlMappingInfo.getSqlTypes());
	}

	private boolean setData() {
		String methodName = jComboboxGetResultSetMethod.getSelectMethodName();
		String getColumn = jTextFieldGetResultSetClass.getText();

		if ((!methodName.equals("")) && (!getColumn.equals(""))) {
			JDialogMessage.infoDialog("ResultSetの取得メソッドと独自データ取得クラスの\n"
					+ "両方を指定することは出来ません。", "指定誤り");
			return false;
		}
		if ((methodName.equals("")) && (getColumn.equals(""))) {
			JDialogMessage.infoDialog("ResultSetの取得メソッドと独自データ取得クラスの\n"
					+ "両方を省略することは出来ません。", "指定誤り");
			return false;
		}

		if (!getColumn.equals("")) {
			try {
				SqlExec.classForName(getColumn);
			} catch (Exception e) {
				JDialogMessage.infoDialog(getColumn + " をロード出来ません。\n"
						+ "クラスパスの指定を確認して下さい。\n"
						+ "「このプログラムについて」から現在のクラスパスを参照できます。", "指定誤り");
				return false;
			}
		}

		sqlMappingInfo.setEnable(jCheckBoxDataEnable.isSelected());
		sqlMappingInfo.setResultSetMethodName(jComboboxGetResultSetMethod
				.getSelectMethodName());
		sqlMappingInfo.setGetResultSetClassName(jTextFieldGetResultSetClass
				.getText());
		sqlMappingInfo.setCellRendererClassName(jTextFieldCellRendererClass
				.getText());
		sqlMappingInfo.setCellEditorClassName(jTextFieldCellEditorClass
				.getText());
		sqlMappingInfo.setSqlTypes((ConstSqlTypes)jComboBoxSqlTypes.getSelectedItem());
		return true;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel1(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getJPanel2(), java.awt.BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
			gridBagConstraints14.gridx = 0;
			gridBagConstraints14.anchor = GridBagConstraints.WEST;
			gridBagConstraints14.insets = new Insets(20, 0, 0, 0);
			gridBagConstraints14.gridy = 11;
			jLabel7 = new JLabel();
			jLabel7.setText("※設定内容は、現在の検索結果には反映されません。次回SQL実行後からです。");
			GridBagConstraints gridBagConstraints32 = new GridBagConstraints();
			gridBagConstraints32.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints32.gridy = 10;
			gridBagConstraints32.weightx = 1.0;
			gridBagConstraints32.anchor = GridBagConstraints.WEST;
			gridBagConstraints32.ipadx = 1;
			gridBagConstraints32.ipady = 1;
			gridBagConstraints32.insets = new Insets(0, 15, 0, 15);
			gridBagConstraints32.gridx = 0;
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.gridx = 0;
			gridBagConstraints21.anchor = GridBagConstraints.WEST;
			gridBagConstraints21.insets = new Insets(10, 5, 0, 0);
			gridBagConstraints21.gridy = 9;
			jLabel6 = new JLabel();
			jLabel6.setText("setObjectで使用するjava.sql.Types値");
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints13.weightx = 1.0;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 0;
			gridBagConstraints12.anchor = GridBagConstraints.WEST;
			gridBagConstraints12.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints12.gridy = 0;
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.gridx = 0;
			gridBagConstraints31.insets = new java.awt.Insets(10, 0, 0, 0);
			gridBagConstraints31.gridy = 9;
			jLabel = new JLabel();
			jLabel.setText("以下はインタフェース検討中の為、現在指定出来ません");
			jLabel.setVisible(false);
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.gridy = 15;
			gridBagConstraints11.ipadx = 1;
			gridBagConstraints11.ipady = 1;
			gridBagConstraints11.weightx = 1.0;
			gridBagConstraints11.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints11.insets = new java.awt.Insets(0, 15, 5, 15);
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.insets = new java.awt.Insets(10, 5, 0, 0);
			gridBagConstraints10.gridy = 13;
			gridBagConstraints10.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints10.gridx = 0;
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints9.gridy = 12;
			gridBagConstraints9.ipadx = 1;
			gridBagConstraints9.ipady = 1;
			gridBagConstraints9.weightx = 1.0;
			gridBagConstraints9.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints9.insets = new java.awt.Insets(0, 15, 0, 15);
			gridBagConstraints9.gridx = 0;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.insets = new java.awt.Insets(10, 5, 0, 0);
			gridBagConstraints8.gridy = 10;
			gridBagConstraints8.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints8.gridx = 0;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints7.gridy = 8;
			gridBagConstraints7.ipadx = 1;
			gridBagConstraints7.ipady = 1;
			gridBagConstraints7.weightx = 1.0;
			gridBagConstraints7.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints7.insets = new java.awt.Insets(0, 15, 0, 15);
			gridBagConstraints7.gridx = 0;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.insets = new java.awt.Insets(10, 5, 0, 0);
			gridBagConstraints6.gridy = 7;
			gridBagConstraints6.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints6.gridx = 0;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints5.gridy = 6;
			gridBagConstraints5.ipadx = 1;
			gridBagConstraints5.ipady = 1;
			gridBagConstraints5.weightx = 1.0;
			gridBagConstraints5.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints5.insets = new java.awt.Insets(0, 15, 0, 15);
			gridBagConstraints5.gridx = 0;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.insets = new java.awt.Insets(10, 5, 0, 0);
			gridBagConstraints4.gridy = 5;
			gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints4.gridx = 0;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints3.gridy = 4;
			gridBagConstraints3.ipadx = 1;
			gridBagConstraints3.ipady = 1;
			gridBagConstraints3.weightx = 1.0;
			gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints3.insets = new java.awt.Insets(0, 15, 0, 15);
			gridBagConstraints3.gridx = 0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.insets = new java.awt.Insets(10, 5, 0, 0);
			gridBagConstraints2.gridy = 3;
			gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints2.gridx = 0;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints1.gridy = 2;
			gridBagConstraints1.ipadx = 1;
			gridBagConstraints1.ipady = 1;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints1.insets = new java.awt.Insets(0, 15, 0, 15);
			gridBagConstraints1.gridx = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new java.awt.Insets(10, 5, 0, 0);
			gridBagConstraints.gridy = 1;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints.gridx = 0;
			jLabel5 = new JLabel();
			jLabel5.setText("セルエディタークラス名");
			jLabel5.setVisible(false);
			jLabel4 = new JLabel();
			jLabel4.setText("セルレンダラ－クラス名");
			jLabel4.setVisible(false);
			jLabel3 = new JLabel();
			jLabel3.setText("GetColumnResultSetを実装した独自クラス名\n 又はDMBS固有のデータ型クラス名");
			jLabel2 = new JLabel();
			jLabel2.setText("java.sql.ResultSetの取得メソッド");
			jLabel1 = new JLabel();
			jLabel1.setText("DBMSデータ型");
			jLabel0 = new JLabel();
			jLabel0.setText("DBMS名称");
			jPanel1 = new JPanel();
			jPanel1.setLayout(new GridBagLayout());
			jPanel1.add(getJCheckBoxDataEnable(), gridBagConstraints12);
			jPanel1.add(jLabel0, gridBagConstraints);
			jPanel1.add(getJTextFieldDbms(), gridBagConstraints1);
			jPanel1.add(jLabel1, gridBagConstraints2);
			jPanel1.add(getJTextFieldType(), gridBagConstraints3);
			jPanel1.add(jLabel2, gridBagConstraints4);
			jPanel1.add(getJComboboxGetResultSetMethod(), gridBagConstraints5);
			jPanel1.add(jLabel3, gridBagConstraints6);
			jPanel1.add(getJTextFieldGetResultSetClass(), gridBagConstraints7);
			jPanel1.add(jLabel6, gridBagConstraints21);
			jPanel1.add(getJComboBoxSqlTypes(), gridBagConstraints32);
			jPanel1.add(jLabel, gridBagConstraints31);
			jPanel1.add(jLabel4, gridBagConstraints8);
			jPanel1.add(getJTextFieldCellRendererClass(), gridBagConstraints9);
			jPanel1.add(jLabel5, gridBagConstraints10);
			jPanel1.add(getJTextFieldCellEditorClass(), gridBagConstraints11);
			jPanel1.add(jLabel7, gridBagConstraints14);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanelJFrameSqlMapping
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
			jPanel2.add(getJButtonSaveAndExit(), null);
			jPanel2.add(getJButtonDiscardAndExit(), null);
		}
		return jPanel2;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSaveAndExit() {
		if (jButtonSaveAndExit == null) {
			jButtonSaveAndExit = new JButton();
			jButtonSaveAndExit.setText("保存して閉じる");
			jButtonSaveAndExit
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (!setData()) {
								return;
							}
							try {
								sqlMappingInfo.currentDataSave();
								if (model != null) {
									model.fireTableRowsUpdated(rowIndex, rowIndex);
								}
								closeFrame();
							} catch (JdbcacsessException e1) {
								JDialogMessage.errorDialog(e1);
							}
						}
					});
		}
		return jButtonSaveAndExit;
	}

	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonDiscardAndExit() {
		if (jButtonDiscardAndExit == null) {
			jButtonDiscardAndExit = new JButton();
			jButtonDiscardAndExit.setText("保存せず閉じる");
			jButtonDiscardAndExit
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							try {
								closeFrame();
							} catch (JdbcacsessException e1) {
								JDialogMessage.errorDialog(e1);
							}
						}
					});
		}
		return jButtonDiscardAndExit;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldDbms() {
		if (jTextFieldDbms == null) {
			jTextFieldDbms = new JTextFieldEdit();
			jTextFieldDbms.setEditable(false);
		}
		return jTextFieldDbms;
	}

	/**
	 * This method initializes jTextField1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldType() {
		if (jTextFieldType == null) {
			jTextFieldType = new JTextFieldEdit();
			jTextFieldType.setEditable(false);
		}
		return jTextFieldType;
	}

	/**
	 * This method initializes jTextField2
	 * 
	 * @return javax.swing.JTextField
	 */
	private JComboboxGetResultSetMethod getJComboboxGetResultSetMethod() {
		if (jComboboxGetResultSetMethod == null) {
			jComboboxGetResultSetMethod = new JComboboxGetResultSetMethod();
		}
		return jComboboxGetResultSetMethod;
	}

	/**
	 * This method initializes jTextField3
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldGetResultSetClass() {
		if (jTextFieldGetResultSetClass == null) {
			jTextFieldGetResultSetClass = new JTextFieldEdit();
		}
		return jTextFieldGetResultSetClass;
	}

	/**
	 * This method initializes jTextField4
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldCellRendererClass() {
		if (jTextFieldCellRendererClass == null) {
			jTextFieldCellRendererClass = new JTextFieldEdit();
			jTextFieldCellRendererClass.setEditable(false);
			jTextFieldCellRendererClass.setVisible(false);
		}
		return jTextFieldCellRendererClass;
	}

	/**
	 * This method initializes jTextField5
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextFieldEdit getJTextFieldCellEditorClass() {
		if (jTextFieldCellEditorClass == null) {
			jTextFieldCellEditorClass = new JTextFieldEdit();
			jTextFieldCellEditorClass.setEditable(false);
			jTextFieldCellEditorClass.setVisible(false);
		}
		return jTextFieldCellEditorClass;
	}

	/**
	 * This method initializes jCheckBoxDataEnable
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBoxDataEnable() {
		if (jCheckBoxDataEnable == null) {
			jCheckBoxDataEnable = new JCheckBox();
			jCheckBoxDataEnable.setText("この設定を有効にする");
		}
		return jCheckBoxDataEnable;
	}

	/**
	 * This method initializes jComboBoxSqlTypes	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBoxSqlTypes() {
		if (jComboBoxSqlTypes == null) {
			jComboBoxSqlTypes = new JComboBox();
		}
		return jComboBoxSqlTypes;
	}
	@Override
	public void frameClosing() throws JdbcacsessException {
		// TODO 自動生成されたメソッド・スタブ
		
	}
}
