/**
 * 
 */
package jdbcacsess.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.KeyEvent;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.border.TitledBorder;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;

import jdbcacsess.gui.common.ColumnWidth;
import jdbcacsess.gui.common.JComboBoxSearchPattern;
import jdbcacsess.gui.common.JDialogMessage;

/**
 * @author sss
 *
 */
public class JPanelDatabaseMetaData extends JPanel {
	
	static class CellRendererDatabaseMetaData extends DefaultTableCellRenderer{
		/**
		 * 
		 */
		private static final long serialVersionUID = -5502420734972638184L;

		public Component getTableCellRendererComponent(JTable table, Object value,
				boolean isSelected, boolean hasFocus, int row, int column) {

			super.getTableCellRendererComponent(table, value, isSelected, hasFocus,
					row, column);
			setHorizontalAlignment((value instanceof Number)?RIGHT:LEFT);
			if (value == null) {
				setValue("#NULL#");
				setFont(getFont().deriveFont(getFont().getStyle(), 10));
				setHorizontalAlignment(CENTER);
			}

			return this;
		}
	}
	
	private static final long serialVersionUID = 1L;
	private JTabbedPane jTabbedPane = null;  //  @jve:decl-index=0:visual-constraint="124,206"
	private JScrollPane jScrollPaneRet = null;
	private JTable jTableReturn = null;
	private JScrollPane jScrollPaneTableTypes = null;
	private JTable jTableTableTypes = null;
	private JScrollPane jScrollPaneTypeInfo = null;
	private JTable jTableTypeInfo = null;
	private JScrollPane jScrollPaneUDTs = null;
	private JTable jTableUDTs = null;
	private JPanel jPanelUDTs = null;
	private JPanel jPanelUDTsSearch = null;
	private JComboBoxSearchPattern jComboBoxCatalog = null;
	private JComboBoxSearchPattern jComboBoxSchemaPattern = null;
	private JComboBoxSearchPattern jComboBoxTypeNamePattern = null;
	private JComboBoxSearchPattern jComboBoxTypes = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JButton jButtonSearch = null;

	private DatabaseMetaData dmd;
	private JPanel jPanelProcedureColumns = null;
	private JPanel jPanelProcedureColumnsSearch = null;
	private JScrollPane jScrollPaneProcedureColumns = null;
	private JTable jTableProcedureColumns = null;
	private JLabel jLabel4 = null;
	private JLabel jLabel5 = null;
	private JLabel jLabel6 = null;
	private JLabel jLabel7 = null;
	private JComboBoxSearchPattern jComboBoxColumnNamePattern2 = null;
	private JComboBoxSearchPattern jComboBoxProcedureNamePattern2 = null;
	private JButton jButtonSearch2 = null;
	private JComboBoxSearchPattern jComboBoxCatalog2 = null;
	private JComboBoxSearchPattern jComboBoxSchemaPattern2 = null;
	private JPanel jPanelProcedures = null;
	private JPanel jPanelProceduresSearch = null;
	private JScrollPane jScrollPaneProcedures = null;
	private JTable jTableProcedures = null;
	private JLabel jLabel8 = null;
	private JLabel jLabel9 = null;
	private JLabel jLabel10 = null;
	private JComboBoxSearchPattern jComboBoxCatalog3 = null;
	private JComboBoxSearchPattern jComboBoxProcedureNamePattern3 = null;
	private JComboBoxSearchPattern jComboBoxSchemaPattern3 = null;
	private JButton jButtonSearch3 = null;
	private JPanel jPanelSuperTypes = null;
	private JPanel jPanelAttributes = null;
	private JPanel jPanelSuperTypesSearch = null;
	private JPanel jPanelAttributesSearch = null;
	private JScrollPane jScrollPaneSuperTypes = null;
	private JTable jTableSuperTypes = null;
	private JScrollPane jScrollPaneAttributes = null;
	private JTable jTableAttributes = null;
	private JLabel jLabel11 = null;
	private JLabel jLabel111 = null;
	private JComboBoxSearchPattern jComboBoxCatalog4 = null;
	private JComboBoxSearchPattern jComboBoxCatalog5 = null;
	private JLabel jLabel12 = null;
	private JLabel jLabel13 = null;
	private JComboBoxSearchPattern jComboBoxSchemaPattern4 = null;
	private JComboBoxSearchPattern jComboBoxSchemaPattern5 = null;
	private JLabel jLabel21 = null;
	private JComboBoxSearchPattern jComboBoxTypeNamePattern5 = null;
	private JLabel jLabel23 = null;
	private JComboBoxSearchPattern jComboBoxTypeNamePattern4 = null;
	private JButton jButtonSearch5 = null;
	private JButton jButtonSearch4 = null;
	private JLabel jLabel14 = null;
	private JComboBoxSearchPattern jComboBoxAttributeNamePattern4 = null;
	private JScrollPane jScrollPaneCatalogs = null;
	private JTable jTableCatalogs = null;
	private JTable jTableSchemas = null;
	private JScrollPane jScrollPaneSchemas = null;
	private JPanel jPanelTables = null;
	private JScrollPane jScrollPaneTables = null;
	private JTable jTableTables = null;
	private JPanel jPanelTablesSearch = null;
	private JLabel jLabel15 = null;
	private JComboBoxSearchPattern jComboBoxCatalog1 = null;
	private JLabel jLabel16 = null;
	private JComboBoxSearchPattern jComboBoxSchemaPattern1 = null;
	private JLabel jLabel22 = null;
	private JComboBoxSearchPattern jComboBoxTableNamePattern1 = null;
	private JLabel jLabel31 = null;
	private JComboBoxSearchPattern jComboBoxTypes1 = null;
	private JButton jButtonSearch1 = null;
	private JPanel jPanelColumns = null;
	private JPanel jPanelColumnsSearch = null;
	private JScrollPane jScrollPaneColumns = null;
	private JTable jTableColumns = null;
	private JComboBoxSearchPattern jComboBoxSchemaPattern6 = null;
	private JComboBoxSearchPattern jComboBoxColumnNamePattern6 = null;
	private JLabel jLabel151 = null;
	private JLabel jLabel161 = null;
	private JLabel jLabel311 = null;
	private JButton jButtonSearch6 = null;
	private JComboBoxSearchPattern jComboBoxCatalog6 = null;
	private JComboBoxSearchPattern jComboBoxTableNamePattern6 = null;
	private JLabel jLabel221 = null;
	/**
	 * 
	 */
	public JPanelDatabaseMetaData() {
		// TODO 自動生成されたコンストラクター・スタブ
		super();
		initialize();
		CellRendererDatabaseMetaData crdmd = new CellRendererDatabaseMetaData();
		
		jTableReturn.setDefaultRenderer(Object.class, crdmd);
		jTableCatalogs.setDefaultRenderer(Object.class, crdmd);
		jTableSchemas.setDefaultRenderer(Object.class, crdmd);
		jTableTables.setDefaultRenderer(Object.class, crdmd);
		jTableColumns.setDefaultRenderer(Object.class, crdmd);
		jTableTableTypes.setDefaultRenderer(Object.class, crdmd);
		jTableTypeInfo.setDefaultRenderer(Object.class, crdmd);
		jTableUDTs.setDefaultRenderer(Object.class, crdmd);
		jTableSuperTypes.setDefaultRenderer(Object.class, crdmd);
		jTableAttributes.setDefaultRenderer(Object.class, crdmd);
		jTableProcedures.setDefaultRenderer(Object.class, crdmd);
		jTableProcedureColumns.setDefaultRenderer(Object.class, crdmd);
	}
	
	public void setData(DatabaseMetaData dmd){
		this.dmd = dmd;
		
		setReturn(dmd);
		setCatalogs(dmd);
		setSchemas(dmd);
		setTables(null);
		setTableTypes(dmd);
		setTypeInfo(dmd);
		setUDTs(null);
		setSuperTypes(null);
		setAttributes(null);
		setProcedures(null);
		setProcedureColumns(null);
		
	}

	private void setReturn(DatabaseMetaData dmd){
		DefaultTableModel tm = new DefaultTableModel(new String[]{"               method               ","     return value     "},0);
		
		Vector<Object> rowData;

		/*	雛型
		rowData = new Vector<Object>();
		rowData.add("xxx");
		try { rowData.add(dmd.xxx);
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		 */
		
		String[] sepa = {"",""};

		rowData = new Vector<Object>();
		rowData.add("allTablesAreSelectable()");
		try { rowData.add(dmd.allTablesAreSelectable());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getURL()");
		try { rowData.add(dmd.getURL());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getUserName()");
		try { rowData.add(dmd.getUserName());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("isReadOnly()");
		try { rowData.add(dmd.isReadOnly());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa);

		rowData = new Vector<Object>();
		rowData.add("getDatabaseProductName()");
		try { rowData.add(dmd.getDatabaseProductName() );
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getDatabaseProductVersion()");
		try { rowData.add(dmd.getDatabaseProductVersion() );
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getDriverName()");
		try { rowData.add(dmd.getDriverName() );
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getDriverVersion()");
		try { rowData.add(dmd.getDriverVersion() );
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getDriverMajorVersion()");
		try { rowData.add(dmd.getDriverMajorVersion());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa);
		
		rowData = new Vector<Object>();
		rowData.add("supportsANSI92EntryLevelSQL()");
		try { rowData.add(dmd.supportsANSI92EntryLevelSQL());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsANSI92IntermediateSQL()");
		try { rowData.add(dmd.supportsANSI92IntermediateSQL());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsANSI92FullSQL()");
		try { rowData.add(dmd.supportsANSI92FullSQL());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsIntegrityEnhancementFacility()");
		try { rowData.add(dmd.supportsIntegrityEnhancementFacility());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsMinimumSQLGrammar()");
		try { rowData.add(dmd.supportsMinimumSQLGrammar());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsCoreSQLGrammar()");
		try { rowData.add(dmd.supportsCoreSQLGrammar());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsExtendedSQLGrammar()");
		try { rowData.add(dmd.supportsExtendedSQLGrammar());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa);
		
		rowData = new Vector<Object>();
		rowData.add("getSQLKeywords()");
		try { rowData.add(dmd.getSQLKeywords());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getNumericFunctions()");
		try { rowData.add(dmd.getNumericFunctions());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getStringFunctions()");
		try { rowData.add(dmd.getStringFunctions());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getSystemFunctions()");
		try { rowData.add(dmd.getSystemFunctions());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getTimeDateFunctions()");
		try { rowData.add(dmd.getTimeDateFunctions());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsConvert()");
		try { rowData.add(dmd.supportsConvert());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

//		rowData = new Vector<Object>();
//		rowData.add("supportsConvert(");
//		try { rowData.add(dmd.supportsConvert();
//		} catch (Exception e) {	rowData.add(e.toString());}
//		tm.addRow(rowData);

		tm.addRow(sepa);
		
		rowData = new Vector<Object>();
		rowData.add("supportsExpressionsInOrderBy()");
		try { rowData.add(dmd.supportsExpressionsInOrderBy());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsOrderByUnrelated()");
		try { rowData.add(dmd.supportsOrderByUnrelated());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsGroupBy()");
		try { rowData.add(dmd.supportsGroupBy());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsGroupByUnrelated()");
		try { rowData.add(dmd.supportsGroupByUnrelated());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsGroupByBeyondSelect()");
		try { rowData.add(dmd.supportsGroupByBeyondSelect());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsUnion()");
		try { rowData.add(dmd.supportsUnion());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsUnionAll()");
		try { rowData.add(dmd.supportsUnionAll());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa);
		
		rowData = new Vector<Object>();
		rowData.add("supportsLikeEscapeClause()");
		try { rowData.add(dmd.supportsLikeEscapeClause());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getSearchStringEscape()");
		try { rowData.add(dmd.getSearchStringEscape());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa);
		
		rowData = new Vector<Object>();
		rowData.add("supportsMixedCaseIdentifiers()");
		try { rowData.add(dmd.supportsMixedCaseIdentifiers());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("storesUpperCaseIdentifiers()");
		try { rowData.add(dmd.storesUpperCaseIdentifiers());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("storesLowerCaseIdentifiers()");
		try { rowData.add(dmd.storesLowerCaseIdentifiers());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("storesMixedCaseIdentifiers()");
		try { rowData.add(dmd.storesMixedCaseIdentifiers());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsMixedCaseQuotedIdentifiers()");
		try { rowData.add(dmd.supportsMixedCaseQuotedIdentifiers());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("storesUpperCaseQuotedIdentifiers()");
		try { rowData.add(dmd.storesUpperCaseQuotedIdentifiers());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("storesLowerCaseQuotedIdentifiers()");
		try { rowData.add(dmd.storesLowerCaseQuotedIdentifiers());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("storesMixedCaseQuotedIdentifiers()");
		try { rowData.add(dmd.storesMixedCaseQuotedIdentifiers());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getIdentifierQuoteString()");
		try { rowData.add(dmd.getIdentifierQuoteString());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getSearchStringEscape()");
		try { rowData.add(dmd.getSearchStringEscape());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getExtraNameCharacters()");
		try { rowData.add(dmd.getExtraNameCharacters());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa);
		
		rowData = new Vector<Object>();
		rowData.add("supportsNonNullableColumns()");
		try { rowData.add(dmd.supportsNonNullableColumns());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("nullPlusNonNullIsNull()");
		try { rowData.add(dmd.nullPlusNonNullIsNull());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("nullsAreSortedHigh()");
		try { rowData.add(dmd.nullsAreSortedHigh());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("nullsAreSortedLow()");
		try { rowData.add(dmd.nullsAreSortedLow());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("nullsAreSortedAtStart() ");
		try { rowData.add(dmd.nullsAreSortedAtStart() );
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("nullsAreSortedAtEnd() ");
		try { rowData.add(dmd.nullsAreSortedAtEnd() );
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa); // エイリアス
		
		rowData = new Vector<Object>();
		rowData.add("supportsColumnAliasing()");
		try { rowData.add(dmd.supportsColumnAliasing());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsTableCorrelationNames()");
		try { rowData.add(dmd.supportsTableCorrelationNames());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsDifferentTableCorrelationNames()");
		try { rowData.add(dmd.supportsDifferentTableCorrelationNames());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa); // サブクエリー

		rowData = new Vector<Object>();
		rowData.add("supportsSubqueriesInComparisons()");
		try { rowData.add(dmd.supportsSubqueriesInComparisons());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsSubqueriesInExists()");
		try { rowData.add(dmd.supportsSubqueriesInExists());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsSubqueriesInIns()");
		try { rowData.add(dmd.supportsSubqueriesInIns());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsSubqueriesInQuantifieds()");
		try { rowData.add(dmd.supportsSubqueriesInQuantifieds());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsCorrelatedSubqueries()");
		try { rowData.add(dmd.supportsCorrelatedSubqueries());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa); // 外部結合

		rowData = new Vector<Object>();
		rowData.add("supportsOuterJoins()");
		try { rowData.add(dmd.supportsOuterJoins());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsFullOuterJoins()");
		try { rowData.add(dmd.supportsFullOuterJoins());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsLimitedOuterJoins()");
		try { rowData.add(dmd.supportsLimitedOuterJoins());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa); // ストアードプロシージャ

		rowData = new Vector<Object>();
		rowData.add("supportsMultipleResultSets()");
		try { rowData.add(dmd.supportsMultipleResultSets());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsStoredProcedures()");
		try { rowData.add(dmd.supportsStoredProcedures());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa); // テーブルスキーマの変更

		rowData = new Vector<Object>();
		rowData.add("supportsAlterTableWithAddColumn()");
		try { rowData.add(dmd.supportsAlterTableWithAddColumn());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsAlterTableWithDropColumn()");
		try { rowData.add(dmd.supportsAlterTableWithDropColumn());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa); // 位置付データ更新

		rowData = new Vector<Object>();
		rowData.add("supportsPositionedDelete()");
		try { rowData.add(dmd.supportsPositionedDelete());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsPositionedUpdate()");
		try { rowData.add(dmd.supportsPositionedUpdate());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsSelectForUpdate()");
		try { rowData.add(dmd.supportsSelectForUpdate());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa); // トランザクション

		rowData = new Vector<Object>();
		rowData.add("getDefaultTransactionIsolation()");
		try { rowData.add(dmd.getDefaultTransactionIsolation());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsTransactions()");
		try { rowData.add(dmd.supportsTransactions());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsTransactionIsolationLevel(Connection.TRANSACTION_NONE)");
		try { rowData.add(dmd.supportsTransactionIsolationLevel(Connection.TRANSACTION_NONE));
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsTransactionIsolationLevel(Connection.TRANSACTION_READ_COMMITTED)");
		try { rowData.add(dmd.supportsTransactionIsolationLevel(Connection.TRANSACTION_READ_COMMITTED));
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsTransactionIsolationLevel(Connection.TRANSACTION_READ_UNCOMMITTED)");
		try { rowData.add(dmd.supportsTransactionIsolationLevel(Connection.TRANSACTION_READ_UNCOMMITTED));
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsTransactionIsolationLevel(Connection.TRANSACTION_REPEATABLE_READ)");
		try { rowData.add(dmd.supportsTransactionIsolationLevel(Connection.TRANSACTION_REPEATABLE_READ));
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsTransactionIsolationLevel(Connection.TRANSACTION_SERIALIZABLE)");
		try { rowData.add(dmd.supportsTransactionIsolationLevel(Connection.TRANSACTION_SERIALIZABLE));
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsDataDefinitionAndDataManipulationTransactions()");
		try { rowData.add(dmd.supportsDataDefinitionAndDataManipulationTransactions());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsDataManipulationTransactionsOnly()");
		try { rowData.add(dmd.supportsDataManipulationTransactionsOnly());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("dataDefinitionCausesTransactionCommit()");
		try { rowData.add(dmd.dataDefinitionCausesTransactionCommit());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("dataDefinitionIgnoredInTransactions()");
		try { rowData.add(dmd.dataDefinitionIgnoredInTransactions());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsOpenCursorsAcrossCommit()");
		try { rowData.add(dmd.supportsOpenCursorsAcrossCommit());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsOpenCursorsAcrossRollback()");
		try { rowData.add(dmd.supportsOpenCursorsAcrossRollback());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsOpenStatementsAcrossCommit()");
		try { rowData.add(dmd.supportsOpenStatementsAcrossCommit());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsOpenStatementsAcrossRollback()");
		try { rowData.add(dmd.supportsOpenStatementsAcrossRollback());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("supportsMultipleResultSets()");
		try { rowData.add(dmd.supportsMultipleResultSets());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		tm.addRow(sepa); // 制限事項

		rowData = new Vector<Object>();
		rowData.add("getMaxConnections()");
		try { rowData.add(dmd.getMaxConnections());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxStatements()");
		try { rowData.add(dmd.getMaxStatements());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxCatalogNameLength()");
		try { rowData.add(dmd.getMaxCatalogNameLength());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxUserNameLength()");
		try { rowData.add(dmd.getMaxUserNameLength());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxSchemaNameLength()");
		try { rowData.add(dmd.getMaxSchemaNameLength());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxTableNameLength()");
		try { rowData.add(dmd.getMaxTableNameLength());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxColumnNameLength()");
		try { rowData.add(dmd.getMaxColumnNameLength());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxCursorNameLength()");
		try { rowData.add(dmd.getMaxCursorNameLength());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxProcedureNameLength()");
		try { rowData.add(dmd.getMaxProcedureNameLength());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxStatementLength()");
		try { rowData.add(dmd.getMaxStatementLength());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxBinaryLiteralLength()");
		try { rowData.add(dmd.getMaxBinaryLiteralLength());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxCharLiteralLength()");
		try { rowData.add(dmd.getMaxCharLiteralLength());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxTablesInSelect()");
		try { rowData.add(dmd.getMaxTablesInSelect());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxColumnsInTable()");
		try { rowData.add(dmd.getMaxColumnsInTable());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxColumnsInSelect()");
		try { rowData.add(dmd.getMaxColumnsInSelect());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxColumnsInOrderBy()");
		try { rowData.add(dmd.getMaxColumnsInOrderBy());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxColumnsInGroupBy()");
		try { rowData.add(dmd.getMaxColumnsInGroupBy());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxColumnsInIndex()");
		try { rowData.add(dmd.getMaxColumnsInIndex());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxRowSize()");
		try { rowData.add(dmd.getMaxRowSize());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("doesMaxRowSizeIncludeBlobs()");
		try { rowData.add(dmd.doesMaxRowSizeIncludeBlobs());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getMaxIndexLength()");
		try { rowData.add(dmd.getMaxIndexLength());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

/////////		
		tm.addRow(sepa);
		
		rowData = new Vector<Object>();
		rowData.add("isCatalogAtStart()");
		try { rowData.add(dmd.isCatalogAtStart());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		rowData = new Vector<Object>();
		rowData.add("getCatalogSeparator()");
		try { rowData.add(dmd.getCatalogSeparator());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("supportsCatalogsInDataManipulation()");
		try { rowData.add(dmd.supportsCatalogsInDataManipulation());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("supportsCatalogsInProcedureCalls()");
		try { rowData.add(dmd.supportsCatalogsInProcedureCalls());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("supportsCatalogsInTableDefinitions()");
		try { rowData.add(dmd.supportsCatalogsInTableDefinitions());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("supportsCatalogsInIndexDefinitions()");
		try { rowData.add(dmd.supportsCatalogsInIndexDefinitions());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("supportsCatalogsInPrivilegeDefinitions()");
		try { rowData.add(dmd.supportsCatalogsInPrivilegeDefinitions());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		tm.addRow(sepa);

		rowData = new Vector<Object>();
		rowData.add("supportsSchemasInDataManipulation()");
		try { rowData.add(dmd.supportsSchemasInDataManipulation());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("supportsSchemasInProcedureCalls()");
		try { rowData.add(dmd.supportsSchemasInProcedureCalls());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("supportsSchemasInTableDefinitions()");
		try { rowData.add(dmd.supportsSchemasInTableDefinitions());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("supportsSchemasInIndexDefinitions()");
		try { rowData.add(dmd.supportsSchemasInIndexDefinitions());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("supportsSchemasInPrivilegeDefinitions()");
		try { rowData.add(dmd.supportsSchemasInDataManipulation());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		tm.addRow(sepa);
		
		rowData = new Vector<Object>();
		rowData.add("getSchemaTerm()");
		try { rowData.add(dmd.getSchemaTerm());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("getProcedureTerm()");
		try { rowData.add(dmd.getProcedureTerm());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("getCatalogTerm()");
		try { rowData.add(dmd.getCatalogTerm());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("usesLocalFiles()");
		try { rowData.add(dmd.usesLocalFiles());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);
		
		rowData = new Vector<Object>();
		rowData.add("usesLocalFilePerTable()");
		try { rowData.add(dmd.usesLocalFilePerTable());
		} catch (Exception e) {	rowData.add(e.toString());}
		tm.addRow(rowData);

		
		
		jTableReturn.setModel(tm);		
		ColumnWidth.setHeaderWidthResizeOff(jTableReturn,10);
	}

	private void setTableTypes(DatabaseMetaData dmd) {
		DefaultTableModel tm = new DefaultTableModel(new String[] { "TABLE_TYPE" }, 0);

		jTableTableTypes.setModel(tm);
		ColumnWidth.setHeaderWidthResizeOff(jTableTableTypes,10);

		if (dmd == null) {
			return;
		}


		ResultSet rs = null;
		try {
			rs = dmd.getTableTypes();
			while (rs.next()) {

				Vector<Object> rowData = new Vector<Object>();
				
				try {rowData.add(rs.getString(1));
				} catch (Exception e) {	rowData.add(e.toString());}

				tm.addRow(rowData);

			}
		} catch (Exception e1) {
			JDialogMessage.errorDialog( e1);
		} finally {
			if (rs != null) {
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}

	}

	private void setTypeInfo(DatabaseMetaData dmd) {
		DefaultTableModel tm = new DefaultTableModel(new String[] { "TYPE_NAME",
				"DATA_TYPE",
				"PRECISION",
				"LITERAL_PREFIX",
				"LITERAL_SUFFIX",
				"CREATE_PARAMS",
				"NULLABLE",
				"CASE_SENSITIVE",
				"SEARCHABLE",
				"UNSIGNED_ATTRIBUTE",
				"FIXED_PREC_SCALE",
				"AUTO_INCREMENT",
				"LOCAL_TYPE_NAME",
				"MINIMUM_SCALE",
				"MAXIMUM_SCALE",
				"SQL_DATA_TYPE",
				"SQL_DATETIME_SUB",
				"NUM_PREC_RADIX" }, 0);

		jTableTypeInfo.setModel(tm);
		ColumnWidth.setHeaderWidthResizeOff(jTableTypeInfo,10);

		if (dmd == null) {
			return;
		}


		ResultSet rs = null;
		try {
			rs = dmd.getTypeInfo();
			while (rs.next()) {

				Vector<Object> rowData = new Vector<Object>();
				
				for(int i=1 ; i < tm.getColumnCount()+1 ; i++){
					try {rowData.add(rs.getObject(i));
					} catch (Exception e) {	rowData.add(e.toString());}
				}

				tm.addRow(rowData);

			}
		} catch (Exception e1) {
			JDialogMessage.errorDialog( e1);
		} finally {
			if (rs != null) {
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}
	}

	private void setCatalogs(DatabaseMetaData dmd) {
		DefaultTableModel tm = new DefaultTableModel(new String[] { "TABLE_CAT" }, 0);

		jTableCatalogs.setModel(tm);
		ColumnWidth.setHeaderWidthResizeOff(jTableCatalogs,10);

		if (dmd == null) {
			return;
		}


		ResultSet rs = null;
		try {
			rs = dmd.getCatalogs();
			while (rs.next()) {

				Vector<Object> rowData = new Vector<Object>();
				
				for(int i=1 ; i < tm.getColumnCount()+1 ; i++){
					try {rowData.add(rs.getObject(i));
					} catch (Exception e) {	rowData.add(e.toString());}
				}

				tm.addRow(rowData);

			}
		} catch (Exception e1) {
			JDialogMessage.errorDialog( e1);
		} finally {
			if (rs != null) {
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}
	}

	private void setSchemas(DatabaseMetaData dmd) {
		DefaultTableModel tm = new DefaultTableModel(new String[] { "TABLE_SCHEM","TABLE_CATALOG" }, 0);

		jTableSchemas.setModel(tm);
		ColumnWidth.setHeaderWidthResizeOff(jTableSchemas,10);

		if (dmd == null) {
			return;
		}


		ResultSet rs = null;
		try {
			rs = dmd.getSchemas();
			while (rs.next()) {

				Vector<Object> rowData = new Vector<Object>();
				
				for(int i=1 ; i < tm.getColumnCount()+1 ; i++){
					try {rowData.add(rs.getObject(i));
					} catch (Exception e) {	rowData.add(e.toString());}
				}

				tm.addRow(rowData);

			}
		} catch (Exception e1) {
			JDialogMessage.errorDialog( e1);
		} finally {
			if (rs != null) {
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}
	}

	private void setTables(DatabaseMetaData dmd) {
		DefaultTableModel tm = new DefaultTableModel(new String[]{"TABLE_CAT","TABLE_SCHEM","TABLE_NAME","TABLE_TYPE","REMARK","TYPE_CAT","TYPE_SCHEM","TYPE_NAME","SELF_REFERENCING_COL_NAME","REF_GENERATION"},0);
		
		jTableTables.setModel(tm);
		ColumnWidth.setHeaderWidthResizeOff(jTableTables,10);
		
		if (dmd==null){
			return;
		}
	
		String catalog = jComboBoxCatalog1.getValue();
        String schemaPattern = jComboBoxSchemaPattern1.getValue();
        String tableNamePattern = jComboBoxTableNamePattern1.getValue();
        String[] types = null;
        
		ResultSet rs=null;
		try {
			rs = dmd.getTables(catalog, schemaPattern, tableNamePattern, types);
			while (rs.next()){
				
				Vector<Object> rowData = new Vector<Object>();
				
				for(int i=1 ; i < tm.getColumnCount()+1 ; i++){
					try {rowData.add(rs.getObject(i));
					} catch (Exception e) {	rowData.add(e.toString());}
				}


				tm.addRow(rowData);
				
			}
		} catch (Exception e1) {
			JDialogMessage.errorDialog( e1);
		}finally{
			if (rs!=null){
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}

	}

	private void setColumns(DatabaseMetaData dmd) {
		DefaultTableModel tm = new DefaultTableModel(new String[]{
				"TABLE_CAT",
				"TABLE_SCHEM",
				"TABLE_NAME",
				"COLUMN_NAME",
				"DATA_TYPE",
				"TYPE_NAME",
				"COLUMN_SIZE",
				"BUFFER_LENGTH",
				"DECIMAL_DIGITS",
				"NUM_PREC_RADIX",
				"NULLABLE",
				"REMARKS",
				"COLUMN_DEF",
				"SQL_DATA_TYPE",
				"SQL_DATETIME_SUB",
				"CHAR_OCTET_LENGTH",
				"ORDINAL_POSITION",
				"IS_NULLABLE",
				"SCOPE_CATLOG",
				"SCOPE_SCHEMA",
				"SCOPE_TABLE",
				"SOURCE_DATA_TYPE",
				},0);
		
		jTableColumns.setModel(tm);
		ColumnWidth.setHeaderWidthResizeOff(jTableColumns,10);
		
		if (dmd==null){
			return;
		}
	
		String catalog = jComboBoxCatalog6.getValue();
        String schemaPattern = jComboBoxSchemaPattern6.getValue();
        String tableNamePattern = jComboBoxTableNamePattern6.getValue();
        String columnNamePattern = jComboBoxColumnNamePattern6.getValue();
        
		ResultSet rs=null;
		try {
			rs = dmd.getColumns(catalog, schemaPattern, tableNamePattern, columnNamePattern);
			while (rs.next()){
				
				Vector<Object> rowData = new Vector<Object>();
				
				for(int i=1 ; i < tm.getColumnCount()+1 ; i++){
					try {rowData.add(rs.getObject(i));
					} catch (Exception e) {	rowData.add(e.toString());}
				}


				tm.addRow(rowData);
				
			}
		} catch (Exception e1) {
			JDialogMessage.errorDialog( e1);
		}finally{
			if (rs!=null){
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}

	}

	private void setUDTs(DatabaseMetaData dmd) {
		DefaultTableModel tm = new DefaultTableModel(new String[]{"TYPE_CAT","TYPE_SCHEM","TYPE_NAME","CLASS_NAME","DATA_TYPE","REMARK"},0);
		
		jTableUDTs.setModel(tm);
		ColumnWidth.setHeaderWidthResizeOff(jTableUDTs,10);
		
		if (dmd==null){
			return;
		}
	
		String catalog = jComboBoxCatalog.getValue();
        String schemaPattern = jComboBoxSchemaPattern.getValue();
        String typeNamePattern = jComboBoxTypeNamePattern.getValue();
        int[] types = null;
        
		ResultSet rs=null;
		try {
			rs = dmd.getUDTs(catalog, schemaPattern, typeNamePattern, types);
			while (rs.next()){
				
				Vector<Object> rowData = new Vector<Object>();
				
				for(int i=1 ; i < tm.getColumnCount()+1 ; i++){
					try {rowData.add(rs.getObject(i));
					} catch (Exception e) {	rowData.add(e.toString());}
				}


				tm.addRow(rowData);
				
			}
		} catch (Exception e1) {
			JDialogMessage.errorDialog( e1);
		}finally{
			if (rs!=null){
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}

	}

	private void setSuperTypes(DatabaseMetaData dmd) {
		DefaultTableModel tm = new DefaultTableModel(new String[]{"TYPE_CAT","TYPE_SCHEM","TYPE_NAME","SUPERTYPE_CAT","SUPERTYPE_SCHEM","SUPERTYPE_NAME",},0);
		
		jTableSuperTypes.setModel(tm);
		ColumnWidth.setHeaderWidthResizeOff(jTableSuperTypes,10);
		
		if (dmd==null){
			return;
		}
	
		String catalog = jComboBoxCatalog5.getValue();
        String schemaPattern = jComboBoxSchemaPattern5.getValue();
        String typeNamePattern = jComboBoxTypeNamePattern5.getValue();
        
		ResultSet rs=null;
		try {
			rs = dmd.getSuperTypes(catalog, schemaPattern, typeNamePattern);
			while (rs.next()){
				
				Vector<Object> rowData = new Vector<Object>();
				
				for(int i=1 ; i < tm.getColumnCount()+1 ; i++){
					try {rowData.add(rs.getObject(i));
					} catch (Exception e) {	rowData.add(e.toString());}
				}


				tm.addRow(rowData);
				
			}
		} catch (Exception e1) {
			JDialogMessage.errorDialog( e1);
		}finally{
			if (rs!=null){
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}

	}

	private void setAttributes(DatabaseMetaData dmd) {
		DefaultTableModel tm = new DefaultTableModel(new String[]{"TYPE_CAT",
				"TYPE_SCHEM",
				"TYPE_NAME",
				"ATTR_NAME",
				"DATA_TYPE",
				"ATTR_TYPE_NAME",
				"ATTR_SIZE",
				"DECIMAL_DIGITS",
				"NUM_PREC_RADIX",
				"NULLABLE",
				"REMARKS",
				"ATTR_DEF",
				"SQL_DATA_TYPE",
				"SQL_DATETIME_SUB",
				"CHAR_OCTET_LENGTH",
				"ORDINAL_POSITION",
				"IS_NULLABLE",
				"SCOPE_CATALOG",
				"SCOPE_SCHEMA",
				"SCOPE_TABLE",
				"SOURCE_DATA_TYPE"},0);
		
		jTableAttributes.setModel(tm);
		ColumnWidth.setHeaderWidthResizeOff(jTableAttributes,10);
		
		if (dmd==null){
			return;
		}
	
		String catalog = jComboBoxCatalog4.getValue();
        String schemaPattern = jComboBoxSchemaPattern4.getValue();
        String typeNamePattern = jComboBoxTypeNamePattern4.getValue();
        String attributeNamePattern = jComboBoxAttributeNamePattern4.getValue();
        
		ResultSet rs=null;
		try {
			rs = dmd.getAttributes(catalog, schemaPattern, typeNamePattern, attributeNamePattern);
			while (rs.next()){
				
				Vector<Object> rowData = new Vector<Object>();
				
				for(int i=1 ; i < tm.getColumnCount()+1 ; i++){
					try {rowData.add(rs.getObject(i));
					} catch (Exception e) {	rowData.add(e.toString());}
				}


				tm.addRow(rowData);
				
			}
		} catch (Exception e1) {
			JDialogMessage.errorDialog( e1);
		}finally{
			if (rs!=null){
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}

	}

	private void setProcedures(DatabaseMetaData dmd) {
		DefaultTableModel tm = new DefaultTableModel(new String[]{
				"PROCEDURE_CAT","PROCEDURE_SCHEM","PROCEDURE_NAME",
				"","","","REMARKS","PROCEDURE_TYPE"},0);
		
		jTableProcedures.setModel(tm);
		ColumnWidth.setHeaderWidthResizeOff(jTableProcedures,10);
		
		if (dmd==null){
			return;
		}
	
		String catalog = jComboBoxCatalog3.getValue();
        String schemaPattern = jComboBoxSchemaPattern3.getValue();
        String procedureNamePattern = jComboBoxProcedureNamePattern3.getValue();
        
		ResultSet rs=null;
		try {
			rs = dmd.getProcedures(catalog, schemaPattern, procedureNamePattern);
			while (rs.next()){
				
				Vector<Object> rowData = new Vector<Object>();
				
				for(int i=1 ; i < tm.getColumnCount()+1 ; i++){
					try {rowData.add(rs.getObject(i));
					} catch (Exception e) {	rowData.add(e.toString());}
				}


				tm.addRow(rowData);
				
			}
		} catch (Exception e1) {
			JDialogMessage.errorDialog( e1);
		}finally{
			if (rs!=null){
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}

	}

	private void setProcedureColumns(DatabaseMetaData dmd) {
		DefaultTableModel tm = new DefaultTableModel(new String[]{
				"PROCEDURE_CAT","PROCEDURE_SCHEM","PROCEDURE_NAME",
				"COLUMN_NAME","COLUMN_TYPE","DATA_TYPE","TYPE_NAME",
				"PRECISION","LENGTH","SCALE","RADIX","NULLABLE",
				"REMARK"},0);
		
		jTableProcedureColumns.setModel(tm);
		ColumnWidth.setHeaderWidthResizeOff(jTableProcedureColumns,10);
		
		if (dmd==null){
			return;
		}
	
		String catalog = jComboBoxCatalog2.getValue();
        String schemaPattern = jComboBoxSchemaPattern2.getValue();
        String procedureNamePattern = jComboBoxProcedureNamePattern2.getValue();
        String columnNamePattern = jComboBoxColumnNamePattern2.getValue();
        
		ResultSet rs=null;
		try {
			rs = dmd.getProcedureColumns(catalog, schemaPattern, procedureNamePattern, columnNamePattern);
			while (rs.next()){
				
				Vector<Object> rowData = new Vector<Object>();
				
				for(int i=1 ; i < tm.getColumnCount()+1 ; i++){
					try {rowData.add(rs.getObject(i));
					} catch (Exception e) {	rowData.add(e.toString());}
				}


				tm.addRow(rowData);
				
			}
		} catch (Exception e1) {
			JDialogMessage.errorDialog( e1);
		}finally{
			if (rs!=null){
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}

	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(568, 322);
		this.setLayout(new BorderLayout());
		setName("DatabaseMetaData");
		add(getJTabbedPane());
	}

	/**
	 * This method initializes jTabbedPane	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.addTab("ret", null, getJScrollPaneRet(), null);
			jTabbedPane.addTab("getCatalogs()", null, getJScrollPaneCatalogs(), null);
			jTabbedPane.addTab("getSchemas()", null, getJScrollPaneSchemas(), null);
			jTabbedPane.addTab("getTables()", null, getJPanelTables(), null);
			jTabbedPane.addTab("getColumns()", null, getJPanelColumns(), null);
			jTabbedPane.addTab("getTableTypes()", null, getJScrollPaneTableTypes(), null);
			jTabbedPane.addTab("getTypeInfo()", null, getJScrollPaneTypeInfo(), null);
			jTabbedPane.addTab("getUDTs()", null, getJPanelUDTs(), null);
			jTabbedPane.addTab("getSuperTypes()", null, getJPanelSuperTypes(), null);
			jTabbedPane.addTab("getAttributes()", null, getJPanelAttributes(), null);
			jTabbedPane.addTab("getProcedures()", null, getJPanelProcedures(), null);
			jTabbedPane.addTab("getProcedureColumns()", null, getJPanelProcedureColumns(), null);
		}
		return jTabbedPane;
	}

	/**
	 * This method initializes jScrollPaneRet	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneRet() {
		if (jScrollPaneRet == null) {
			jScrollPaneRet = new JScrollPane();
			jScrollPaneRet.setViewportView(getJTableReturn());
		}
		return jScrollPaneRet;
	}

	/**
	 * This method initializes jTableTables	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableReturn() {
		if (jTableReturn == null) {
			jTableReturn = new JTable();
			jTableReturn.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTableReturn;
	}

	/**
	 * This method initializes jScrollPaneTableTypes	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneTableTypes() {
		if (jScrollPaneTableTypes == null) {
			jScrollPaneTableTypes = new JScrollPane();
			jScrollPaneTableTypes.setViewportView(getJTableTableTypes());
		}
		return jScrollPaneTableTypes;
	}

	/**
	 * This method initializes jTable1	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableTableTypes() {
		if (jTableTableTypes == null) {
			jTableTableTypes = new JTable();
			jTableTableTypes.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTableTableTypes;
	}

	/**
	 * This method initializes jScrollPaneTypeInfo	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneTypeInfo() {
		if (jScrollPaneTypeInfo == null) {
			jScrollPaneTypeInfo = new JScrollPane();
			jScrollPaneTypeInfo.setViewportView(getJTableTypeInfo());
		}
		return jScrollPaneTypeInfo;
	}

	/**
	 * This method initializes jTable2	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableTypeInfo() {
		if (jTableTypeInfo == null) {
			jTableTypeInfo = new JTable();
			jTableTypeInfo.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTableTypeInfo;
	}

	/**
	 * This method initializes jScrollPaneUDTs	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneUDTs() {
		if (jScrollPaneUDTs == null) {
			jScrollPaneUDTs = new JScrollPane();
			jScrollPaneUDTs.setBorder(null);
			jScrollPaneUDTs.setViewportView(getJTableUDTs());
		}
		return jScrollPaneUDTs;
	}

	/**
	 * This method initializes jTable3	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableUDTs() {
		if (jTableUDTs == null) {
			jTableUDTs = new JTable();
			jTableUDTs.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTableUDTs;
	}

	/**
	 * This method initializes jPanelUDTs	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelUDTs() {
		if (jPanelUDTs == null) {
			jPanelUDTs = new JPanel();
			jPanelUDTs.setLayout(new BorderLayout());
			jPanelUDTs.add(getJPanelUDTsSearch(), BorderLayout.NORTH);
			jPanelUDTs.add(getJScrollPaneUDTs(), BorderLayout.CENTER);
		}
		return jPanelUDTs;
	}

	/**
	 * This method initializes jPanelUDTsSearch	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelUDTsSearch() {
		if (jPanelUDTsSearch == null) {
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.insets = new Insets(5, 3, 5, 164);
			gridBagConstraints8.gridy = 1;
			gridBagConstraints8.anchor = GridBagConstraints.WEST;
			gridBagConstraints8.gridx = 8;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints7.gridx = 3;
			gridBagConstraints7.gridy = 1;
			gridBagConstraints7.weightx = 1.0;
			gridBagConstraints7.anchor = GridBagConstraints.WEST;
			gridBagConstraints7.insets = new Insets(5, 3, 6, 2);
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.insets = new Insets(10, 3, 10, 2);
			gridBagConstraints6.gridy = 1;
			gridBagConstraints6.anchor = GridBagConstraints.EAST;
			gridBagConstraints6.gridx = 2;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints5.gridx = 1;
			gridBagConstraints5.gridy = 1;
			gridBagConstraints5.weightx = 1.0;
			gridBagConstraints5.anchor = GridBagConstraints.WEST;
			gridBagConstraints5.insets = new Insets(5, 3, 6, 2);
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.insets = new Insets(10, 3, 10, 2);
			gridBagConstraints4.gridy = 1;
			gridBagConstraints4.anchor = GridBagConstraints.EAST;
			gridBagConstraints4.gridx = 0;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints3.gridx = 3;
			gridBagConstraints3.gridy = 0;
			gridBagConstraints3.weightx = 1.0;
			gridBagConstraints3.anchor = GridBagConstraints.WEST;
			gridBagConstraints3.insets = new Insets(5, 3, 6, 2);
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.insets = new Insets(10, 3, 10, 2);
			gridBagConstraints2.gridy = 0;
			gridBagConstraints2.anchor = GridBagConstraints.EAST;
			gridBagConstraints2.gridx = 2;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints1.gridx = 1;
			gridBagConstraints1.gridy = 0;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.anchor = GridBagConstraints.WEST;
			gridBagConstraints1.insets = new Insets(5, 3, 6, 2);
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new Insets(10, 5, 10, 2);
			gridBagConstraints.gridy = 0;
			gridBagConstraints.anchor = GridBagConstraints.EAST;
			gridBagConstraints.gridx = 0;
			jLabel3 = new JLabel();
			jLabel3.setText("types:");
			jLabel2 = new JLabel();
			jLabel2.setText("typeNamePtn:");
			jLabel1 = new JLabel();
			jLabel1.setText("schemaPtn:");
			jLabel = new JLabel();
			jLabel.setText("catalog:");
			jPanelUDTsSearch = new JPanel();
			jPanelUDTsSearch.setBorder(BorderFactory.createTitledBorder(null, "\u5f15\u6570", TitledBorder.LEFT, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.PLAIN, 12), Color.black));
			jPanelUDTsSearch.setLayout(new GridBagLayout());
			jPanelUDTsSearch.add(jLabel, gridBagConstraints);
			jPanelUDTsSearch.add(getJComboBoxCatalog(), gridBagConstraints1);
			jPanelUDTsSearch.add(jLabel1, gridBagConstraints2);
			jPanelUDTsSearch.add(getJComboBoxSchemaPattern(), gridBagConstraints3);
			jPanelUDTsSearch.add(jLabel2, gridBagConstraints4);
			jPanelUDTsSearch.add(getJComboBoxTypeNamePattern(), gridBagConstraints5);
			jPanelUDTsSearch.add(jLabel3, gridBagConstraints6);
			jPanelUDTsSearch.add(getJComboBoxTypes(), gridBagConstraints7);
			jPanelUDTsSearch.add(getJButtonSearch(), gridBagConstraints8);
		}
		return jPanelUDTsSearch;
	}

	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBoxSearchPattern getJComboBoxCatalog() {
		if (jComboBoxCatalog == null) {
			jComboBoxCatalog = new JComboBoxSearchPattern();
		}
		return jComboBoxCatalog;
	}

	/**
	 * This method initializes jComboBox1	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBoxSearchPattern getJComboBoxSchemaPattern() {
		if (jComboBoxSchemaPattern == null) {
			jComboBoxSchemaPattern = new JComboBoxSearchPattern();
		}
		return jComboBoxSchemaPattern;
	}

	/**
	 * This method initializes jComboBox2	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBoxSearchPattern getJComboBoxTypeNamePattern() {
		if (jComboBoxTypeNamePattern == null) {
			jComboBoxTypeNamePattern = new JComboBoxSearchPattern();
		}
		return jComboBoxTypeNamePattern;
	}

	/**
	 * This method initializes jComboBox3	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBoxSearchPattern getJComboBoxTypes() {
		if (jComboBoxTypes == null) {
			jComboBoxTypes = new JComboBoxSearchPattern();
			jComboBoxTypes.setEditable(false);
			jComboBoxTypes.setEnabled(false);
		}
		return jComboBoxTypes;
	}

	/**
	 * This method initializes jButtonSearch	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonSearch() {
		if (jButtonSearch == null) {
			jButtonSearch = new JButton();
			jButtonSearch.setText("取得");
			jButtonSearch.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					setUDTs(dmd);
				}
			});
		}
		return jButtonSearch;
	}

	/**
	 * This method initializes jPanelProcedureColumns	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelProcedureColumns() {
		if (jPanelProcedureColumns == null) {
			jPanelProcedureColumns = new JPanel();
			jPanelProcedureColumns.setLayout(new BorderLayout());
			jPanelProcedureColumns.setName("getProcedureColumns()");
			jPanelProcedureColumns.add(getJPanelProcedureColumnsSearch(), BorderLayout.NORTH);
			jPanelProcedureColumns.add(getJScrollPaneProcedureColumns(), BorderLayout.CENTER);
		}
		return jPanelProcedureColumns;
	}

	/**
	 * This method initializes jPanelProcedureColumnsSearch	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelProcedureColumnsSearch() {
		if (jPanelProcedureColumnsSearch == null) {
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			gridBagConstraints17.insets = new Insets(5, 3, 5, 5);
			gridBagConstraints17.gridy = 1;
			gridBagConstraints17.anchor = GridBagConstraints.WEST;
			gridBagConstraints17.gridx = 8;
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			gridBagConstraints16.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints16.gridx = 3;
			gridBagConstraints16.gridy = 1;
			gridBagConstraints16.weightx = 1.0;
			gridBagConstraints16.anchor = GridBagConstraints.WEST;
			gridBagConstraints16.insets = new Insets(5, 3, 6, 2);
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.insets = new Insets(10, 3, 10, 2);
			gridBagConstraints15.gridy = 1;
			gridBagConstraints15.anchor = GridBagConstraints.EAST;
			gridBagConstraints15.gridx = 2;
			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
			gridBagConstraints14.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints14.gridx = 1;
			gridBagConstraints14.gridy = 1;
			gridBagConstraints14.weightx = 1.0;
			gridBagConstraints14.anchor = GridBagConstraints.WEST;
			gridBagConstraints14.insets = new Insets(5, 3, 6, 2);
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.insets = new Insets(10, 3, 10, 2);
			gridBagConstraints13.gridy = 1;
			gridBagConstraints13.anchor = GridBagConstraints.EAST;
			gridBagConstraints13.gridx = 0;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints12.gridx = 3;
			gridBagConstraints12.gridy = 0;
			gridBagConstraints12.weightx = 1.0;
			gridBagConstraints12.anchor = GridBagConstraints.WEST;
			gridBagConstraints12.insets = new Insets(5, 3, 6, 2);
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.insets = new Insets(10, 3, 10, 2);
			gridBagConstraints11.gridy = 0;
			gridBagConstraints11.anchor = GridBagConstraints.EAST;
			gridBagConstraints11.gridx = 2;
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints10.gridx = 1;
			gridBagConstraints10.gridy = 0;
			gridBagConstraints10.weightx = 1.0;
			gridBagConstraints10.anchor = GridBagConstraints.WEST;
			gridBagConstraints10.insets = new Insets(5, 3, 6, 2);
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.insets = new Insets(10, 5, 10, 2);
			gridBagConstraints9.gridy = 0;
			gridBagConstraints9.anchor = GridBagConstraints.EAST;
			gridBagConstraints9.gridx = 0;
			jLabel7 = new JLabel();
			jLabel7.setText("columnNamePtn:");
			jLabel7.setName("jLabel7");
			jLabel6 = new JLabel();
			jLabel6.setText("procedureNamePtn:");
			jLabel6.setName("jLabel6");
			jLabel5 = new JLabel();
			jLabel5.setText("schemaPtn:");
			jLabel5.setName("jLabel5");
			jLabel4 = new JLabel();
			jLabel4.setText("catalog:");
			jLabel4.setName("jLabel4");
			jPanelProcedureColumnsSearch = new JPanel();
			jPanelProcedureColumnsSearch.setBorder(BorderFactory.createTitledBorder(null, "\u5f15\u6570", TitledBorder.LEFT, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.PLAIN, 12), Color.black));
			jPanelProcedureColumnsSearch.setLayout(new GridBagLayout());
			jPanelProcedureColumnsSearch.add(jLabel4, gridBagConstraints9);
			jPanelProcedureColumnsSearch.add(getJComboBoxCatalog2(), gridBagConstraints10);
			jPanelProcedureColumnsSearch.add(jLabel5, gridBagConstraints11);
			jPanelProcedureColumnsSearch.add(getJComboBoxSchemaPattern2(), gridBagConstraints12);
			jPanelProcedureColumnsSearch.add(jLabel6, gridBagConstraints13);
			jPanelProcedureColumnsSearch.add(getJComboBoxProcedureNamePattern2(), gridBagConstraints14);
			jPanelProcedureColumnsSearch.add(jLabel7, gridBagConstraints15);
			jPanelProcedureColumnsSearch.add(getJComboBoxColumnNamePattern2(), gridBagConstraints16);
			jPanelProcedureColumnsSearch.add(getJButtonSearch2(), gridBagConstraints17);
		}
		return jPanelProcedureColumnsSearch;
	}

	/**
	 * This method initializes jScrollPaneProcedureColumns	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneProcedureColumns() {
		if (jScrollPaneProcedureColumns == null) {
			jScrollPaneProcedureColumns = new JScrollPane();
			jScrollPaneProcedureColumns.setBorder(null);
			jScrollPaneProcedureColumns.setViewportView(getJTableProcedureColumns());
		}
		return jScrollPaneProcedureColumns;
	}

	/**
	 * This method initializes jTableProcedureColumns	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableProcedureColumns() {
		if (jTableProcedureColumns == null) {
			jTableProcedureColumns = new JTable();
			jTableProcedureColumns.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTableProcedureColumns;
	}

	/**
	 * This method initializes jComboBoxColumnNamePattern	
	 * 	
	 * @return jdbcacsess.gui.JPanelDatabaseMetaData.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxColumnNamePattern2() {
		if (jComboBoxColumnNamePattern2 == null) {
			jComboBoxColumnNamePattern2 = new JComboBoxSearchPattern();
			jComboBoxColumnNamePattern2.setName("jComboBoxColumnNamePattern2");
		}
		return jComboBoxColumnNamePattern2;
	}

	/**
	 * This method initializes jComboBoxProcedureNamePattern2	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxProcedureNamePattern2() {
		if (jComboBoxProcedureNamePattern2 == null) {
			jComboBoxProcedureNamePattern2 = new JComboBoxSearchPattern();
			jComboBoxProcedureNamePattern2.setName("jComboBoxProcedureNamePattern2");
		}
		return jComboBoxProcedureNamePattern2;
	}

	/**
	 * This method initializes jButtonSearch2	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonSearch2() {
		if (jButtonSearch2 == null) {
			jButtonSearch2 = new JButton();
			jButtonSearch2.setText("取得");
			jButtonSearch2.setName("jButtonSearch2");
			jButtonSearch2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					setProcedureColumns(dmd);
				}
			});
		}
		return jButtonSearch2;
	}

	/**
	 * This method initializes jComboBoxCatalog2	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxCatalog2() {
		if (jComboBoxCatalog2 == null) {
			jComboBoxCatalog2 = new JComboBoxSearchPattern();
			jComboBoxCatalog2.setName("jComboBoxCatalog2");
		}
		return jComboBoxCatalog2;
	}

	/**
	 * This method initializes jComboBoxSchemaPattern2	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxSchemaPattern2() {
		if (jComboBoxSchemaPattern2 == null) {
			jComboBoxSchemaPattern2 = new JComboBoxSearchPattern();
			jComboBoxSchemaPattern2.setName("jComboBoxSchemaPattern2");
		}
		return jComboBoxSchemaPattern2;
	}

	/**
	 * This method initializes jPanelProcedures	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelProcedures() {
		if (jPanelProcedures == null) {
			jPanelProcedures = new JPanel();
			jPanelProcedures.setLayout(new BorderLayout());
			jPanelProcedures.add(getJPanelProceduresSearch(), BorderLayout.NORTH);
			jPanelProcedures.add(getJScrollPaneProcedures(), BorderLayout.CENTER);
		}
		return jPanelProcedures;
	}

	/**
	 * This method initializes jPanelProceduresSearch	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelProceduresSearch() {
		if (jPanelProceduresSearch == null) {
			GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
			gridBagConstraints24.anchor = GridBagConstraints.EAST;
			gridBagConstraints24.insets = new Insets(10, 3, 10, 2);
			GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
			gridBagConstraints23.gridx = 4;
			gridBagConstraints23.anchor = GridBagConstraints.WEST;
			gridBagConstraints23.gridy = 1;
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.fill = GridBagConstraints.NONE;
			gridBagConstraints22.gridy = 0;
			gridBagConstraints22.weightx = 1.0;
			gridBagConstraints22.anchor = GridBagConstraints.WEST;
			gridBagConstraints22.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints22.gridx = 3;
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.fill = GridBagConstraints.NONE;
			gridBagConstraints21.gridy = 1;
			gridBagConstraints21.weightx = 1.0;
			gridBagConstraints21.anchor = GridBagConstraints.WEST;
			gridBagConstraints21.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints21.gridx = 1;
			GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
			gridBagConstraints20.gridx = 2;
			gridBagConstraints20.insets = new Insets(10, 3, 10, 2);
			gridBagConstraints20.anchor = GridBagConstraints.EAST;
			GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
			gridBagConstraints19.fill = GridBagConstraints.NONE;
			gridBagConstraints19.gridy = 0;
			gridBagConstraints19.weightx = 1.0;
			gridBagConstraints19.anchor = GridBagConstraints.WEST;
			gridBagConstraints19.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints19.gridx = 1;
			GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
			gridBagConstraints18.gridx = 0;
			gridBagConstraints18.anchor = GridBagConstraints.EAST;
			gridBagConstraints18.insets = new Insets(10, 3, 10, 2);
			gridBagConstraints18.gridy = 1;
			jLabel10 = new JLabel();
			jLabel10.setText("procedureNamePtn:");
			jLabel9 = new JLabel();
			jLabel9.setText("schemaPtn:");
			jLabel8 = new JLabel();
			jLabel8.setText("catalog:");
			jLabel8.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jPanelProceduresSearch = new JPanel();
			jPanelProceduresSearch.setLayout(new GridBagLayout());
			jPanelProceduresSearch.setBorder(BorderFactory.createTitledBorder(null, "\u5f15\u6570", TitledBorder.LEFT, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.PLAIN, 12), Color.black));
			jPanelProceduresSearch.add(jLabel8, gridBagConstraints24);
			jPanelProceduresSearch.add(getJComboBoxCatalog3(), gridBagConstraints19);
			jPanelProceduresSearch.add(jLabel9, gridBagConstraints20);
			jPanelProceduresSearch.add(getJComboBoxProcedureNamePattern3(), gridBagConstraints21);
			jPanelProceduresSearch.add(jLabel10, gridBagConstraints18);
			jPanelProceduresSearch.add(getJComboBoxSchemaPattern3(), gridBagConstraints22);
			jPanelProceduresSearch.add(getJButtonSearch3(), gridBagConstraints23);
		}
		return jPanelProceduresSearch;
	}

	/**
	 * This method initializes jScrollPaneProcedures	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneProcedures() {
		if (jScrollPaneProcedures == null) {
			jScrollPaneProcedures = new JScrollPane();
			jScrollPaneProcedures.setBorder(null);
			jScrollPaneProcedures.setViewportView(getJTableProcedures());
		}
		return jScrollPaneProcedures;
	}

	/**
	 * This method initializes jTableProcedures	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableProcedures() {
		if (jTableProcedures == null) {
			jTableProcedures = new JTable();
			jTableProcedures.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTableProcedures;
	}

	/**
	 * This method initializes jComboBoxCatalog3	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxCatalog3() {
		if (jComboBoxCatalog3 == null) {
			jComboBoxCatalog3 = new JComboBoxSearchPattern();
		}
		return jComboBoxCatalog3;
	}

	/**
	 * This method initializes jComboBoxProcedureNamePattern3	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxProcedureNamePattern3() {
		if (jComboBoxProcedureNamePattern3 == null) {
			jComboBoxProcedureNamePattern3 = new JComboBoxSearchPattern();
		}
		return jComboBoxProcedureNamePattern3;
	}

	/**
	 * This method initializes jComboBoxSchemaPattern3	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxSchemaPattern3() {
		if (jComboBoxSchemaPattern3 == null) {
			jComboBoxSchemaPattern3 = new JComboBoxSearchPattern();
		}
		return jComboBoxSchemaPattern3;
	}

	/**
	 * This method initializes jButtonSearch3	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonSearch3() {
		if (jButtonSearch3 == null) {
			jButtonSearch3 = new JButton();
			jButtonSearch3.setText("取得");
			jButtonSearch3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					setProcedures(dmd);
				}
			});
		}
		return jButtonSearch3;
	}

	/**
	 * This method initializes jPanelSuperTypes	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelSuperTypes() {
		if (jPanelSuperTypes == null) {
			jPanelSuperTypes = new JPanel();
			jPanelSuperTypes.setLayout(new BorderLayout());
			jPanelSuperTypes.add(getJPanelSuperTypesSearch(), BorderLayout.NORTH);
			jPanelSuperTypes.add(getJScrollPaneSuperTypes(), BorderLayout.CENTER);
		}
		return jPanelSuperTypes;
	}

	/**
	 * This method initializes jPanelAttributes	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelAttributes() {
		if (jPanelAttributes == null) {
			jPanelAttributes = new JPanel();
			jPanelAttributes.setLayout(new BorderLayout());
			jPanelAttributes.setBorder(BorderFactory.createTitledBorder(null, "\u5f15\u6570", TitledBorder.LEFT, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.PLAIN, 12), Color.black));
			jPanelAttributes.add(getJPanelAttributesSearch(), BorderLayout.NORTH);
			jPanelAttributes.add(getJScrollPaneAttributes(), BorderLayout.CENTER);
		}
		return jPanelAttributes;
	}

	/**
	 * This method initializes jPanelSuperTypesSearch	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelSuperTypesSearch() {
		if (jPanelSuperTypesSearch == null) {
			GridBagConstraints gridBagConstraints40 = new GridBagConstraints();
			gridBagConstraints40.anchor = GridBagConstraints.EAST;
			gridBagConstraints40.insets = new Insets(10, 3, 10, 2);
			GridBagConstraints gridBagConstraints33 = new GridBagConstraints();
			gridBagConstraints33.gridx = 4;
			gridBagConstraints33.anchor = GridBagConstraints.WEST;
			gridBagConstraints33.gridy = 1;
			GridBagConstraints gridBagConstraints32 = new GridBagConstraints();
			gridBagConstraints32.gridx = 0;
			gridBagConstraints32.anchor = GridBagConstraints.EAST;
			gridBagConstraints32.insets = new Insets(10, 3, 10, 2);
			gridBagConstraints32.gridy = 1;
			GridBagConstraints gridBagConstraints30 = new GridBagConstraints();
			gridBagConstraints30.fill = GridBagConstraints.NONE;
			gridBagConstraints30.gridx = 1;
			gridBagConstraints30.gridy = 1;
			gridBagConstraints30.anchor = GridBagConstraints.WEST;
			gridBagConstraints30.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints30.weightx = 1.0;
			jLabel21 = new JLabel();
			jLabel21.setText("typeNamePtn:");
			GridBagConstraints gridBagConstraints27 = new GridBagConstraints();
			gridBagConstraints27.fill = GridBagConstraints.NONE;
			gridBagConstraints27.anchor = GridBagConstraints.WEST;
			gridBagConstraints27.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints27.weightx = 1.0;
			GridBagConstraints gridBagConstraints28 = new GridBagConstraints();
			gridBagConstraints28.gridx = 2;
			gridBagConstraints28.anchor = GridBagConstraints.EAST;
			gridBagConstraints28.insets = new Insets(10, 3, 10, 2);
			gridBagConstraints28.gridy = 0;
			jLabel12 = new JLabel();
			jLabel12.setText("schemaPtn:");
			GridBagConstraints gridBagConstraints26 = new GridBagConstraints();
			gridBagConstraints26.fill = GridBagConstraints.NONE;
			gridBagConstraints26.anchor = GridBagConstraints.WEST;
			gridBagConstraints26.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints26.weightx = 1.0;
			jLabel11 = new JLabel();
			jLabel11.setText("catalog:");
			jPanelSuperTypesSearch = new JPanel();
			jPanelSuperTypesSearch.setLayout(new GridBagLayout());
			jPanelSuperTypesSearch.setBorder(BorderFactory.createTitledBorder(null, "\u5f15\u6570", TitledBorder.LEFT, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.PLAIN, 12), Color.black));
			jPanelSuperTypesSearch.add(jLabel11, gridBagConstraints40);
			jPanelSuperTypesSearch.add(getJComboBoxCatalog5(), gridBagConstraints26);
			jPanelSuperTypesSearch.add(jLabel12, gridBagConstraints28);
			jPanelSuperTypesSearch.add(getJComboBoxSchemaPattern5(), gridBagConstraints27);
			jPanelSuperTypesSearch.add(jLabel21, gridBagConstraints32);
			jPanelSuperTypesSearch.add(getJComboBoxTypeNamePattern5(), gridBagConstraints30);
			jPanelSuperTypesSearch.add(getJButtonSearch5(), gridBagConstraints33);
		}
		return jPanelSuperTypesSearch;
	}

	/**
	 * This method initializes jPanelAttributesSearch	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelAttributesSearch() {
		if (jPanelAttributesSearch == null) {
			GridBagConstraints gridBagConstraints39 = new GridBagConstraints();
			gridBagConstraints39.anchor = GridBagConstraints.EAST;
			gridBagConstraints39.insets = new Insets(10, 3, 10, 2);
			GridBagConstraints gridBagConstraints38 = new GridBagConstraints();
			gridBagConstraints38.anchor = GridBagConstraints.EAST;
			gridBagConstraints38.insets = new Insets(10, 3, 10, 2);
			GridBagConstraints gridBagConstraints37 = new GridBagConstraints();
			gridBagConstraints37.gridx = 4;
			gridBagConstraints37.anchor = GridBagConstraints.WEST;
			gridBagConstraints37.gridy = 1;
			GridBagConstraints gridBagConstraints36 = new GridBagConstraints();
			gridBagConstraints36.fill = GridBagConstraints.NONE;
			gridBagConstraints36.gridy = 1;
			gridBagConstraints36.weightx = 1.0;
			gridBagConstraints36.anchor = GridBagConstraints.WEST;
			gridBagConstraints36.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints36.gridx = 3;
			GridBagConstraints gridBagConstraints35 = new GridBagConstraints();
			gridBagConstraints35.gridx = 2;
			gridBagConstraints35.anchor = GridBagConstraints.EAST;
			gridBagConstraints35.insets = new Insets(10, 3, 10, 2);
			gridBagConstraints35.gridy = 1;
			jLabel14 = new JLabel();
			jLabel14.setText("attributeNamePtn:");
			GridBagConstraints gridBagConstraints34 = new GridBagConstraints();
			gridBagConstraints34.gridx = 0;
			gridBagConstraints34.anchor = GridBagConstraints.EAST;
			gridBagConstraints34.insets = new Insets(10, 3, 10, 2);
			gridBagConstraints34.gridy = 1;
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.fill = GridBagConstraints.NONE;
			gridBagConstraints31.gridx = 1;
			gridBagConstraints31.gridy = 1;
			gridBagConstraints31.anchor = GridBagConstraints.WEST;
			gridBagConstraints31.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints31.weightx = 1.0;
			jLabel23 = new JLabel();
			jLabel23.setText("typeNamePtn:");
			GridBagConstraints gridBagConstraints29 = new GridBagConstraints();
			gridBagConstraints29.fill = GridBagConstraints.NONE;
			gridBagConstraints29.anchor = GridBagConstraints.WEST;
			gridBagConstraints29.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints29.weightx = 1.0;
			jLabel13 = new JLabel();
			jLabel13.setText("schemaPtn:");
			GridBagConstraints gridBagConstraints25 = new GridBagConstraints();
			gridBagConstraints25.fill = GridBagConstraints.NONE;
			gridBagConstraints25.anchor = GridBagConstraints.WEST;
			gridBagConstraints25.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints25.weightx = 1.0;
			jLabel111 = new JLabel();
			jLabel111.setText("catalog:");
			jPanelAttributesSearch = new JPanel();
			jPanelAttributesSearch.setLayout(new GridBagLayout());
			jPanelAttributesSearch.add(jLabel111, gridBagConstraints38);
			jPanelAttributesSearch.add(getJComboBoxCatalog4(), gridBagConstraints25);
			jPanelAttributesSearch.add(jLabel13, gridBagConstraints39);
			jPanelAttributesSearch.add(getJComboBoxSchemaPattern4(), gridBagConstraints29);
			jPanelAttributesSearch.add(jLabel23, gridBagConstraints34);
			jPanelAttributesSearch.add(getJComboBoxTypeNamePattern4(), gridBagConstraints31);
			jPanelAttributesSearch.add(jLabel14, gridBagConstraints35);
			jPanelAttributesSearch.add(getJComboBoxAttributeNamePattern4(), gridBagConstraints36);
			jPanelAttributesSearch.add(getJButtonSearch4(), gridBagConstraints37);
		}
		return jPanelAttributesSearch;
	}

	/**
	 * This method initializes jScrollPaneSuperTypes	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneSuperTypes() {
		if (jScrollPaneSuperTypes == null) {
			jScrollPaneSuperTypes = new JScrollPane();
			jScrollPaneSuperTypes.setViewportView(getJTableSuperTypes());
		}
		return jScrollPaneSuperTypes;
	}

	/**
	 * This method initializes jTableSuperTypes	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableSuperTypes() {
		if (jTableSuperTypes == null) {
			jTableSuperTypes = new JTable();
			jTableSuperTypes.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTableSuperTypes;
	}

	/**
	 * This method initializes jScrollPaneAttributes	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneAttributes() {
		if (jScrollPaneAttributes == null) {
			jScrollPaneAttributes = new JScrollPane();
			jScrollPaneAttributes.setViewportView(getJTableAttributes());
		}
		return jScrollPaneAttributes;
	}

	/**
	 * This method initializes jTableAttributes	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableAttributes() {
		if (jTableAttributes == null) {
			jTableAttributes = new JTable();
			jTableAttributes.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTableAttributes;
	}

	/**
	 * This method initializes jComboBoxCatalog4	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxCatalog4() {
		if (jComboBoxCatalog4 == null) {
			jComboBoxCatalog4 = new JComboBoxSearchPattern();
		}
		return jComboBoxCatalog4;
	}

	/**
	 * This method initializes jComboBoxCatalog5	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxCatalog5() {
		if (jComboBoxCatalog5 == null) {
			jComboBoxCatalog5 = new JComboBoxSearchPattern();
		}
		return jComboBoxCatalog5;
	}

	/**
	 * This method initializes jComboBoxSchemaPattern4	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxSchemaPattern4() {
		if (jComboBoxSchemaPattern4 == null) {
			jComboBoxSchemaPattern4 = new JComboBoxSearchPattern();
		}
		return jComboBoxSchemaPattern4;
	}

	/**
	 * This method initializes jComboBoxSchemaPattern5	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxSchemaPattern5() {
		if (jComboBoxSchemaPattern5 == null) {
			jComboBoxSchemaPattern5 = new JComboBoxSearchPattern();
		}
		return jComboBoxSchemaPattern5;
	}

	/**
	 * This method initializes jComboBoxTypeNamePattern5	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxTypeNamePattern5() {
		if (jComboBoxTypeNamePattern5 == null) {
			jComboBoxTypeNamePattern5 = new JComboBoxSearchPattern();
		}
		return jComboBoxTypeNamePattern5;
	}

	/**
	 * This method initializes jComboBoxTypeNamePattern4	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxTypeNamePattern4() {
		if (jComboBoxTypeNamePattern4 == null) {
			jComboBoxTypeNamePattern4 = new JComboBoxSearchPattern();
		}
		return jComboBoxTypeNamePattern4;
	}

	/**
	 * This method initializes jButtonSearch5	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonSearch5() {
		if (jButtonSearch5 == null) {
			jButtonSearch5 = new JButton();
			jButtonSearch5.setText("\u53d6\u5f97");
			jButtonSearch5.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					setSuperTypes(dmd);
				}
			});
		}
		return jButtonSearch5;
	}

	/**
	 * This method initializes jButtonSearch4	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonSearch4() {
		if (jButtonSearch4 == null) {
			jButtonSearch4 = new JButton();
			jButtonSearch4.setText("\u53d6\u5f97");
			jButtonSearch4.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					setAttributes(dmd);
				}
			});
		}
		return jButtonSearch4;
	}

	/**
	 * This method initializes jComboBoxAttributeNamePattern4	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxAttributeNamePattern4() {
		if (jComboBoxAttributeNamePattern4 == null) {
			jComboBoxAttributeNamePattern4 = new JComboBoxSearchPattern();
		}
		return jComboBoxAttributeNamePattern4;
	}

	/**
	 * This method initializes jScrollPaneCatalogs	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneCatalogs() {
		if (jScrollPaneCatalogs == null) {
			jScrollPaneCatalogs = new JScrollPane();
			jScrollPaneCatalogs.setViewportView(getJTableCatalogs());
		}
		return jScrollPaneCatalogs;
	}

	/**
	 * This method initializes jTableCatalogs	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableCatalogs() {
		if (jTableCatalogs == null) {
			jTableCatalogs = new JTable();
			jTableCatalogs.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTableCatalogs;
	}

	/**
	 * This method initializes jScrollPaneAttributes	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneSchemas() {
		if (jScrollPaneSchemas == null) {
			jScrollPaneSchemas = new JScrollPane();
			jScrollPaneSchemas.setViewportView(getJTableSchemas());
		}
		return jScrollPaneSchemas;
	}

	/**
	 * This method initializes jTableAttributes	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableSchemas() {
		if (jTableSchemas == null) {
			jTableSchemas = new JTable();
			jTableSchemas.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTableSchemas;
	}

	/**
	 * This method initializes jPanelTables	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelTables() {
		if (jPanelTables == null) {
			jPanelTables = new JPanel();
			jPanelTables.setLayout(new BorderLayout());
			jPanelTables.add(getJPanelTablesSearch(), BorderLayout.NORTH);
			jPanelTables.add(getJScrollPaneTables(), BorderLayout.CENTER);
		}
		return jPanelTables;
	}

	/**
	 * This method initializes jScrollPaneTables	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneTables() {
		if (jScrollPaneTables == null) {
			jScrollPaneTables = new JScrollPane();
			jScrollPaneTables.setViewportView(getJTableTables());
		}
		return jScrollPaneTables;
	}

	/**
	 * This method initializes jTableTables	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableTables() {
		if (jTableTables == null) {
			jTableTables = new JTable();
			jTableTables.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTableTables;
	}

	/**
	 * This method initializes jPanelTablesSearch	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelTablesSearch() {
		if (jPanelTablesSearch == null) {
			GridBagConstraints gridBagConstraints49 = new GridBagConstraints();
			gridBagConstraints49.anchor = GridBagConstraints.EAST;
			gridBagConstraints49.insets = new Insets(10, 5, 10, 2);
			GridBagConstraints gridBagConstraints48 = new GridBagConstraints();
			gridBagConstraints48.anchor = GridBagConstraints.EAST;
			gridBagConstraints48.insets = new Insets(10, 5, 10, 2);
			GridBagConstraints gridBagConstraints47 = new GridBagConstraints();
			gridBagConstraints47.gridx = 4;
			gridBagConstraints47.anchor = GridBagConstraints.WEST;
			gridBagConstraints47.gridy = 1;
			GridBagConstraints gridBagConstraints46 = new GridBagConstraints();
			gridBagConstraints46.gridx = 2;
			gridBagConstraints46.anchor = GridBagConstraints.EAST;
			gridBagConstraints46.insets = new Insets(10, 5, 10, 2);
			gridBagConstraints46.gridy = 1;
			GridBagConstraints gridBagConstraints45 = new GridBagConstraints();
			gridBagConstraints45.gridx = 0;
			gridBagConstraints45.anchor = GridBagConstraints.EAST;
			gridBagConstraints45.insets = new Insets(10, 5, 10, 2);
			gridBagConstraints45.gridy = 1;
			GridBagConstraints gridBagConstraints44 = new GridBagConstraints();
			gridBagConstraints44.fill = GridBagConstraints.NONE;
			gridBagConstraints44.gridx = 3;
			gridBagConstraints44.gridy = 1;
			gridBagConstraints44.anchor = GridBagConstraints.WEST;
			gridBagConstraints44.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints44.weightx = 1.0;
			jLabel31 = new JLabel();
			jLabel31.setText("types:");
			GridBagConstraints gridBagConstraints43 = new GridBagConstraints();
			gridBagConstraints43.fill = GridBagConstraints.NONE;
			gridBagConstraints43.gridx = 1;
			gridBagConstraints43.gridy = 1;
			gridBagConstraints43.anchor = GridBagConstraints.WEST;
			gridBagConstraints43.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints43.weightx = 1.0;
			jLabel22 = new JLabel();
			jLabel22.setText("tableNamePtn:");
			GridBagConstraints gridBagConstraints42 = new GridBagConstraints();
			gridBagConstraints42.fill = GridBagConstraints.NONE;
			gridBagConstraints42.anchor = GridBagConstraints.WEST;
			gridBagConstraints42.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints42.weightx = 1.0;
			jLabel16 = new JLabel();
			jLabel16.setText("schemaPtn:");
			GridBagConstraints gridBagConstraints41 = new GridBagConstraints();
			gridBagConstraints41.fill = GridBagConstraints.NONE;
			gridBagConstraints41.anchor = GridBagConstraints.WEST;
			gridBagConstraints41.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints41.weightx = 1.0;
			jLabel15 = new JLabel();
			jLabel15.setText("catalog:");
			jPanelTablesSearch = new JPanel();
			jPanelTablesSearch.setLayout(new GridBagLayout());
			jPanelTablesSearch.setBorder(BorderFactory.createTitledBorder(null, "\u5f15\u6570", TitledBorder.LEFT, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.PLAIN, 12), Color.black));
			jPanelTablesSearch.add(jLabel15, gridBagConstraints48);
			jPanelTablesSearch.add(getJComboBoxCatalog1(), gridBagConstraints41);
			jPanelTablesSearch.add(jLabel16, gridBagConstraints49);
			jPanelTablesSearch.add(getJComboBoxSchemaPattern1(), gridBagConstraints42);
			jPanelTablesSearch.add(jLabel22, gridBagConstraints45);
			jPanelTablesSearch.add(getJComboBoxTableNamePattern1(), gridBagConstraints43);
			jPanelTablesSearch.add(jLabel31, gridBagConstraints46);
			jPanelTablesSearch.add(getJComboBoxTypes1(), gridBagConstraints44);
			jPanelTablesSearch.add(getJButtonSearch1(), gridBagConstraints47);
		}
		return jPanelTablesSearch;
	}

	/**
	 * This method initializes jComboBoxCatalog1	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxCatalog1() {
		if (jComboBoxCatalog1 == null) {
			jComboBoxCatalog1 = new JComboBoxSearchPattern();
		}
		return jComboBoxCatalog1;
	}

	/**
	 * This method initializes jComboBoxSchemaPattern1	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxSchemaPattern1() {
		if (jComboBoxSchemaPattern1 == null) {
			jComboBoxSchemaPattern1 = new JComboBoxSearchPattern();
		}
		return jComboBoxSchemaPattern1;
	}

	/**
	 * This method initializes jComboBoxTableNamePattern1	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxTableNamePattern1() {
		if (jComboBoxTableNamePattern1 == null) {
			jComboBoxTableNamePattern1 = new JComboBoxSearchPattern();
		}
		return jComboBoxTableNamePattern1;
	}

	/**
	 * This method initializes jComboBoxTypes1	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxTypes1() {
		if (jComboBoxTypes1 == null) {
			jComboBoxTypes1 = new JComboBoxSearchPattern();
			jComboBoxTypes1.setEnabled(false);
			jComboBoxTypes1.setEditable(false);
		}
		return jComboBoxTypes1;
	}

	/**
	 * This method initializes jButtonSearch1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonSearch1() {
		if (jButtonSearch1 == null) {
			jButtonSearch1 = new JButton();
			jButtonSearch1.setText("\u53d6\u5f97");
			jButtonSearch1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					setTables(dmd);
				}
			});
		}
		return jButtonSearch1;
	}

	/**
	 * This method initializes jPanelColumns	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelColumns() {
		if (jPanelColumns == null) {
			jPanelColumns = new JPanel();
			jPanelColumns.setLayout(new BorderLayout());
			jPanelColumns.add(getJPanelColumnsSearch(), BorderLayout.NORTH);
			jPanelColumns.add(getJScrollPaneColumns(), BorderLayout.CENTER);
		}
		return jPanelColumns;
	}

	/**
	 * This method initializes jPanelColumnsSearch	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelColumnsSearch() {
		if (jPanelColumnsSearch == null) {
			GridBagConstraints gridBagConstraints55 = new GridBagConstraints();
			gridBagConstraints55.gridx = 0;
			gridBagConstraints55.anchor = GridBagConstraints.EAST;
			gridBagConstraints55.gridy = 1;
			jLabel221 = new JLabel();
			jLabel221.setText("tableNamePtn:");
			GridBagConstraints gridBagConstraints54 = new GridBagConstraints();
			gridBagConstraints54.fill = GridBagConstraints.NONE;
			gridBagConstraints54.gridy = 1;
			gridBagConstraints54.weightx = 1.0;
			gridBagConstraints54.anchor = GridBagConstraints.WEST;
			gridBagConstraints54.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints54.gridx = 1;
			GridBagConstraints gridBagConstraints51 = new GridBagConstraints();
			gridBagConstraints51.fill = GridBagConstraints.NONE;
			gridBagConstraints51.gridy = 0;
			gridBagConstraints51.weightx = 1.0;
			gridBagConstraints51.anchor = GridBagConstraints.WEST;
			gridBagConstraints51.insets = new Insets(5, 3, 6, 2);
			gridBagConstraints51.gridx = 1;
			GridBagConstraints gridBagConstraints58 = new GridBagConstraints();
			gridBagConstraints58.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints58.gridy = 1;
			gridBagConstraints58.anchor = GridBagConstraints.WEST;
			gridBagConstraints58.gridx = 5;
			GridBagConstraints gridBagConstraints57 = new GridBagConstraints();
			gridBagConstraints57.fill = GridBagConstraints.NONE;
			gridBagConstraints57.gridx = 4;
			gridBagConstraints57.gridy = 1;
			gridBagConstraints57.weightx = 1.0;
			gridBagConstraints57.anchor = GridBagConstraints.WEST;
			gridBagConstraints57.insets = new Insets(5, 3, 6, 2);
			GridBagConstraints gridBagConstraints56 = new GridBagConstraints();
			gridBagConstraints56.insets = new Insets(10, 5, 10, 2);
			gridBagConstraints56.gridx = 2;
			gridBagConstraints56.gridy = 1;
			gridBagConstraints56.anchor = GridBagConstraints.EAST;
			gridBagConstraints56.gridwidth = 1;
			GridBagConstraints gridBagConstraints53 = new GridBagConstraints();
			gridBagConstraints53.fill = GridBagConstraints.NONE;
			gridBagConstraints53.gridx = 4;
			gridBagConstraints53.gridy = 0;
			gridBagConstraints53.weightx = 1.0;
			gridBagConstraints53.anchor = GridBagConstraints.WEST;
			gridBagConstraints53.insets = new Insets(5, 3, 6, 2);
			GridBagConstraints gridBagConstraints52 = new GridBagConstraints();
			gridBagConstraints52.insets = new Insets(10, 5, 10, 2);
			gridBagConstraints52.gridy = 0;
			gridBagConstraints52.anchor = GridBagConstraints.EAST;
			gridBagConstraints52.gridx = 2;
			GridBagConstraints gridBagConstraints50 = new GridBagConstraints();
			gridBagConstraints50.insets = new Insets(10, 5, 10, 2);
			gridBagConstraints50.gridy = 0;
			gridBagConstraints50.anchor = GridBagConstraints.EAST;
			gridBagConstraints50.gridx = 0;
			jLabel311 = new JLabel();
			jLabel311.setText("columnNamePtn:");
			jLabel161 = new JLabel();
			jLabel161.setText("schemaPtn:");
			jLabel151 = new JLabel();
			jLabel151.setText("catalog:");
			jPanelColumnsSearch = new JPanel();
			jPanelColumnsSearch.setLayout(new GridBagLayout());
			jPanelColumnsSearch.setBorder(BorderFactory.createTitledBorder(null, "\u5f15\u6570", TitledBorder.LEFT, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.PLAIN, 12), Color.black));
			jPanelColumnsSearch.add(jLabel151, gridBagConstraints50);
			jPanelColumnsSearch.add(getJComboBoxCatalog6(), gridBagConstraints51);
			jPanelColumnsSearch.add(jLabel161, gridBagConstraints52);
			jPanelColumnsSearch.add(getJComboBoxSchemaPattern6(), gridBagConstraints53);
			jPanelColumnsSearch.add(jLabel221, gridBagConstraints55);
			jPanelColumnsSearch.add(getJComboBoxTableNamePattern6(), gridBagConstraints54);
			jPanelColumnsSearch.add(jLabel311, gridBagConstraints56);
			jPanelColumnsSearch.add(getJComboBoxColumnNamePattern6(), gridBagConstraints57);
			jPanelColumnsSearch.add(getJButtonSearch6(), gridBagConstraints58);
		}
		return jPanelColumnsSearch;
	}

	/**
	 * This method initializes jScrollPaneColumns	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneColumns() {
		if (jScrollPaneColumns == null) {
			jScrollPaneColumns = new JScrollPane();
			jScrollPaneColumns.setViewportView(getJTableColumns());
		}
		return jScrollPaneColumns;
	}

	/**
	 * This method initializes jTableColumns	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableColumns() {
		if (jTableColumns == null) {
			jTableColumns = new JTable();
			jTableColumns.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTableColumns;
	}

	/**
	 * This method initializes jComboBoxSchemaPattern6	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxSchemaPattern6() {
		if (jComboBoxSchemaPattern6 == null) {
			jComboBoxSchemaPattern6 = new JComboBoxSearchPattern();
		}
		return jComboBoxSchemaPattern6;
	}

	/**
	 * This method initializes jComboBoxTableNamePattern7	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxColumnNamePattern6() {
		if (jComboBoxColumnNamePattern6 == null) {
			jComboBoxColumnNamePattern6 = new JComboBoxSearchPattern();
		}
		return jComboBoxColumnNamePattern6;
	}

	/**
	 * This method initializes jButtonSearch6	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonSearch6() {
		if (jButtonSearch6 == null) {
			jButtonSearch6 = new JButton();
			jButtonSearch6.setText("\u53d6\u5f97");
			jButtonSearch6.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					setColumns(dmd);
				}
			});
		}
		return jButtonSearch6;
	}

	/**
	 * This method initializes jComboBoxCatalog6	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxCatalog6() {
		if (jComboBoxCatalog6 == null) {
			jComboBoxCatalog6 = new JComboBoxSearchPattern();
		}
		return jComboBoxCatalog6;
	}

	/**
	 * This method initializes jComboBoxTableNamePattern6	
	 * 	
	 * @return jdbcacsess.gui.common.JComboBoxSearchPattern	
	 */
	private JComboBoxSearchPattern getJComboBoxTableNamePattern6() {
		if (jComboBoxTableNamePattern6 == null) {
			jComboBoxTableNamePattern6 = new JComboBoxSearchPattern();
		}
		return jComboBoxTableNamePattern6;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
