package jdbcacsess.gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.util.Observable;
import java.util.Observer;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JPanel;

public class JPanelEditButton extends JPanel implements Observer {

	private static final long serialVersionUID = 6072155308327958525L;

	static class JButtonSqlPhrase extends JButton {
		private static final long serialVersionUID = -3349122403086665806L;

		JButtonSqlPhrase(Action action, String text, String actionCommand) {
			super(action);

			setFont(getFont().deriveFont(Font.PLAIN, 9));
			setAlignmentY(0.2F);
			setMinimumSize(new Dimension(0, 0));
			setMargin(new Insets(0, 0, 0, 0));

			setText(text);
			setActionCommand(actionCommand);
		}
	}

	public JPanelEditButton() {
		String crlf = "\n";

		GridLayout gridLayoutEdit = new GridLayout();

		setLayout(gridLayoutEdit);
		gridLayoutEdit.setRows(4);

		AbstractAction actionSetText = new AbstractAction() {
			private static final long serialVersionUID = -1513563428445671L;

			public void actionPerformed(ActionEvent e) {
				if (sqlStatement == null)
					return;
				sqlStatement.setText(e.getActionCommand());
			}
		};

		AbstractAction actionInsertText = new AbstractAction() {
			private static final long serialVersionUID = -1513563428445671L;

			public void actionPerformed(ActionEvent e) {
				if (sqlStatement == null)
					return;
				sqlStatement.insertCurrentPosition(e.getActionCommand());
			}
		};

		addButton(actionSetText, "SELECT", "SELECT " + crlf + "FROM " + crlf
				+ "WHERE ");
		addButton(actionSetText, "DELETE", "DELETE FROM " + crlf + "WHERE ");
		addButton(actionSetText, "INSERT", "INSERT INTO " + crlf + "VALUES( "
				+ crlf + ") ");
		addButton(actionSetText, "UPDATE", "UPDATE " + crlf + "SET = " + crlf
				+ "WHERE ");

		addButton(actionInsertText, "<", " < ");
		addButton(actionInsertText, ">", " > ");
		addButton(actionInsertText, "=", " = ");
		addButton(actionInsertText, "SP", " ");

		addButton(actionInsertText, "*", " * ");
		addButton(actionInsertText, "AND", " AND ");
		addButton(actionInsertText, "OR", " OR ");
		addButton(actionInsertText, "改行", crlf);

		addButton(actionInsertText, ",", " , ");
		addButton(actionInsertText, "WHERE", " WHERE ");
		addButton(actionInsertText, "GROUP BY", " GROUP BY ");
		addButton(actionInsertText, "ORDER BY", " ORDER BY ");
	}

	private void addButton(Action action, String text, String actionCommand) {
		add(new JButtonSqlPhrase(action, text, actionCommand), null);
	}

	private JTextPaneSqlStatement sqlStatement;

	public void update(Observable o, Object sqlStatement) {
		this.sqlStatement = (JTextPaneSqlStatement) sqlStatement;

	}

}