/*
 * 作成日: 2004/01/05
 *
 * この生成されたコメントの挿入されるテンプレートを変更するため
 * ウィンドウ > 設定 > Java > コード生成 > コードとコメント
 */
package jdbcacsess.gui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.swing.DefaultComboBoxModel;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingUtilities;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import jdbcacsess.JdbcacsessException;
import jdbcacsess.LogOutput;
import jdbcacsess.csv.CsvExport;
import jdbcacsess.csv.CsvInfo;
import jdbcacsess.csv.CsvMode;
import jdbcacsess.csv.JDialogCsv;
import jdbcacsess.gui.common.ActionBase;
import jdbcacsess.gui.common.ConstAutoCommit;
import jdbcacsess.gui.common.JDialogMessage;
import jdbcacsess.gui.icons.IconImage;
import jdbcacsess.sql.ColumnInfoResult;
import jdbcacsess.sql.PrepareExecuteStatement;
import jdbcacsess.sql.QueryExecuteListener;
import jdbcacsess.sql.QueryExecuteStatus;
import jdbcacsess.sql.QueryExecuteThread;
import jdbcacsess.sql.SqlAnalyze;
import jdbcacsess.sql.SqlExec;
import jdbcacsess.sql.SqlStatementCatgoly;

/**
 * @author sima
 */
public class JPanelExecSql extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -2404983650883644746L;

	private ComanndBuffer cmdBuff;

	private JTableSqlModel jTableSqlModel;

	private JButton jButtonCsvExport = null;

	private JButton jButtonClear = null;

	private JButton jButtonExecSql = null;
	private JButton jButtonNext = null;

	private JButton jButtonPrev = null;

	private JButton jButtonSelectAbort = null;

	private JButton jButtonSelectContinue = null;

	private JLabel jLabelPageNo = null;

	private JPanel jPanelCommand = null;

	private JPanel jPanelSalStatement = null;

	private JSplitPane jSplitPane = null;

	private JPanel jPanelSqlInput = null;

	private JScrollPane jScrollPaneResults = null;

	private JTableSql jTableResults = null;

	private JTextPaneSqlStatement jTextPaneSqlStatement = null;

	private QueryExecuteThread queryExecute;

	private JScrollPane jScrollPane = null;

	private JLabel jLabelMessage = null;

	private JButton jButtonClose = null;

	private Connection execSqlConnection;

	private JButton jButtonCommit = null;

	private JButton jButtonRollBack = null;

	private boolean autoCommit;

	private JPanel jPanelMessage = null;

	private JLabel jLabelLocation = null;

	private ActionExecSql actionExecSql;

	private ActionCsvExport actionCsvExport;

	private ActionSelectContinue actionSelectContinue;

	private ActionSelectAbort actionSelectAbort;

	private JComboBox jComboBoxAutoCommit = null;
	
	static final Icon execSqlIcon = new ImageIcon(IconImage.class.getResource("stock_form-date-field.png"));
	
	static final Icon prevIcon = new ImageIcon(IconImage.class.getResource("stock_left.png"));
	
	static final Icon nextIcon = new ImageIcon(IconImage.class.getResource("stock_right.png"));
	
	static final Icon selectAbortIcon = new ImageIcon(IconImage.class.getResource("stock_stop.png"));
	
	static final Icon selectContinueIcon = new ImageIcon(IconImage.class.getResource("stock_insert-fields.png"));
	
	static final Icon csvExportIcon = new ImageIcon(IconImage.class.getResource("stock_save-csv.png"));
	
	static final Icon clearIcon = new ImageIcon(IconImage.class.getResource("stock_toilet-paper.png"));
	
	static final Icon closeIcon = new ImageIcon(IconImage.class.getResource("stock_exit.png"));
	
	static final Icon commitIcon = new ImageIcon(IconImage.class.getResource("stock_database.png"));
	
	static final Icon rollBackIcon = new ImageIcon(IconImage.class.getResource("stock_data-undo.png"));
	
	static final Icon connectIcon = new ImageIcon(IconImage.class.getResource("stock_connect.png"));
	
	static final Icon disconnectIcon = new ImageIcon(IconImage.class.getResource("stock_disconnect.png"));
	
	public JPanelExecSql(String panelName, boolean autoCommit) {
		super();
		
		setName( panelName );
		
		actionExecSql = new ActionExecSql();
		actionCsvExport = new ActionCsvExport();
		actionSelectContinue = new ActionSelectContinue();
		actionSelectAbort = new ActionSelectAbort();

		initialize();
		
		try {
			setAutoCommit(autoCommit);
		} catch (SQLException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}

		jComboBoxAutoCommit.setModel(new DefaultComboBoxModel(ConstAutoCommit.values()));
		if (autoCommit) {
			jComboBoxAutoCommit.setSelectedItem(ConstAutoCommit.AUTOCOMMIT);
		} else {
			jComboBoxAutoCommit.setSelectedItem(ConstAutoCommit.MANUALCOMMIT);
		}
	}

	private void setAutoCommit(boolean autoCommit) throws SQLException{
		if (execSqlConnection != null) {
			execSqlConnection.setAutoCommit(autoCommit);
		}
		if (autoCommit) {
			jButtonCommit.setEnabled(false);
			jButtonRollBack.setEnabled(false);
		} else {
			jButtonCommit.setEnabled(true);
			jButtonRollBack.setEnabled(true);
		}
		this.autoCommit = autoCommit;
	}
	
	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		getJSplitPane();

		this.setLayout(new BorderLayout());
		this.setPreferredSize(new java.awt.Dimension(600, 400));
		this.add(getJSplitPane(), java.awt.BorderLayout.CENTER);
		this.add(getJPanelMessage(), java.awt.BorderLayout.SOUTH);
		this.add(getJPanelCommand(), java.awt.BorderLayout.NORTH);
		cmdBuff = new ComanndBuffer();
		displayIdx();

		for (JMenuItem item : getJMenu()) {
			jTextPaneSqlStatement.insertMenuItem(item, 0);
		}
		jTextPaneSqlStatement.insertMenuItem(new JPopupMenu.Separator(), 4);

		for (JMenuItem item : getJMenu()) {
			jTableResults.insertMenuItem(item, 0);
		}
		jTableResults.insertMenuItem(new JPopupMenu.Separator(), 4);
		
		jLabelLocation.setText(getCurrentCellPosition());
		
		jButtonExecSql.setIcon(execSqlIcon);
		jButtonNext.setIcon(nextIcon);
		jButtonPrev.setIcon(prevIcon);
		jButtonClear.setIcon(clearIcon);
		jButtonSelectAbort.setIcon(selectAbortIcon);
		jButtonSelectContinue.setIcon(selectContinueIcon);
		jButtonCsvExport.setIcon(csvExportIcon);
		jButtonClose.setIcon(closeIcon);
		jButtonCommit.setIcon(commitIcon);
		jButtonRollBack.setIcon(rollBackIcon);
	}

	List<JMenuItem> getJMenu() {
		List<JMenuItem> rtn = new ArrayList<JMenuItem>();
		rtn.add(new JMenuItem(actionSelectAbort));
		rtn.add(new JMenuItem(actionSelectContinue));
		rtn.add(new JMenuItem(actionCsvExport));
		rtn.add(new JMenuItem(actionExecSql));
		return rtn;
	}

	public JTextPaneSqlStatement getSqlStatement() {
		return jTextPaneSqlStatement;
	}

	private void setMessage(final String msg) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				jLabelMessage.setText(msg);
			}
		});
		LogOutput.fine(msg);
	}

	class ReciveStatus implements QueryExecuteListener {
		JTableSqlModel jtsm;
		boolean selectUpdatable;
		String errorReasonMsg;
		
		public ReciveStatus() {
			this.jtsm = null;
		}
		public ReciveStatus(JTableSqlModel jtsm) {
			this.jtsm = jtsm;
		}
		public void init(){
			if (jtsm!=null){
				SwingUtilities.invokeLater(new Runnable() {
		            public void run() {
						jTableSqlModel = jtsm;
						jTableResults.setModel(jTableSqlModel);
		            }
				});
			}
		}

		public void setResultHeader(ArrayList<ColumnInfoResult> rowData,
				final SqlAnalyze sqlAnalyze,boolean selectUpdatable) {
			this.selectUpdatable = selectUpdatable;
			errorReasonMsg = sqlAnalyze.getErrorReasonMsg();
			SwingUtilities.invokeLater(new Runnable() {
	            public void run() {
					
					JFrameMain jFrameMain = (JFrameMain) JFrameMain.serachComponent(JPanelExecSql.this, JFrameMain.class);
					if (jFrameMain != null) {
						jFrameMain.getTabWinManager().getPane().setPaneTitleName(
								JPanelExecSql.this,
									getName() + ":" + 
									sqlAnalyze.getSchemaTableName().getCompleteTableName());
					}
	            }
			});
		}
		
		private String msg(QueryExecuteStatus breakStatus) {
			if (breakStatus.getSource() == actionCsvExport) {
				return "";
			}
			
			if (selectUpdatable) {
				return "結果更新可能：";
			}
			return errorReasonMsg + "：";
		}

		public void completeQuery(QueryExecuteStatus breakStatus) {
			LogOutput.fine("BreakStatus受信" + breakStatus.toString());
			setMessage(msg(breakStatus) + breakStatus.getCnt()
						+ ( breakStatus.isComplete() ? "行取得ました" : "行で結果取得を中止しました"));
			resetActionStatus();
		}

		public void status(QueryExecuteStatus breakStatus) {
			LogOutput.fine("BreakStatus受信" + breakStatus.toString());
			setMessage((msg(breakStatus) + "結果取得中..." + breakStatus.getCnt() + "行"));
		  return;
		}

		public void errorException(Exception obj) {
			if (obj instanceof SQLException) {
				JDialogMessage.errorDialog( obj, "検索結果取得");
			} else {
				JDialogMessage.errorDialog(obj);
			}
			resetActionStatus();
		}

		private void resetActionStatus() {
			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					actionSelectAbort.setEnabled(false);
					actionSelectContinue.setEnabled(false);
					actionCsvExport.setEnabled(true);
					actionExecSql.setEnabled(true);
				}
			});
		}
		
		public void setResultDetail(ArrayList<Object> rowData) throws IOException {
		}
	}

	/**
	 * コマンド履歴の履歴番号を表示する
	 */
	private void displayIdx() {
		jLabelPageNo.setText("履歴[" + (cmdBuff.getIdx() + 1) + "/"
				+ cmdBuff.size() + "]");
	}

	abstract class ActioinExecute extends ActionBase {
		private static final long serialVersionUID = -243818453050400696L;

		ActioinExecute(String name) {
			super(name);
		}

		final public void actionPerformed(ActionEvent e) {
			execSqlConnection = checkConnect();
			if (execSqlConnection == null) {
				return;
			}
			setMessage(" ");

			SqlAnalyze sa = checkStatement(getSqlStatementCatgolys());
			if (sa == null) {
				return;
			}

			try {
				if (!execute(sa)) {
					return;
				}
			} catch (JdbcacsessException e1) {
				JDialogMessage.errorDialog(e1);
			}

			// コマンド履歴に追加
			cmdBuff.add(sa.getSqlStatement());
			displayIdx();

			jTextPaneSqlStatement.undoDiscard();

		}

		// 実行メソッド
		abstract boolean execute(SqlAnalyze sa) throws JdbcacsessException;

		// 実行を許可するSQL文の配列
		abstract SqlStatementCatgoly[] getSqlStatementCatgolys();

		private Connection checkConnect() {
			if (!SqlExec.isConnect()) {
				JDialogMessage.notConnectErrorDialog();
				execSqlConnection = null;
				jLabelLocation.setIcon(disconnectIcon);
				return null;
			}
			// sql実行用に新たなconnectionを取得
			if (execSqlConnection == null) {
				try {
					execSqlConnection = SqlExec.getNewConnection();
					execSqlConnection.setAutoCommit(autoCommit);
					jLabelLocation.setIcon(connectIcon);
				} catch (Exception e) {
					JDialogMessage.errorDialog(e);
					jLabelLocation.setIcon(disconnectIcon);
					return null;
				}
			}
			return execSqlConnection;
		}

		private SqlAnalyze checkStatement(
				SqlStatementCatgoly[] sqlStatementCatgolys) {
			// 入力されたsql文の解析とチェック
			SqlAnalyze sa = new SqlAnalyze(jTextPaneSqlStatement.getText());

			// 許可リストにあるか検索する
			boolean flg = false;
			for (int i = 0; i < sqlStatementCatgolys.length; i++) {
				if (sqlStatementCatgolys[i].equals(sa.getSqlStatementCatgoly())) {
					flg = true;
					break;
				}
			}
			if (!flg) {
				// 許可リストに無かった
				StringBuffer str = new StringBuffer("");
				for (int i = 0; i < sqlStatementCatgolys.length; i++) {
					if (i != 0) {
						str.append(' ');
					}
					str.append(sqlStatementCatgolys[i]);
				}
				JDialogMessage.errorDialog(new JdbcacsessException(str + " のみ実行出来ます"));
				return null;
			}
			return sa;
		}
	}

	/**
	 * SQLコマンドの実行
	 */
	class ActionExecSql extends ActioinExecute {
		private static final long serialVersionUID = -6660910166029768221L;

		ActionExecSql() {
			super("SQL実行");
		}
		ActionExecSql(String str) {
			super(str);
		}

		@Override
		SqlStatementCatgoly[] getSqlStatementCatgolys() {
			SqlStatementCatgoly[] sql = { SqlStatementCatgoly.SELECT, SqlStatementCatgoly.INSERT,
					SqlStatementCatgoly.DELETE, SqlStatementCatgoly.UPDATE, SqlStatementCatgoly.CALL,
					SqlStatementCatgoly.CREATE, SqlStatementCatgoly.ALTER, SqlStatementCatgoly.DROP,
					SqlStatementCatgoly.GRANT };
			return sql;
		}

		@Override
		boolean execute(SqlAnalyze sqlAnalyze) throws JdbcacsessException {
			if (sqlAnalyze.getSqlStatementCatgoly() == SqlStatementCatgoly.SELECT || sqlAnalyze.getSqlStatementCatgoly() == SqlStatementCatgoly.CALL) {
				actionCsvExport.setEnabled(false);
				actionExecSql.setEnabled(false);


				// インスタンス変数で無く一時変数に作成
				JTableSqlModel jtsm = new JTableSqlModel(execSqlConnection);

				queryExecute = new QueryExecuteThread(this, sqlAnalyze, execSqlConnection);
				queryExecute.setBinaryDatalimit(true);
				queryExecute.addQueryExecuteListener(new ReciveStatus(jtsm));

				queryExecute.addQueryExecuteListener(jtsm);
				queryExecute.addQueryExecuteListener(jTableResults.new RegistCellRendererAndEditor());

				actionSelectAbort.setEnabled(true);
				actionSelectContinue.setEnabled(true);

				// 結果取得スレッドの開始。ディテール編集は editResult 内で行われる
				new Thread(queryExecute).start();

				return true;
			}

			final PrepareExecuteStatement pe = new PrepareExecuteStatement();
			try {
				pe.addStm(sqlAnalyze.getSqlStatement());
				pe.prepare(execSqlConnection);
				if (pe.isHavingInputParameter()){
					JDialogPrepareParameter jdpp = new JDialogPrepareParameter(pe);
					if (!jdpp.isExecuteAns()) {
						return false;
					}
				}
			} catch (SQLException e) {
				JDialogMessage.errorDialog(e, "select以外のコマンド実行");
				return false;
			} catch (JdbcacsessException e) {
				JDialogMessage.errorDialog(e);
				return false;
			}
			new Thread() {
				@Override
				public void run() {
					try {
						int cnt = 0;
						cnt = pe.executeUpdate();
						setMessage(cnt + "行処理しました");
					} catch (SQLException e) {
						JDialogMessage.errorDialog(e, "select以外のコマンド実行");
					}
				}
			}.start();
			return true;
		}
	}

	/**
	 * ＣＳＶ出力
	 */
	class ActionCsvExport extends ActioinExecute {
		private static final long serialVersionUID = -6872871029493035488L;

		public ActionCsvExport() {
			super("CSV出力...");
		}

		@Override
		SqlStatementCatgoly[] getSqlStatementCatgolys() {
			SqlStatementCatgoly[] sql = { SqlStatementCatgoly.SELECT, SqlStatementCatgoly.CALL };
			return sql;
		}
		
		@Override
		boolean execute(SqlAnalyze sa) throws JdbcacsessException {
			// ダイアログの表示
			CsvInfo csvInfo = new CsvInfo();
			csvInfo.currentDataLoad();

			csvInfo.setPropTableName(sa.getSchemaTableName());

			JDialogCsv dlg = new JDialogCsv(CsvMode.EXPORT, csvInfo);
			csvInfo = dlg.getCsvInfo();
			if (csvInfo == null) {
				// ダイアログで取消の場合は終る
				return false;
			}

			actionCsvExport.setEnabled(false);
			actionExecSql.setEnabled(false);

			// SQL検索＆ファイル出力を別スレッドで行う。ファイル出録では中断(wait)は行わない
			queryExecute = new QueryExecuteThread(this, sa, execSqlConnection);
			queryExecute.addQueryExecuteListener(new CsvExport(csvInfo));
			queryExecute.addQueryExecuteListener(new ReciveStatus());

			actionSelectAbort.setEnabled(true);

			new Thread(queryExecute).start();
			
			return true;
		}
	}

	class ActionSelectAbort extends ActionBase {
		private static final long serialVersionUID = 3905192537275202747L;

		ActionSelectAbort() {
			super("取得中止");
		}

		public void actionPerformed(ActionEvent e) {
			if (queryExecute != null) {
				queryExecute.setCancelFlg();
			}
			if (jTableSqlModel != null) {
				jTableSqlModel.nextSearch();
			}
		}
	}

	class ActionSelectContinue extends ActionBase {
		private static final long serialVersionUID = 6826069816727830380L;

		ActionSelectContinue() {
			super("継続取得");
		}

		public void actionPerformed(ActionEvent e) {
			if (jTableSqlModel != null) {
				jTableSqlModel.nextSearch();
			}
		}
	}


	void actionPerformedNext(ActionEvent e) {
		jTextPaneSqlStatement.setText(cmdBuff.next());
		displayIdx();
	}

	void actionPerformedPrev(ActionEvent e) {
		jTextPaneSqlStatement.setText(cmdBuff.prev());
		displayIdx();
	}

	private void actionPerformedClear(ActionEvent e) {
		jTextPaneSqlStatement.setText("");
	}

	
	/**
	 * @return jSplitPane を戻します。
	 * @uml.property name="jSplitPane"
	 */
	private JSplitPane getJSplitPane() {
		if (jSplitPane == null) {
			jSplitPane = new JSplitPane();
			jSplitPane.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
			jSplitPane.setDividerSize(7);
			jSplitPane.setDividerLocation(120);
			jSplitPane.setOneTouchExpandable(true);
			jSplitPane.setTopComponent(getJPanelSqlInput());
			jSplitPane.setBottomComponent(getJScrollPaneResults());
		}
		return jSplitPane;
	}

	/**
	 * @return jButtonClear を戻します。
	 * @uml.property name="jButtonClear"
	 */
	private JButton getJButtonClear() {
		if (jButtonClear == null) {
			jButtonClear = new JButton();
			jButtonClear.setText("");
			jButtonClear.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jButtonClear.setToolTipText("入力されたSQL文をクリアします");
			jButtonClear.setName("jButtonClear");
			jButtonClear.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jButtonClear.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					actionPerformedClear(e);
				}
			});
		}
		return jButtonClear;
	}

	/**
	 * This method initializes jButtonExecSql
	 * 
	 * @return javax.swing.JButton
	 * @uml.property name="jButtonExecSql"
	 */
	private JButton getJButtonExecSql() {
		if (jButtonExecSql == null) {
			jButtonExecSql = new JButton(actionExecSql);
			jButtonExecSql.setText("");
			jButtonExecSql
					.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jButtonExecSql.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jButtonExecSql.setToolTipText("<HTML>入力されたSQL文を実行します。<BR>"
					+ "検索系の場合はSwingと異なるスレッドで実行と結果取得が行われ、検索結果を順次画面表示します<BR>"
					+ "更新系の場合はSwingと同一スレッドで実行され、更新データは表示しません</HTML>");
			jButtonExecSql.setName("jButtonExecSql");
			jButtonExecSql.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jButtonExecSql;
	}
	
	/**
	 * This method initializes jButton2
	 * 
	 * @return javax.swing.JButton
	 * @uml.property name="jButtonCsvExport"
	 */
	private JButton getJButtonCsvExport() {
		if (jButtonCsvExport == null) {
			jButtonCsvExport = new JButton(actionCsvExport);
			jButtonCsvExport.setText("");
			jButtonCsvExport
					.setHorizontalAlignment(javax.swing.SwingConstants.LEADING);
			jButtonCsvExport.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jButtonCsvExport
					.setToolTipText("入力された検索SQL文を実行し、結果をCSVファイルに出力します。画面は更新されません");
			jButtonCsvExport.setName("jButtonCsvExport");
			jButtonCsvExport.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
		}
		return jButtonCsvExport;
	}

	/**
	 * @return jButtonNext を戻します。
	 * @uml.property name="jButtonNext"
	 */
	private JButton getJButtonNext() {
		if (jButtonNext == null) {
			jButtonNext = new JButton();
			jButtonNext.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jButtonNext.setToolTipText("入力されたSQL文履歴を未来方向に進めて表示します");
			jButtonNext.setName("jButtonNext");
			jButtonNext.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jButtonNext.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					actionPerformedNext(e);
				}
			});
		}
		return jButtonNext;
	}

	/**
	 * @return jButtonPrev を戻します。
	 * @uml.property name="jButtonPrev"
	 */
	private JButton getJButtonPrev() {
		if (jButtonPrev == null) {
			jButtonPrev = new JButton();
			jButtonPrev.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jButtonPrev.setToolTipText("入力されたSQL文履歴を過去方向に遡って表示します");
			jButtonPrev.setName("jButtonPrev");
			jButtonPrev.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jButtonPrev.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					actionPerformedPrev(e);
				}
			});
		}
		return jButtonPrev;
	}

	/**
	 * This method initializes jButtonSelectAbort
	 * 
	 * @return javax.swing.JButton
	 * @uml.property name="jButtonSelectAbort"
	 */
	private JButton getJButtonSelectAbort() {
		if (jButtonSelectAbort == null) {
			jButtonSelectAbort = new JButton(actionSelectAbort);
			jButtonSelectAbort.setText("");
			jButtonSelectAbort.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jButtonSelectAbort.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jButtonSelectAbort.setName("jButtonSelectAbort");
			jButtonSelectAbort.setToolTipText("大量検索結果の為取得を中断している時に中止します");
			actionSelectAbort.setEnabled(false);
		}
		return jButtonSelectAbort;
	}

	/**
	 * This method initializes jButtonExecSql
	 * 
	 * @return javax.swing.JButton
	 * @uml.property name="jButtonSelectContinue"
	 */
	private JButton getJButtonSelectContinue() {
		if (jButtonSelectContinue == null) {
			jButtonSelectContinue = new JButton(actionSelectContinue);
			jButtonSelectContinue.setText("");
			jButtonSelectContinue.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jButtonSelectContinue.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jButtonSelectContinue.setName("jButtonSelectContinue");
			jButtonSelectContinue.setToolTipText("大量検索結果の為中断している時に続きを取得します");
			actionSelectContinue.setEnabled(false);
		}
		return jButtonSelectContinue;
	}

	/**
	 * @return jLabelPageNo を戻します。
	 * @uml.property name="jLabelPageNo"
	 */
	private JLabel getJLabelPageNo() {
		if (jLabelPageNo == null) {
			jLabelPageNo = new JLabel();
			jLabelPageNo.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jLabelPageNo.setToolTipText("入力されたSQL文履歴の現在位置です。");
			jLabelPageNo.setName("jLabelPageNo");
			jLabelPageNo.setText("");
		}
		return jLabelPageNo;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 * @uml.property name="jPanelCommand"
	 */
	private JPanel getJPanelCommand() {
		if (jPanelCommand == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setAlignment(FlowLayout.LEFT);
			jPanelCommand = new JPanel();
			jPanelCommand.setLayout(flowLayout1);
			jPanelCommand.add(getJButtonExecSql(), null);
			jPanelCommand.add(getJLabelPageNo(), null);
			jPanelCommand.add(getJButtonPrev(), null);
			jPanelCommand.add(getJButtonNext(), null);
			jPanelCommand.add(getJButtonSelectContinue(), null);
			jPanelCommand.add(getJButtonSelectAbort(), null);
			jPanelCommand.add(getJButtonCsvExport(), null);
			jPanelCommand.add(getJButtonClear(), null);
			jPanelCommand.add(getJButtonClose(), null);
			jPanelCommand.add(getJButtonCommit(), null);
			jPanelCommand.add(getJButtonRollBack(), null);
			jPanelCommand.add(getJComboBoxAutoCommit(), null);
		}
		return jPanelCommand;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 * @uml.property name="jPanelSqlInput"
	 */
	private JPanel getJPanelSqlInput() {
		if (jPanelSqlInput == null) {
			jPanelSqlInput = new JPanel();
			jPanelSqlInput.setLayout(new BorderLayout());
			jPanelSqlInput.add(getJPanelSalStatement(),
					java.awt.BorderLayout.CENTER);
		}
		return jPanelSqlInput;
	}

	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 * @uml.property name="jScrollPaneResults"
	 */
	private JScrollPane getJScrollPaneResults() {
		if (jScrollPaneResults == null) {
			jScrollPaneResults = new JScrollPane();
			jScrollPaneResults
					.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPaneResults
					.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
			jScrollPaneResults.setViewportView(getJTableResults());
		}
		return jScrollPaneResults;
	}

	/**
	 * This method initializes jTableResults
	 * 
	 * @return jdbcacsess.gui.JTableSql
	 * @uml.property name="jTableResults"
	 */
	private JTableSql getJTableResults() {
		if (jTableResults == null) {
			jTableResults = new JTableSql();
			jTableResults.getSelectionModel().addListSelectionListener(
					new ListSelectionListener() {
						public void valueChanged(ListSelectionEvent e) {
							jLabelLocation.setText(getCurrentCellPosition());
						}
					});
			jTableResults.getColumnModel().getSelectionModel()
					.addListSelectionListener(new ListSelectionListener() {
						public void valueChanged(ListSelectionEvent e) {
							jLabelLocation.setText(getCurrentCellPosition());
						}
					});
		}
		return jTableResults;
	}

	private String getCurrentCellPosition() {
		return (jTableResults.getSelectedColumn() + 1) + " : "
				+ (jTableResults.getSelectedRow() + 1) + "  ";
	}

	/**
	 * This method initializes jTextArea1
	 * 
	 * @return javax.swing.JTextArea
	 * @uml.property name="jTextPaneSqlStatement"
	 */
	private JTextPaneSqlStatement getJTextPaneSqlStatement() {
		if (jTextPaneSqlStatement == null) {
			jTextPaneSqlStatement = new JTextPaneSqlStatement();
		}
		return jTextPaneSqlStatement;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 * @uml.property name="jPanelSalStatement"
	 */
	private JPanel getJPanelSalStatement() {
		if (jPanelSalStatement == null) {
			jPanelSalStatement = new JPanel();
			jPanelSalStatement.setLayout(new BorderLayout());
			jPanelSalStatement
					.setBorder(javax.swing.BorderFactory
							.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED));
			jPanelSalStatement.add(getJScrollPane(),
					java.awt.BorderLayout.CENTER);
		}
		return jPanelSalStatement;
	}

	/**
	 * @return jScrollPane を戻します。
	 * @uml.property name="jScrollPane"
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane
					.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane.setViewportView(getJTextPaneSqlStatement());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jButtonClose
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonClose() {
		if (jButtonClose == null) {
			jButtonClose = new JButton();
			jButtonClose.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jButtonClose.setToolTipText("SQL実行画面を閉じます");
			jButtonClose.setName("jButtonClose");
			jButtonClose.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jButtonClose.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					actionPerformedSelectClose();
				}
			});
		}
		return jButtonClose;
	}

	private void actionPerformedSelectClose() {
		disconnect();
		JFrameMain jFrameMain = (JFrameMain)JFrameMain.serachComponent(JPanelExecSql.this, JFrameMain.class);
		jFrameMain.getTabWinManager().disposePanel(this);
	}

	public void disconnect() {
		actionSelectAbort.actionPerformed(null);
		new Thread() {
			@Override
			public void run() {
				SqlExec.disconnect(execSqlConnection);
				execSqlConnection=null;
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {
						jLabelLocation.setIcon(disconnectIcon);
					}
				});
			}
		}.start();
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonCommit() {
		if (jButtonCommit == null) {
			jButtonCommit = new JButton();
			jButtonCommit.setText("");
			jButtonCommit.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jButtonCommit
					.setToolTipText("commitします。但し、ManualCommitでSQL実行画面を開いた時のみ有効です");
			jButtonCommit.setName("jButtonCommit");
			jButtonCommit.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jButtonCommit
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedCommit();
						}
					});
		}
		return jButtonCommit;
	}

	private void actionPerformedCommit() {
		if (execSqlConnection != null) {
			setMessage("Commitを開始します... ");
			new Thread() {
				@Override
				public void run() {
					try {
						execSqlConnection.commit();
						setMessage("Commitしました");
					} catch (SQLException e) {
						JDialogMessage.errorDialog(e, "Commitでエラー発生");
					}
				}
			}.start();
		}
	}

	private void actionPerformedRollBack() {
		if (execSqlConnection != null) {
			setMessage("RollBackを開始します... ");
			new Thread() {
				@Override
				public void run() {
					try {
						execSqlConnection.rollback();
						setMessage("RollBackしました");
					} catch (SQLException e) {
						JDialogMessage.errorDialog(e, "RollBackでエラー発生");
					}
				}
			}.start();
		}
	}

	/**
	 * This method initializes jButtonRollBack
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonRollBack() {
		if (jButtonRollBack == null) {
			jButtonRollBack = new JButton();
			jButtonRollBack.setText("");
			jButtonRollBack.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 12));
			jButtonRollBack
					.setToolTipText("rollbackします。但し、ManualCommitでSQL実行画面を開いた時のみ有効です");
			jButtonRollBack.setName("jButtonRollBack");
			jButtonRollBack.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jButtonRollBack
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedRollBack();
						}
					});
		}
		return jButtonRollBack;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelMessage() {
		if (jPanelMessage == null) {

			jLabelLocation = new JLabel();
			jLabelLocation.setText("");
			jLabelLocation.setIcon(disconnectIcon);

			jLabelMessage = new JLabel();
			jLabelMessage.setText(" ");
			jLabelMessage.setFont(new java.awt.Font("Dialog",
					java.awt.Font.PLAIN, 14));

			jPanelMessage = new JPanel();
			jPanelMessage.setLayout(new BorderLayout());
			jPanelMessage.add(jLabelLocation, java.awt.BorderLayout.WEST);
			jPanelMessage.add(jLabelMessage, java.awt.BorderLayout.CENTER);
		}
		return jPanelMessage;
	}

	/**
	 * This method initializes jComboBoxAutoCommit	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBoxAutoCommit() {
		if (jComboBoxAutoCommit == null) {
			jComboBoxAutoCommit = new JComboBox();
			jComboBoxAutoCommit.setName("jComboBoxAutoCommit");
			jComboBoxAutoCommit.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					ConstAutoCommit item = (ConstAutoCommit)jComboBoxAutoCommit.getSelectedItem();
					try {
						setAutoCommit(item.getValue());
					} catch (SQLException err) {
						JDialogMessage.errorDialog(err, "AutoCommit設定");
					}
				}
			});
		}
		return jComboBoxAutoCommit;
	}

}
