/**
 * 
 */
package jdbcacsess.gui;

import java.awt.BorderLayout;
import java.awt.Font;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingUtilities;

import jdbcacsess.gui.common.JTextAreaNoEdit;

/**
 * @author sima
 * 
 */
public class JPanelPrepareStatementLog extends JPanel {
	private JScrollPane jScrollPane = null;

	private JTextAreaNoEdit jTextArea = null;

	/**
	 * 
	 */
	private static final long serialVersionUID = -5942780717732327985L;

	public JPanelPrepareStatementLog() {
		super();

		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		setLayout(new BorderLayout());
		add(getJScrollPane(), java.awt.BorderLayout.CENTER);
		setName("Log");
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane
					.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
			jScrollPane
					.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane.setViewportView(getJTextArea());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextAreaNoEdit();
			jTextArea.setFont(new Font("Monospaced", Font.PLAIN, 12));
			jTextArea.setLineWrap(true);
		}
		return jTextArea;
	}

	/**
	 * @param sb
	 */
	public void appendLog(final String s) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				if (jTextArea.getText().length() > 50000) {
					jTextArea.setText("");
				}
				int l = jTextArea.getText().length();
				jTextArea.insert(s, l);
				jTextArea.setCaretPosition(l);
			}
		});
	}
	public void appendLog(final StringBuilder sb) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				appendLog(sb.toString());
			}
		});
	}
}
