package jdbcacsess.gui;

import java.awt.BorderLayout;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.Vector;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.SwingUtilities;
import javax.swing.table.DefaultTableModel;

import jdbcacsess.gui.common.ColumnWidth;
import jdbcacsess.sql.ConstSqlTypes;

@SuppressWarnings("serial")
public class JPanelResultSetMetaData extends JPanel {

	private JScrollPane jScrollPane = null;

	private JTable jTable = null;

	private Vector<Object> header;

	Vector<Object> tblgetCatalogName;

	Vector<Object> tblgetColumnClassName;

	Vector<Object> tblgetColumnDisplaySize;

	Vector<Object> tblgetColumnLabel; // @jve:decl-index=0:

	Vector<Object> tblgetColumnName;

	Vector<Object> tblgetColumnType;

	Vector<Object> tblgetColumnSqlTypeName;

	Vector<Object> tblgetColumnTypeName;

	Vector<Object> tblgetPrecision;

	Vector<Object> tblgetScale;

	Vector<Object> tblgetSchemaName;

	Vector<Object> tblgetTableName;

	Vector<Object> tblisAutoIncrement;

	Vector<Object> tblisCaseSensitive;

	Vector<Object> tblisCurrency;

	Vector<Object> tblisDefinitelyWritable;

	Vector<Object> tblisNullable;

	Vector<Object> tblisReadOnly;

	Vector<Object> tblisSearchable;

	Vector<Object> tblisSigned;

	Vector<Object> tblisWritable;

	Vector<Object> tblRealClassName;

	private Vector<Vector<Object>> tblRow;

	/**
	 * This is the default constructor
	 * 
	 * @throws SQLException
	 */
	public JPanelResultSetMetaData() {

		setFixedCoulumn();

		initialize();
	}

	private void setFixedCoulumn() {
		header = new Vector<Object>();
		tblgetCatalogName = new Vector<Object>();
		tblgetColumnClassName = new Vector<Object>();
		tblgetColumnDisplaySize = new Vector<Object>();
		tblgetColumnLabel = new Vector<Object>();
		tblgetColumnName = new Vector<Object>();
		tblgetColumnType = new Vector<Object>();
		tblgetColumnSqlTypeName = new Vector<Object>();
		tblgetColumnTypeName = new Vector<Object>();
		tblgetPrecision = new Vector<Object>();
		tblgetScale = new Vector<Object>();
		tblgetSchemaName = new Vector<Object>();
		tblgetTableName = new Vector<Object>();
		tblisAutoIncrement = new Vector<Object>();
		tblisCaseSensitive = new Vector<Object>();
		tblisCurrency = new Vector<Object>();
		tblisDefinitelyWritable = new Vector<Object>();
		tblisNullable = new Vector<Object>();
		tblisReadOnly = new Vector<Object>();
		tblisSearchable = new Vector<Object>();
		tblisSigned = new Vector<Object>();
		tblisWritable = new Vector<Object>();
		tblRealClassName = new Vector<Object>();

		tblRow = new Vector<Vector<Object>>();

		tblRow.add(tblgetCatalogName);
		tblRow.add(tblgetColumnClassName);
		tblRow.add(tblgetColumnDisplaySize);
		tblRow.add(tblgetColumnLabel);
		tblRow.add(tblgetColumnName);
		tblRow.add(tblgetColumnType);
		tblRow.add(tblgetColumnSqlTypeName);
		tblRow.add(tblgetColumnTypeName);
		tblRow.add(tblgetPrecision);
		tblRow.add(tblgetScale);
		tblRow.add(tblgetSchemaName);
		tblRow.add(tblgetTableName);
		tblRow.add(tblisAutoIncrement);
		tblRow.add(tblisCaseSensitive);
		tblRow.add(tblisCurrency);
		tblRow.add(tblisDefinitelyWritable);
		tblRow.add(tblisNullable);
		tblRow.add(tblisReadOnly);
		tblRow.add(tblisSearchable);
		tblRow.add(tblisSigned);
		tblRow.add(tblisWritable);
		tblRow.add(tblRealClassName);

		header.add("概要");
		tblgetCatalogName.add("列のテーブルのカタログ名");
		tblgetColumnClassName.add("Java クラスの完全名前");
		tblgetColumnDisplaySize.add("列の通常の最大幅を文字数");
		tblgetColumnLabel.add("印刷や表示に使用する列の推奨タイトル");
		tblgetColumnName.add("列の名前");
		tblgetColumnType.add("列の SQL 型");
		tblgetColumnSqlTypeName.add("★列の SQL 型の名称★");
		tblgetColumnTypeName.add("列のデータベース固有の型名");
		tblgetPrecision.add("列の 10 進桁数");
		tblgetScale.add("列の小数点以下の桁数");
		tblgetSchemaName.add("列のテーブルのスキーマ");
		tblgetTableName.add("列のテーブル名");
		tblisAutoIncrement.add("列が自動的番号付され読取専用で扱れるか");
		tblisCaseSensitive.add("列の大文字と小文字が区別されるか");
		tblisCurrency.add("列がキャッシュの値か");
		tblisDefinitelyWritable.add("列の書き込みが必ず成功するか");
		tblisNullable.add("列に NULL をセットできるか");
		tblisReadOnly.add("列が絶対的に書き込み可能でないか");
		tblisSearchable.add("列を where 節で使用できるか");
		tblisSigned.add("列の値が符号付き数値か");
		tblisWritable.add("列への書き込みを成功させることができるか");
		tblRealClassName.add("★getObjectのクラス名★");

		header.add("メソッド名");
		tblgetCatalogName.add("getCatalogName()");
		tblgetColumnClassName.add("getColumnClassName()");
		tblgetColumnDisplaySize.add("getColumnDisplaySize()");
		tblgetColumnLabel.add("getColumnLabel()");
		tblgetColumnName.add("getColumnName()");
		tblgetColumnType.add("getColumnType()");
		tblgetColumnSqlTypeName.add("★conv()★");
		tblgetColumnTypeName.add("getColumnTypeName()");
		tblgetPrecision.add("getPrecision()");
		tblgetScale.add("getScale()");
		tblgetSchemaName.add("getSchemaName()");
		tblgetTableName.add("getTableName()");
		tblisAutoIncrement.add("isAutoIncrement()");
		tblisCaseSensitive.add("isCaseSensitive()");
		tblisCurrency.add("isCurrency()");
		tblisDefinitelyWritable.add("isDefinitelyWritable()");
		tblisNullable.add("isNullable()");
		tblisReadOnly.add("isReadOnly()");
		tblisSearchable.add("isSearchable()");
		tblisSigned.add("isSigned()");
		tblisWritable.add("isWritable()");
		tblRealClassName.add("getObject()");
	}

	public void setData(ResultSet rs) {
		setFixedCoulumn();
		try {

			ResultSetMetaData md = rs.getMetaData();
			for (int i = 1; i <= md.getColumnCount(); i++) {
				header.add(Integer.toString(i));
				setInfoAdd(rs, i);
			}

		} catch (SQLException e) {
			e.printStackTrace();
		}
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {

				DefaultTableModel tableModel = new DefaultTableModel(tblRow,
						header);
				jTable.setModel(tableModel);
				ColumnWidth.setColumnWidthResizeOff(jTable);
			}
		});
	}

	private void setInfoAdd(ResultSet rs, int column) throws SQLException {

		ResultSetMetaData md = rs.getMetaData();

		tblgetCatalogName.add(md.getCatalogName(column));
		tblgetColumnClassName.add(md.getColumnClassName(column));
		tblgetColumnDisplaySize.add(md.getColumnDisplaySize(column));
		tblgetColumnLabel.add(md.getColumnLabel(column));
		tblgetColumnName.add(md.getColumnName(column));
		tblgetColumnType.add(md.getColumnType(column));
		
		tblgetColumnSqlTypeName.add(ConstSqlTypes.searchTypes(md.getColumnType(column)
				).toString());
		
		tblgetColumnTypeName.add(md.getColumnTypeName(column));
		tblgetPrecision.add(md.getPrecision(column));
		tblgetScale.add(md.getScale(column));
		tblgetSchemaName.add(md.getSchemaName(column));
		tblgetTableName.add(md.getTableName(column));
		tblisAutoIncrement.add(md.isAutoIncrement(column));
		tblisCaseSensitive.add(md.isCaseSensitive(column));
		tblisCurrency.add(md.isCurrency(column));
		tblisDefinitelyWritable.add(md.isDefinitelyWritable(column));
		tblisNullable.add(md.isNullable(column));
		tblisReadOnly.add(md.isReadOnly(column));
		tblisSearchable.add(md.isSearchable(column));
		tblisSigned.add(md.isSigned(column));
		tblisWritable.add(md.isWritable(column));
		Object o = rs.getObject(column);
		if (o == null) {
			tblRealClassName.add("#NULL#");
		} else {
			tblRealClassName.add(o.getClass().getName());
		}

	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setName("QueryResultSet");
		setLayout(new BorderLayout());
		add(getJScrollPane(), java.awt.BorderLayout.CENTER);

	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTable());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private JTable getJTable() {
		if (jTable == null) {
			jTable = new JTable(tblRow, header);
		}
		return jTable;
	}
}
