/*
 * 作成日: 2004/01/12
 *
 * この生成されたコメントの挿入されるテンプレートを変更するため
 * ウィンドウ > 設定 > Java > コード生成 > コードとコメント
 */
package jdbcacsess.gui;

import java.awt.Component;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.event.ActionEvent;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Enumeration;

import javax.swing.AbstractAction;
import javax.swing.ActionMap;
import javax.swing.JFileChooser;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.SwingUtilities;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;

import jdbcacsess.JdbcacsessException;
import jdbcacsess.csv.CSVLine;
import jdbcacsess.gui.cell.FileOutputBinary;
import jdbcacsess.gui.cell.FileOutputCharcter;
import jdbcacsess.gui.cell.JFrameSqlData;
import jdbcacsess.gui.cell.JFrameViewerHex;
import jdbcacsess.gui.cell.JFrameViewerImage;
import jdbcacsess.gui.cell.ViewColumn;
import jdbcacsess.gui.cell.ViewerGetBinaryStream;
import jdbcacsess.gui.cell.ViewerGetBlob;
import jdbcacsess.gui.cell.ViewerGetBytes;
import jdbcacsess.gui.cell.ViewerGetChracterStream;
import jdbcacsess.gui.cell.ViewerGetString;
import jdbcacsess.gui.common.JDialogMessage;
import jdbcacsess.gui.common.JFileChooserLastUse;
import jdbcacsess.gui.common.JPopupMenuCnageUI;
import jdbcacsess.gui.common.PopupKeybordAndMouse;
import jdbcacsess.sql.ColumnInfoResult;
import jdbcacsess.sql.QueryExecuteAdapter;
import jdbcacsess.sql.SqlAnalyze;
import jdbcacsess.sql.column.BinaryInputStream;
import jdbcacsess.sql.column.CharacterInputStream;
import jdbcacsess.sql.column.DenyEditInCell;

/**
 * @author sima この生成されたコメントの挿入されるテンプレートを変更するため ウィンドウ > 設定 > Java > コード生成 >
 *         コードとコメント
 */
/**
 * @author sima
 * 
 */
public class JTableSql extends JTable implements ClipboardOwner {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3304832537800845261L;

	private JPopupMenuCnageUI jPopupMenu = null; 

	private JMenuItem jMenuItemSetNULL = null;

	private JMenuItem jMenuItemRowDelete = null;

	private JMenuItem jMenuItemRowInsert = null;

	private JMenuItem jMenuItemRowInsertNull = null;

	private JMenuItem jMenuItemRowCopy = null;

	private JMenuItem jMenuItemToClipRangeComma = null;

	private JMenuItem jMenuItemToClipRangeTab = null;

	private JMenuItem jMenuItemToClipRangeCond = null;

	private JMenuItem jMenuItemDefaultInsert = null;

	private JMenuItem jMenuItemSelectRow = null;

	private JMenuItem jMenuItemSelectAll = null;

	private JMenuItem jMenuItemSqlDataTree = null;
	
	private JMenuItem jMenuItemHexGetBinaryStream = null;

	private JMenu jMenuHexViewer = null;

	private JMenuItem jMenuItemHexGetBlob = null;

	private JMenuItem jMenuItemHexGetBytes;

	private JMenu jMenuInputFile = null;

	private JMenuItem jMenuItemInputFileBinary = null;

	private JMenuItem jMenuItemInputFileChar = null;

	private JMenu jMenuOutputFile = null;

	private JMenuItem jMenuItemOutputFileBinary = null;

	private JMenuItem jMenuItemOutputFileChar = null;

	private JMenuItem jMenuItemTextEditer = null;

	private JMenuItem jMenuItemHexGetString = null;

	private JMenu jMenuImageViewer = null;

	private JMenuItem jMenuItemImageGetBinaryStream = null;

	private JMenuItem jMenuItemImageGetBlob = null;

	private JFileChooserLastUse lastOutputFile;

	private JFileChooserLastUse lastInputFile;

	private JMenuItem jMenuItemSqlMapping = null;

	public JTableSql() {
		super();
		initialize();
	}

	private void initialize() {
		setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);

		this.setCellSelectionEnabled(true);
		// 列の並び替えは許可しない。
		getTableHeader().setReorderingAllowed(false);

		setSelectionMode(javax.swing.ListSelectionModel.SINGLE_INTERVAL_SELECTION);

		// テーブルデータ変更イベントリスナー
		ListSelectionModel model = getSelectionModel();
		model.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				tableSelectionValueChanged(e);
			}
		});

		new PopupKeybordAndMouse(this, getJPopupMenu());

		jPopupMenu.addPopupMenuListener(new PopupMenuListener() {
			public void popupMenuCanceled(PopupMenuEvent e) {
			}

			public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
			}

			public void popupMenuWillBecomeVisible(PopupMenuEvent e) {
				int row = getSelectedRow();
				int col = getSelectedColumn();
				if (row < 0 || col < 0) {
					return;
				}

				JTableSqlModel model = (JTableSqlModel) getModel();
				CellMode cellMode = model.getMode(row, col);

				// 更新可能状態を判定し、ポップアップメニューの可視制御
				if (model.isCellEditable(row, col)) {
					jMenuItemRowDelete.setEnabled(true);
					jMenuItemRowCopy.setEnabled(true);
				} else {
					if (cellMode == CellMode.CELL_INSERT) {
						jMenuItemRowDelete.setEnabled(true);
					} else {
						jMenuItemRowDelete.setEnabled(false);
					}
					jMenuItemRowCopy.setEnabled(false);
				}

				if (model.isTableEditable()) {
					switch (cellMode) {
					case CELL_NON:
					case CELL_UPDATE:
					case CELL_UPDATE_COMPLETE:
					case CELL_INSERT:
					case CELL_INSERT_COMPLETE:
					case CELL_DENYEDIT_IN_CELL:
						jMenuItemSetNULL.setEnabled(true);
						break;
					default:
						jMenuItemSetNULL.setEnabled(false);
					}
				} else {
					jMenuItemSetNULL.setEnabled(false);
				}

				jMenuHexViewer.setEnabled(false);
				jMenuImageViewer.setEnabled(false);
				jMenuInputFile.setEnabled(false);
				jMenuItemTextEditer.setEnabled(false);
				jMenuOutputFile.setEnabled(false);
				if (model.isTableEditable() && getSelectedRowCount() == 1
						&& getSelectedColumnCount() == 1) {
					switch (cellMode) {
					case CELL_NON:
					case CELL_UPDATE:
					case CELL_UPDATE_COMPLETE:
					case CELL_INSERT_COMPLETE:
					case CELL_DENYEDIT_IN_CELL:
						jMenuHexViewer.setEnabled(true);
						jMenuImageViewer.setEnabled(true);
						jMenuInputFile.setEnabled(true);
						jMenuItemTextEditer.setEnabled(true);
						jMenuOutputFile.setEnabled(true);
						break;
					}
				}

				if (cellMode == CellMode.CELL_INSERT) {
					jMenuItemDefaultInsert.setEnabled(true);
					if (model.isDefaultInsert(row, col)) {
						jMenuItemDefaultInsert.setText("Insertから除外しない");
					} else {
						jMenuItemDefaultInsert.setText("Insertから除外する");
					}
				} else {
					jMenuItemDefaultInsert.setEnabled(false);
				}
			}

		});

		// ショートカットキーの設定
		ActionMap am = getActionMap();
		am.put("copy", new AbstractAction() {
			private static final long serialVersionUID = 5414012911084954750L;

			public void actionPerformed(ActionEvent e) {
				actionPerformedCopyRange('\t');
			}
		});

		// 最後に選択したファイル
		lastInputFile = new JFileChooserLastUse("入力ファイルを指定して下さい",
				JFileChooser.OPEN_DIALOG);
		lastOutputFile = new JFileChooserLastUse("出力ファイルを指定して下さい",
				JFileChooser.SAVE_DIALOG);

		// 行の高さをフォントの大きさから求める
		setRowHeight(getFontMetrics(CellRendererSqlTable.tableFont).getHeight());
	}

	/**
	 * セルレンダラ－とセルエディターを、検索結果見出しから設定する。
	 * Jtableのヘッダーモデルには、JTableからしかアクセス出来ないので、ここで内部クラスとして実装している
	 * QueryExecuteAdapterを実装しているので、検索系ＳＱＬ実行時に通知を受取る事が出来ます。
	 */
	public class RegistCellRendererAndEditor extends QueryExecuteAdapter {
		@Override
		public void setResultHeader(final ArrayList<ColumnInfoResult> rowData, SqlAnalyze sqlAnalyze,boolean flg) {
			SwingUtilities.invokeLater(new Runnable() {
	            public void run() {
	    			Enumeration<TableColumn> cols = getColumnModel().getColumns();

	    			int idx = 0;
	    			while (cols.hasMoreElements()) {
	    				TableColumn col = cols.nextElement();

	    				// 見出しの表示幅を設定。
	    				TableCellRenderer headerRenderer = col.getHeaderRenderer();
	    				if (headerRenderer == null) {
	    					headerRenderer = getTableHeader().getDefaultRenderer();
	    				}
	    				Component c = headerRenderer.getTableCellRendererComponent(
	    						JTableSql.this, "", false, false, -1, idx);
	    				int w = c.getFontMetrics(c.getFont()).stringWidth(
	    						rowData.get(idx).getColumnName())
	    						+ getColumnModel().getColumnMargin() * 2 + 4;
	    				col.setPreferredWidth(w);

	    				// セルレンダラーの設定
	    				col.setCellRenderer(rowData.get(idx).getTableCellRenderer());

	    				// セルエディターの設定
	    				col.setCellEditor(rowData.get(idx).getTableCellEditor());

	    				idx++;
	    			}
	    			requestFocusInWindow();
	            }
			});
		}
	}

	/**
	 * ｓｑｌデータテーブルの選択範囲をクリップボードに転送する
	 */
	public void lostOwnership(Clipboard clipboard, Transferable contents) {
		System.out.println("クリップボード所有権を失いました");
	}

	private void actionPerformedCopyRange(char delim) {
		Clipboard cb = getToolkit().getSystemClipboard();

		String lineSeparator = System.getProperty("line.separator");
		JTableSqlModel tbl = (JTableSqlModel) getModel();

		int selCols[] = getSelectedColumns();
		int selRows[] = getSelectedRows();

		StringBuffer selectString = new StringBuffer();
		for (int idxCol = 0; idxCol < selCols.length; idxCol++) {
			if (idxCol != 0) {
				selectString.append(delim);
			}
			selectString.append(tbl.getColumnName(selCols[idxCol]));
		}
		selectString.append(lineSeparator);

		String nullValue = JFrameSetting.getColumnOutNullValue();
		boolean msgout = false;
		for (int idxRow = 0; idxRow < selRows.length; idxRow++) {
			CellMode cellMode = tbl.getMode(selRows[idxRow], 0);
			if (cellMode == CellMode.CELL_DELETE_COMPLETE) {
				msgout = msg(msgout);
				continue;
			}
			// 削除以外ならコピー対象
			CSVLine csvline = new CSVLine();
			csvline.setToken(delim);

			for (int idxCol = 0; idxCol < selCols.length; idxCol++) {
				Object o = tbl.getValueAt(selRows[idxRow], selCols[idxCol]);
				if (o != null) {
					csvline.addItem(o.toString());
				} else {
					csvline.addItem(nullValue);
				}
			}
			if (csvline.size() != 0) {
				selectString.append(csvline.getLine()).append(lineSeparator);
			}
		}
		StringSelection ss = new StringSelection(selectString.toString());
		cb.setContents(ss, this);
	}

	/**
	 * 
	 */
	private void actionPerformedCopyCond() {
		Clipboard cb = getToolkit().getSystemClipboard();

		String lineSeparator = System.getProperty("line.separator");
		JTableSqlModel tbl = (JTableSqlModel) getModel();

		int selCols[] = getSelectedColumns();
		int selRows[] = getSelectedRows();

		StringBuffer selectString = new StringBuffer();
		boolean msgout = false;
		for (int idxRow = 0; idxRow < selRows.length; idxRow++) {
			CellMode cellMode = tbl.getMode(selRows[idxRow], selCols[0]);
			if (cellMode == CellMode.CELL_DELETE_COMPLETE) {
				msgout = msg(msgout);
				continue;
			}

			if (idxRow != 0) {
				selectString.append(lineSeparator);
				selectString.append("or ");
			}

			selectString.append("(");
			for (int idxCol = 0; idxCol < selCols.length; idxCol++) {
				if (idxCol != 0) {
					selectString.append(" and ");
				}

				selectString.append(tbl.getColumnName(selCols[idxCol]));

				Object o = tbl.getValueAt(selRows[idxRow], selCols[idxCol]);
				if (o == null) {
					selectString.append(" is NULL ");
				} else {
					selectString.append(" = ");
					if (!Number.class.isAssignableFrom(o.getClass())) {
						selectString.append("'");
					}
					selectString.append(o.toString());
					if (!Number.class.isAssignableFrom(o.getClass())) {
						selectString.append("'");
					}
				}
			}
			selectString.append(")");
		}

		selectString.append(lineSeparator);

		StringSelection ss = new StringSelection(selectString.toString());
		cb.setContents(ss, this);
	}

	/**
	 * @param msgout
	 * @return
	 */
	private boolean msg(boolean msgout) {
		if (!msgout) {
			JDialogMessage.infoDialog("選択されたセルの中に削除済行が含まれています。"
					+ "削除済行はクリップボードにコピーしませんでした。", "削除済行が含まれています");
			msgout = true;
		}
		return msgout;
	}

	/**
	 * データモデルにNULL更新を依頼
	 * 
	 * @param e
	 */
	private void actionPerformedSetNULL(ActionEvent e) {
		JTableSqlModel tbl = (JTableSqlModel) getModel();
		int[] rows = getSelectedRows();
		int[] columns = getSelectedColumns();
		if (rows.length == 0 || columns.length == 0) {
			return;
		}

		tbl.setValueAt(null, rows, columns);
	}

	/**
	 * データモデルにdefault insertの反転を依頼
	 * 
	 * @param e
	 */
	private void actionPerformedDefaultInsert(ActionEvent e) {
		JTableSqlModel tbl = (JTableSqlModel) getModel();
		for (int col : getSelectedColumns()) {
			for (int row : getSelectedRows()) {
				tbl.reverseDefaultInsert(row, col);
			}
		}
	}

	/**
	 * データモデルに行削除を依頼
	 * 
	 * @param e
	 */
	private void actionPerformedRowDelete(ActionEvent e) {
		JTableSqlModel sqlTableModel = (JTableSqlModel) getModel();
		sqlTableModel.rowDelete(getSelectedRows());
	}

	/**
	 * データモデルに行追加を依頼。新規行を用意するだけでDB更新は行わない
	 * 
	 * @param e
	 */
	private void actionPerformedRowInsert(ActionEvent e) {
		JTableSqlModel sqlTableModel = (JTableSqlModel) getModel();
		sqlTableModel.rowCopy(getSelectedRows()[0],
				RowInsertValueMode.VALUEROWNEW);
	}

	private void actionPerformedRowInsertNull(ActionEvent e) {
		JTableSqlModel sqlTableModel = (JTableSqlModel) getModel();
		sqlTableModel.rowCopy(getSelectedRows()[0],
				RowInsertValueMode.ALLNULLROWNEW);
	}

	/**
	 * データモデルに行複写を依頼
	 * 
	 * @param e
	 */
	private void actionPerformedRowCopy(ActionEvent e) {
		JTableSqlModel sqlTableModel = (JTableSqlModel) getModel();
		sqlTableModel.rowCopy(getSelectedRows()[0], RowInsertValueMode.ROWCOPY);
	}

	/**
	 * 行の選択が変更になったことを受けて、INSERT発行処理をデータモデルに依頼する
	 * 
	 * @param e
	 */
	private void tableSelectionValueChanged(ListSelectionEvent e) {
		if (e.getValueIsAdjusting()) {
			// 最後のイベントだけを処理対象とする。他のイベントは捨てる
			return;
		}
		if (getSelectedRow() == -1) {
			return;
		}
		JTableSqlModel sqlTableModel = (JTableSqlModel) getModel();
		sqlTableModel.rowInsert(getSelectedRow());
	}

	/**
	 * 
	 */
	private void actionPerformedSqlDataTree() {
		int selectedRow = getSelectedRows()[0];
		int selectedCol = getSelectedColumns()[0];

		JTableSqlModel sqlTableModel = (JTableSqlModel) getModel();

		
		
		JFrameSqlData.getInstance().setTopObject(sqlTableModel.getColumnName(selectedCol),
				sqlTableModel.getColumnClass(selectedCol),
				sqlTableModel.getValueAt(selectedRow, selectedCol));
	}

	/**
	 * @param viewColumn
	 */
	private void actionPerformedViewer(ViewColumn viewColumn) {
		int selectedRow = getSelectedRows()[0];
		int selectedCol = getSelectedColumns()[0];

		JTableSqlModel sqlTableModel = (JTableSqlModel) getModel();

		sqlTableModel.viewer(selectedRow, selectedCol, viewColumn);
	}

	/**
	 * @param deic
	 */
	private void actionPerformedFileInput(DenyEditInCell deic) {
		int selectedRow = getSelectedRows()[0];
		int selectedCol = getSelectedColumns()[0];

		JTableSqlModel sqlTableModel = (JTableSqlModel) getModel();

		sqlTableModel.setValueAt(deic, selectedRow, selectedCol);
	}

	/**
	 * 
	 */
	private void actionPerformedTextEditer() {
		int selectedRow = getSelectedRows()[0];
		int selectedCol = getSelectedColumns()[0];

		JTableSqlModel sqlTableModel = (JTableSqlModel) getModel();

		sqlTableModel.textEditer(selectedRow, selectedCol);
	}

	/**
	 * @throws SQLException 
	 * @throws JdbcacsessException 
	 * 
	 */
	private void actionPerformedSqlMapping() throws JdbcacsessException, SQLException {
		int selectedRow = getSelectedRows()[0];
		int selectedCol = getSelectedColumns()[0];

		JTableSqlModel sqlTableModel = (JTableSqlModel) getModel();

		sqlTableModel.sqlMapping(selectedRow, selectedCol);
	}

	/**
	 * This method initializes jPopupMenu
	 * 
	 * @return javax.swing.JPopupMenu
	 * @uml.property name="jPopupMenu"
	 */
	private JPopupMenuCnageUI getJPopupMenu() {
		if (jPopupMenu == null) {
			jPopupMenu = new JPopupMenuCnageUI();
			jPopupMenu.add(getJMenuItemSetNULL());
			jPopupMenu.add(getJMenuItemDefaultInsert());
			jPopupMenu.addSeparator();
			jPopupMenu.add(getJMenuItemRowDelete());
			jPopupMenu.addSeparator();
			jPopupMenu.add(getJMenuItemRowInsert());
			jPopupMenu.add(getJMenuItemRowInsertNull());
			jPopupMenu.addSeparator();
			jPopupMenu.add(getJMenuItemRowCopy());
			jPopupMenu.addSeparator();
			jPopupMenu.add(getJMenuItemToClipRangeComma());
			jPopupMenu.add(getJMenuItemToClipRangeTab());
			jPopupMenu.add(getJMenuItemToClipRangeCond());
			jPopupMenu.addSeparator();
			jPopupMenu.add(getJMenuItemSelectRow());
			jPopupMenu.add(getJMenuItemSelectAll());
			jPopupMenu.addSeparator();
			jPopupMenu.add(getJMenuSqlDataTree());
			jPopupMenu.add(getJMenuHexViewer());
			jPopupMenu.add(getJMenuImageViewer());
			jPopupMenu.add(getJMenuOutputFile());
			jPopupMenu.addSeparator();
			jPopupMenu.add(getJMenuItemTextEditer());
			jPopupMenu.add(getJMenuInputFile());
			jPopupMenu.addSeparator();
			jPopupMenu.add(getJMenuItemSqlMapping());
		}
		return jPopupMenu;
	}

	private JMenuItem getJMenuItemSetNULL() {
		if (jMenuItemSetNULL == null) {
			jMenuItemSetNULL = new JMenuItem();
			jMenuItemSetNULL.setText("NULLに更新");
			jMenuItemSetNULL.setToolTipText("SQLのNULL値に更新します");
			jMenuItemSetNULL
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedSetNULL(e);
						}
					});
		}
		return jMenuItemSetNULL;
	}

	/**
	 * This method initializes jMenuItem2
	 * 
	 * @return javax.swing.JMenuItem
	 * @uml.property name="jMenuItemRowDelete"
	 */
	private JMenuItem getJMenuItemRowDelete() {
		if (jMenuItemRowDelete == null) {
			jMenuItemRowDelete = new JMenuItem();
			jMenuItemRowDelete.setText("行削除");
			jMenuItemRowDelete
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedRowDelete(e);
						}
					});
		}
		return jMenuItemRowDelete;
	}

	/**
	 * This method initializes jMenuItem3
	 * 
	 * @return javax.swing.JMenuItem
	 * @uml.property name="jMenuItemRowInsert"
	 */
	private JMenuItem getJMenuItemRowInsert() {
		if (jMenuItemRowInsert == null) {
			jMenuItemRowInsert = new JMenuItem();
			jMenuItemRowInsert.setText("値設定済行挿入");
			jMenuItemRowInsert
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedRowInsert(e);
						}
					});
		}
		return jMenuItemRowInsert;
	}

	private JMenuItem getJMenuItemRowInsertNull() {
		if (jMenuItemRowInsertNull == null) {
			jMenuItemRowInsertNull = new JMenuItem();
			jMenuItemRowInsertNull.setText("null値行挿入");
			jMenuItemRowInsertNull
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedRowInsertNull(e);
						}
					});
		}
		return jMenuItemRowInsertNull;
	}

	/**
	 * This method initializes jMenuItem4
	 * 
	 * @return javax.swing.JMenuItem
	 * @uml.property name="jMenuItemRowCopy"
	 */
	private JMenuItem getJMenuItemRowCopy() {
		if (jMenuItemRowCopy == null) {
			jMenuItemRowCopy = new JMenuItem();
			jMenuItemRowCopy.setText("行複写");
			jMenuItemRowCopy
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedRowCopy(e);
						}
					});
		}
		return jMenuItemRowCopy;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 * @uml.property name="jMenuItemToClipRangeComma"
	 */
	private JMenuItem getJMenuItemToClipRangeComma() {
		if (jMenuItemToClipRangeComma == null) {
			jMenuItemToClipRangeComma = new JMenuItem();
			jMenuItemToClipRangeComma.setText("カンマ区切りでコピー");
			jMenuItemToClipRangeComma
					.setToolTipText("<html>各カラムをカンマで繋げてクリップボードへコピーします。<br>"
							+ "１行目はカラム名が自動的にコピーされます。</html>");
			jMenuItemToClipRangeComma
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedCopyRange(',');
						}
					});
		}
		return jMenuItemToClipRangeComma;
	}

	/**
	 * This method initializes jMenuItem1
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemToClipRangeTab() {
		if (jMenuItemToClipRangeTab == null) {
			jMenuItemToClipRangeTab = new JMenuItem();
			jMenuItemToClipRangeTab.setText("タブ区切りでコピー CTRL+C");
			jMenuItemToClipRangeTab
					.setToolTipText("<html>各カラムをタブで繋げてクリップボードへコピーします。<br>"
							+ "１行目はカラム名が自動的にコピーされます。</html>");
			jMenuItemToClipRangeTab
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedCopyRange('\t');
						}
					});
		}
		return jMenuItemToClipRangeTab;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 * @uml.property name="jMenuItemToClipRangeComma"
	 */
	private JMenuItem getJMenuItemToClipRangeCond() {
		if (jMenuItemToClipRangeCond == null) {
			jMenuItemToClipRangeCond = new JMenuItem();
			jMenuItemToClipRangeCond.setText("条件式でコピー");
			jMenuItemToClipRangeCond
					.setToolTipText("<html>カラム名=値のand条件としクリップボードへコピーします。</html>");
			jMenuItemToClipRangeCond
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedCopyCond();
						}
					});
		}
		return jMenuItemToClipRangeCond;
	}

	/**
	 * This method initializes jMenuItemDefaultInsert
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemDefaultInsert() {
		if (jMenuItemDefaultInsert == null) {
			jMenuItemDefaultInsert = new JMenuItem();
			jMenuItemDefaultInsert.setText("Insertから除外");
			jMenuItemDefaultInsert
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedDefaultInsert(e);
						}
					});
		}
		return jMenuItemDefaultInsert;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemSelectRow() {
		if (jMenuItemSelectRow == null) {
			jMenuItemSelectRow = new JMenuItem();
			jMenuItemSelectRow.setText("行選択");
			jMenuItemSelectRow.setToolTipText("セル選択を行選択へ拡大します。");
			jMenuItemSelectRow
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							setColumnSelectionInterval(0, getColumnCount() - 1);
						}
					});
		}
		return jMenuItemSelectRow;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemSelectAll() {
		if (jMenuItemSelectAll == null) {
			jMenuItemSelectAll = new JMenuItem();
			jMenuItemSelectAll.setText("全て選択");
			jMenuItemSelectAll.setToolTipText("<html>検索取得済データの全てを選択します。<br>"
					+ "継続取得すべきデータが残っている場合は、その分は選択されません。</html>");
			jMenuItemSelectAll
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							selectAll();
						}
					});
		}
		return jMenuItemSelectAll;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuSqlDataTree() {
		if (jMenuItemSqlDataTree == null) {
			jMenuItemSqlDataTree = new JMenuItem();
			jMenuItemSqlDataTree.setText("ObjectTree...");
			jMenuItemSqlDataTree
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedSqlDataTree();
						}
					});
		}
		return jMenuItemSqlDataTree;
	}

	/**
	 * This method initializes jMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenuHexViewer() {
		if (jMenuHexViewer == null) {
			jMenuHexViewer = new JMenu();
			jMenuHexViewer.setText("バイナリビューワ画面で表示");
			jMenuHexViewer.setToolTipText("<html>１６進文字列で１バイトずつ表示します。<br>"
					+ "更新は画面からは出来ないので、『カラム更新(ファイルから)』で行ってください。</html>");
			jMenuHexViewer.add(getJMenuItemHexGetBinaryStream());
			jMenuHexViewer.add(getJMenuItemHexGetBlob());
			jMenuHexViewer.add(getJMenuItemHexGetBytes());
			jMenuHexViewer.add(getJMenuItemHexGetString());
		}
		return jMenuHexViewer;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemHexGetBinaryStream() {
		if (jMenuItemHexGetBinaryStream == null) {
			jMenuItemHexGetBinaryStream = new JMenuItem();
			jMenuItemHexGetBinaryStream.setText("バイナリ[getBinaryStream()]...");
			jMenuItemHexGetBinaryStream
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedViewer(new ViewerGetBinaryStream(
									JFrameViewerHex.getInstance()));
						}
					});
		}
		return jMenuItemHexGetBinaryStream;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemHexGetBlob() {
		if (jMenuItemHexGetBlob == null) {
			jMenuItemHexGetBlob = new JMenuItem();
			jMenuItemHexGetBlob.setText("バイナリ[getBlob()]...");
			jMenuItemHexGetBlob
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedViewer(new ViewerGetBlob(
									JFrameViewerHex.getInstance()));
						}
					});
		}
		return jMenuItemHexGetBlob;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemHexGetBytes() {
		if (jMenuItemHexGetBytes == null) {
			jMenuItemHexGetBytes = new JMenuItem();
			jMenuItemHexGetBytes.setText("バイナリ[getBytes()]...");
			jMenuItemHexGetBytes
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedViewer(new ViewerGetBytes(
									JFrameViewerHex.getInstance()));
						}
					});
		}
		return jMenuItemHexGetBytes;
	}

	/**
	 * This method initializes jMenuItemViewerGetString
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemHexGetString() {
		if (jMenuItemHexGetString == null) {
			jMenuItemHexGetString = new JMenuItem();
			jMenuItemHexGetString.setText("テキスト[getString()]...");
			jMenuItemHexGetString
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedViewer(new ViewerGetString(
									JFrameViewerHex.getInstance()));
						}
					});
		}
		return jMenuItemHexGetString;
	}

	/**
	 * This method initializes jMenuOutputFile
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenuOutputFile() {
		if (jMenuOutputFile == null) {
			jMenuOutputFile = new JMenu();
			jMenuOutputFile.setText("カラム出力(ファイルへ)");
			jMenuOutputFile.setToolTipText("１カラムselectを再発行して、結果を１ファイルに書き込みます");
			jMenuOutputFile.add(getJMenuItemOutputFileBinary());
			jMenuOutputFile.add(getJMenuItemOutputFileChar());
		}
		return jMenuOutputFile;
	}

	/**
	 * This method initializes jMenuItemOutputFileGetBinaryStream
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemOutputFileBinary() {
		if (jMenuItemOutputFileBinary == null) {
			jMenuItemOutputFileBinary = new JMenuItem();
			jMenuItemOutputFileBinary.setText("バイナリ[getBinaryStream()]...");
			jMenuItemOutputFileBinary
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							File f = lastOutputFile.choice();
							if (f != null) {
								actionPerformedViewer(new ViewerGetBinaryStream(
										new FileOutputBinary(f)));
							}
						}

					});
		}
		return jMenuItemOutputFileBinary;
	}

	/**
	 * This method initializes jMenuItemOutputFileGetCharcterStream
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemOutputFileChar() {
		if (jMenuItemOutputFileChar == null) {
			jMenuItemOutputFileChar = new JMenuItem();
			jMenuItemOutputFileChar.setText("テキスト[getCharacterStream()]...");
			jMenuItemOutputFileChar
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							File f = lastOutputFile.choice();
							if (f != null) {
								actionPerformedViewer(new ViewerGetChracterStream(
										new FileOutputCharcter(f)));
							}
						}
					});
		}
		return jMenuItemOutputFileChar;
	}

	/**
	 * This method initializes jMenuTextEciter
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenuItem getJMenuItemTextEditer() {
		if (jMenuItemTextEditer == null) {
			jMenuItemTextEditer = new JMenuItem();
			jMenuItemTextEditer.setText("テキスト編集...");
			jMenuItemTextEditer
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedTextEditer();
						}
					});
		}
		return jMenuItemTextEditer;
	}

	/**
	 * This method initializes jMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenuInputFile() {
		if (jMenuInputFile == null) {
			jMenuInputFile = new JMenu();
			jMenuInputFile.setText("カラム更新(ファイルから)");
			jMenuInputFile.setToolTipText("１ファイル分の内容全体で、１カラムupdateを発行します");
			jMenuInputFile.add(getJMenuItemInputFileBinary());
			jMenuInputFile.add(getJMenuItemInputFileChar());
		}
		return jMenuInputFile;
	}

	/**
	 * This method initializes jMenuItemSetBinaryStream
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemInputFileBinary() {
		if (jMenuItemInputFileBinary == null) {
			jMenuItemInputFileBinary = new JMenuItem();
			jMenuItemInputFileBinary.setText("バイナリ[setBinaryStream()]...");
			jMenuItemInputFileBinary
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							File f = lastInputFile.choice();
							if (f != null) {
								FileInputStream fis = null;
								try {
									fis = new FileInputStream(f);
								} catch (FileNotFoundException e1) {
									JDialogMessage.errorDialog(e1);
								}
								DenyEditInCell deic = new BinaryInputStream(
										new BufferedInputStream(fis), (int) f
												.length());
								actionPerformedFileInput(deic);
							}
						}
					});
		}
		return jMenuItemInputFileBinary;
	}

	/**
	 * This method initializes jMenuItemSetCharacterStream
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemInputFileChar() {
		if (jMenuItemInputFileChar == null) {
			jMenuItemInputFileChar = new JMenuItem();
			jMenuItemInputFileChar.setText("テキスト[setCharacterStream]...");
			jMenuItemInputFileChar
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							File f = lastInputFile.choice();
							if (f != null) {
								InputStreamReader isr = null;
								try {
									isr = new InputStreamReader(
											new FileInputStream(f),
											JFrameSetting
													.getColumnInOutEncodeing().getValue());
								} catch (FileNotFoundException e1) {
									JDialogMessage.errorDialog(e1);
								}
								DenyEditInCell deic = new CharacterInputStream(
										new BufferedReader(isr), (int) f
												.length());
								actionPerformedFileInput(deic);
							}
						}
					});
		}
		return jMenuItemInputFileChar;
	}

	/**
	 * This method initializes jMenuImageViewer
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenuImageViewer() {
		if (jMenuImageViewer == null) {
			jMenuImageViewer = new JMenu();
			jMenuImageViewer.setText("画像ビューワ画面で表示");
			jMenuImageViewer.add(getJMenuItemImageGetBinaryStream());
			jMenuImageViewer.add(getJMenuItemImageGetBlob());
		}
		return jMenuImageViewer;
	}

	/**
	 * This method initializes jMenuItemImageGetBinaryStream
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemImageGetBinaryStream() {
		if (jMenuItemImageGetBinaryStream == null) {
			jMenuItemImageGetBinaryStream = new JMenuItem();
			jMenuItemImageGetBinaryStream.setText("バイナリ[getBinaryStream()]...");
			jMenuItemImageGetBinaryStream
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedViewer(new ViewerGetBinaryStream(
									JFrameViewerImage.getInstance()));
						}
					});
		}
		return jMenuItemImageGetBinaryStream;
	}

	/**
	 * This method initializes jMenuItemImageGetBlob
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemImageGetBlob() {
		if (jMenuItemImageGetBlob == null) {
			jMenuItemImageGetBlob = new JMenuItem();
			jMenuItemImageGetBlob.setText("バイナリ[getBlob()]...");
			jMenuItemImageGetBlob
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							actionPerformedViewer(new ViewerGetBlob(
									JFrameViewerImage.getInstance()));
						}
					});
		}
		return jMenuItemImageGetBlob;
	}

	/**
	 * This method initializes jMenuItemSqlMapping
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemSqlMapping() {
		if (jMenuItemSqlMapping == null) {
			jMenuItemSqlMapping = new JMenuItem();
			jMenuItemSqlMapping.setText("SQLデータ型マッピング...");
			jMenuItemSqlMapping
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							try {
								actionPerformedSqlMapping();
							} catch (JdbcacsessException e1) {
								JDialogMessage.errorDialog(e1);
							} catch (SQLException e1) {
								JDialogMessage.errorDialog(e1);
							}
						}
					});
		}
		return jMenuItemSqlMapping;
	}

	/*
	 * 追加メニューアイテムを受け付ける
	 */
	public void insertMenuItem(Component menuItem, int index) {
		jPopupMenu.insert(menuItem, index);
	}

}
