/**
 * 
 */
package jdbcacsess.gui.cell;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.Reader;

import jdbcacsess.gui.common.JDialogMessage;

/**
 * @author sima
 * 
 */
public class FileOutputBinary implements OutputHandler {

	File file;

	InputStream is;

	String dataSource;

	public FileOutputBinary(File file) {
		this.file = file;
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.gui.cell.OutputHandler#setInputStream(java.io.InputStream)
	 */
	public void setInputStream(InputStream is) {
		this.is = is;
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.gui.cell.OutputHandler#setReader(java.io.Reader)
	 */
	public void setReader(Reader r) {
		throw new ExceptionNoimplements();
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.gui.cell.OutputHandler#setDataSize(long)
	 */
	public void setDataSize(long size) {
//		throw new ExceptionNoimplements();
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.gui.cell.OutputHandler#setDataSource(java.lang.String)
	 */
	public void setDataSource(String dataSource) {
		this.dataSource = dataSource;
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.gui.cell.OutputHandler#output()
	 */
	public void output() {
		BufferedInputStream bis = null;
		BufferedOutputStream bos = null;
		try {

			bis = new BufferedInputStream(is);
			bos = new BufferedOutputStream(new FileOutputStream(file));

			int c;

			while ((c = bis.read()) != -1) {
				bos.write(c);
			}
			JDialogMessage.infoDialog(file.getPath() + "に出力しました", dataSource);
		} catch (IOException e) {
			JDialogMessage.errorDialog(e);
		} finally {
			if (bis != null) {
				try {
					bis.close();
				} catch (IOException e) {
				}
			}
			if (bos != null) {
				try {
					bos.close();
				} catch (IOException e) {
				}
			}
		}
	}

}
