/**
 * 
 */
package jdbcacsess.gui.cell;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;

import jdbcacsess.gui.JFrameSetting;
import jdbcacsess.gui.common.JDialogMessage;

/**
 * @author sima
 * 
 */
public class FileOutputCharcter implements OutputHandler {

	File file;

	Reader r;

	String dataSource;

	public FileOutputCharcter(File file) {
		this.file = file;
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.gui.cell.OutputHandler#setInputStream(java.io.InputStream)
	 */
	public void setInputStream(InputStream is) {
		throw new ExceptionNoimplements();
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.gui.cell.OutputHandler#setReader(java.io.Reader)
	 */
	public void setReader(Reader r) {
		this.r = r;
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.gui.cell.OutputHandler#setDataSize(long)
	 */
	public void setDataSize(long size) {
		throw new ExceptionNoimplements();
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.gui.cell.OutputHandler#setDataSource(java.lang.String)
	 */
	public void setDataSource(String dataSource) {
		this.dataSource = dataSource;
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.gui.cell.OutputHandler#output()
	 */
	public void output() {
		BufferedReader br = null;
		BufferedWriter bw = null;
		try {

			int c;
			br = new BufferedReader(r);
			bw = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(file), JFrameSetting
							.getColumnInOutEncodeing().getValue()));
			while ((c = br.read()) != -1) {
				bw.write(c);
			}
			JDialogMessage.infoDialog(file.getPath() + "に出力しました", dataSource);
		} catch (IOException e) {
			JDialogMessage.errorDialog(e);
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
				}
			}
			if (bw != null) {
				try {
					bw.close();
				} catch (IOException e) {
				}
			}
		}
	}
}
