/**
 * 
 */
package jdbcacsess.gui.cell;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.HeadlessException;
import java.io.IOException;
import java.io.StringReader;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.text.PlainDocument;

import jdbcacsess.gui.common.ComponentProperty;
import jdbcacsess.gui.common.JComboBoxLineSeparator;
import jdbcacsess.gui.common.JPopupMenuEdit;
import jdbcacsess.gui.common.JComboBoxLineSeparator.LineSeparator;

/**
 * @author sima
 * 
 */
public class JDialogTextEditer extends JDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7455394030874059074L;

	private JPanel jContentPane = null;

	private JPanel jPanel = null;

	private JButton jButtonUpdate = null;

	private JButton jButtonCancel = null;

	private JScrollPane jScrollPane = null;

	private JTextArea jTextArea = null;

	private JComboBoxLineSeparator jComboBoxLineSeparator = null;

	private JPanel jPanel1 = null;

	// 更新ボタンが押されたか?
	boolean tableUpdate;

	/**
	 * @throws HeadlessException
	 */
	public JDialogTextEditer() throws HeadlessException {
		super();
		// TODO 自動生成されたコンストラクター・スタブ
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		new ComponentProperty().restoreWindowPosition(this, 600, 400);
		addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent e) {
				dialogClosing();
			}
		});
		this.setTitle("テキスト編集");
		this.setModal(true);
		this.setContentPane(getJContentPane());

		// 画面初期表示
		jComboBoxLineSeparator.setSelectedItem(getLineSeparatorFromProperty());
		int tabSize = getTabSizeFromProperty();
		switch (tabSize) {
		case 2:
			jRadioButtonTab2.setSelected(true);
			break;
		case 3:
			jRadioButtonTab3.setSelected(true);
			break;
		case 4:
			jRadioButtonTab4.setSelected(true);
			break;
		case 8:
			jRadioButtonTab8.setSelected(true);
			break;
		}
		jTextArea.setTabSize(getTabSizeFromProperty());
		jCheckBoxLineWrap.setSelected(getLineWrapProperty());

		new JPopupMenuEdit(jTextArea);
	}

	public void dialogClosing() {
		ComponentProperty cp = new ComponentProperty();
		cp.storeWindowPosition(this);

		cp.put(this.getClass(), "lineSeparator", jComboBoxLineSeparator
				.getSelectedItem().toString());
		cp.put(this.getClass(), "tabSize", jTextArea.getTabSize());
		cp.put(this.getClass(), "lineWrap",
				Boolean.valueOf(jTextArea.getLineWrap()).toString());
		tableUpdate = false;
		setVisible(false);
	}

	private LineSeparator getLineSeparatorFromProperty() {
		String rtn = new ComponentProperty().getToString(this.getClass(),
				"lineSeparator");
		return LineSeparator.defaultValueOf(rtn);
	}

	private int getTabSizeFromProperty() {
		Integer rtn = new ComponentProperty().getToInteger(this.getClass(),
				"tabSize");
		if (rtn == null) {
			return 4;
		}
		return rtn.intValue();
	}

	private boolean getLineWrapProperty() {
		String rtn = new ComponentProperty().getToString(this.getClass(),
				"lineWrap");
		if (rtn.equals("")) {
			rtn = "false";
		}
		return Boolean.valueOf(rtn);
	}

	/**
	 * テキストを表示する
	 * 
	 * @param text
	 *            DBから検索した値
	 */
	public void setText(String text) {
		if (text == null) {
			return;
		}
		// reader経由で読込ませれば改行コードは、'\n'に統一されるみたいだ
		StringReader sr = new StringReader(text);
		try {
			jTextArea.read(sr, new PlainDocument());
		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}

		jTextArea.setTabSize(getTabSizeFromProperty());
		jTextArea.setLineWrap(getLineWrapProperty());
		jTextArea.setCaretPosition(0);
	}

	public String getText() {
		String lineSeparator = jComboBoxLineSeparator.getSelectedItem()
				.getLineSeparator();
		StringBuilder sb = new StringBuilder();
		String str = jTextArea.getText();
		for (int i = 0; i < str.length(); i++) {
			char c = str.charAt(i);
			if (c == '\n') {
				sb.append(lineSeparator);
			} else {
				sb.append(c);
			}
		}
		return sb.toString();
	}

	public boolean isTableUpdate() {
		return tableUpdate;
	}

	private JCheckBox jCheckBoxLineWrap = null;

	private JPanel jPanel2 = null;

	private JRadioButton jRadioButtonTab2 = null;

	private JRadioButton jRadioButtonTab3 = null;

	private JRadioButton jRadioButtonTab4 = null;

	private JRadioButton jRadioButtonTab8 = null;

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.add(getJPanel2(), null);
			jPanel.add(getJCheckBoxLineWrap(), null);
			jPanel.add(getJPanel1(), null);
			jPanel.add(getJButton(), null);
			jPanel.add(getJButton1(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButtonUpdate == null) {
			jButtonUpdate = new JButton();
			jButtonUpdate.setText("DB更新");
			jButtonUpdate
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							tableUpdate = true;
							// 更新は呼び元で行うので、非表示にして戻る
							setVisible(false);
						}
					});
		}
		return jButtonUpdate;
	}

	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton1() {
		if (jButtonCancel == null) {
			jButtonCancel = new JButton();
			jButtonCancel.setText("閉じる");
			jButtonCancel
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							dialogClosing();
						}
					});
		}
		return jButtonCancel;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTextArea());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTextArea
	 * 
	 * @return javax.swing.JTextArea
	 */
	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
		}
		return jTextArea;
	}

	/**
	 * This method initializes jComboBoxLineSeparator
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBoxLineSeparator getJComboBoxLineSeparator() {
		if (jComboBoxLineSeparator == null) {
			jComboBoxLineSeparator = new JComboBoxLineSeparator();
		}
		return jComboBoxLineSeparator;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(new BorderLayout());
			jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(
					null, "更新時の改行",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION, null,
					null));
			jPanel1.setMinimumSize(new java.awt.Dimension(0, 0));
			jPanel1.add(getJComboBoxLineSeparator(),
					java.awt.BorderLayout.CENTER);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jCheckBoxLineWarp
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBoxLineWrap() {
		if (jCheckBoxLineWrap == null) {
			jCheckBoxLineWrap = new JCheckBox();
			jCheckBoxLineWrap.setText("行折り返し");
			jCheckBoxLineWrap
					.addItemListener(new java.awt.event.ItemListener() {
						public void itemStateChanged(java.awt.event.ItemEvent e) {
							jTextArea.setLineWrap(jCheckBoxLineWrap
									.isSelected());
						}
					});
		}
		return jCheckBoxLineWrap;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setVgap(0);
			flowLayout.setHgap(0);
			jPanel2 = new JPanel();
			jPanel2.setLayout(flowLayout);
			jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(
					null, "タブの表示カラム数",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION, null,
					null));
			jPanel2.add(getJRadioButtonTab2(), null);
			jPanel2.add(getJRadioButtonTab3(), null);
			jPanel2.add(getJRadioButtonTab4(), null);
			jPanel2.add(getJRadioButtonTab8(), null);
			ButtonGroup bg = new ButtonGroup();
			bg.add(jRadioButtonTab2);
			bg.add(jRadioButtonTab3);
			bg.add(jRadioButtonTab4);
			bg.add(jRadioButtonTab8);
		}
		return jPanel2;
	}

	/**
	 * This method initializes jRadioButtonTab2
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonTab2() {
		if (jRadioButtonTab2 == null) {
			jRadioButtonTab2 = new JRadioButton();
			jRadioButtonTab2.setText("2");
			jRadioButtonTab2.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jRadioButtonTab2
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							jTextArea.setTabSize(2);
						}
					});
		}
		return jRadioButtonTab2;
	}

	/**
	 * This method initializes jRadioButton3
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonTab3() {
		if (jRadioButtonTab3 == null) {
			jRadioButtonTab3 = new JRadioButton();
			jRadioButtonTab3.setText("3");
			jRadioButtonTab3.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jRadioButtonTab3
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							jTextArea.setTabSize(3);
						}
					});
		}
		return jRadioButtonTab3;
	}

	/**
	 * This method initializes jRadioButtonTab4
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonTab4() {
		if (jRadioButtonTab4 == null) {
			jRadioButtonTab4 = new JRadioButton();
			jRadioButtonTab4.setText("4");
			jRadioButtonTab4.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jRadioButtonTab4
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							jTextArea.setTabSize(4);
						}
					});
		}
		return jRadioButtonTab4;
	}

	/**
	 * This method initializes jRadioButtonTab8
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonTab8() {
		if (jRadioButtonTab8 == null) {
			jRadioButtonTab8 = new JRadioButton();
			jRadioButtonTab8.setText("8");
			jRadioButtonTab8.setMargin(new java.awt.Insets(0, 0, 0, 0));
			jRadioButtonTab8
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							jTextArea.setTabSize(8);
						}
					});
		}
		return jRadioButtonTab8;
	}

}
