package jdbcacsess.gui.cell;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;

abstract public class ViewColumn {

	OutputHandler outputHandler;

	public ViewColumn(OutputHandler outputHandler) {
		this.outputHandler = outputHandler;

	}

	public OutputHandler getOutputHandler() {
		return outputHandler;
	}

	public void setResultSet(ResultSet resultSet) throws ExceptionNullSelect,
			SQLException, IOException {
		getColumn(resultSet);
		if (resultSet.wasNull()) {
			throw new ExceptionNullSelect();
		}
	}

	abstract void getColumn(ResultSet resultSet) throws SQLException;

	abstract public void execute(String comment) throws IOException,
			SQLException;
}
