package jdbcacsess.gui.cell;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.sql.Blob;
import java.sql.ResultSet;
import java.sql.SQLException;

public class ViewerGetBlob extends ViewColumn {

	Blob blob;

	public ViewerGetBlob(OutputHandler viewer) {
		super(viewer);
	}

	@Override
	void getColumn(ResultSet resultSet) throws SQLException {
		blob = resultSet.getBlob(1);
	}

	public @Override
	void execute(String dataSource) throws IOException, SQLException {
		OutputHandler oh = getOutputHandler();
		oh.setInputStream(new BufferedInputStream(blob.getBinaryStream()));
		oh.setDataSize(blob.length());
		oh.setDataSource("getBlob:" + dataSource);
		oh.output();
	}

}
