package jdbcacsess.gui.cell;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;

public class ViewerGetBytes extends ViewColumn {

	byte[] bytes;

	public ViewerGetBytes(OutputHandler viewer) {
		super(viewer);
	}

	@Override
	void getColumn(ResultSet resultSet) throws SQLException {
		bytes = resultSet.getBytes(1);
	}

	public @Override
	void execute(String dataSource) throws IOException {
		OutputHandler oh = getOutputHandler();
		oh.setInputStream(new BufferedInputStream(new ByteArrayInputStream(
				bytes)));
		oh.setDataSize(bytes.length);
		oh.setDataSource("getBytes:" + dataSource);
		oh.output();
	}

}
