/**
 * 
 */
package jdbcacsess.gui.common;

import java.awt.Component;

import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;

/**
 * @author sima
 * 
 */
public class ColumnWidth {

	static public void setColumnWidth(JTable jtable) {
		jtable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_LAST_COLUMN);

		resizeCell(jtable, jtable.getColumnCount() - 1);
	}

	static public void setColumnWidthResizeOff(JTable jtable) {
		jtable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);

		resizeCell(jtable, jtable.getColumnCount());
	}

	static public void setHeaderWidth(JTable jtable, int margin) {
		jtable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_LAST_COLUMN);

		resizeHeader(jtable, jtable.getColumnModel().getColumnCount() - 1,
				margin);
	}

	static public void setHeaderWidthResizeOff(JTable jtable, int margin) {
		jtable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);

		resizeHeader(jtable, jtable.getColumnModel().getColumnCount(), margin);
	}

	/**
	 * @param jtable
	 * @param columnCnt
	 */
	private static void resizeCell(JTable jtable, int columnCnt) {
		for (int col = 0; col < columnCnt; col++) {
			TableColumn tableColumn = jtable.getColumnModel().getColumn(col);

			int width = 0;
			for (int row = 0; row < jtable.getRowCount(); row++) {
				Object obj = jtable.getValueAt(row, col);
				if (obj == null) {
					continue;
				}

				TableCellRenderer tcr = jtable.getCellRenderer(row, col);
				Component c = tcr.getTableCellRendererComponent(jtable, obj,
						false, false, row, col);
				int w = c.getFontMetrics(c.getFont()).stringWidth(
						obj.toString()) + 10;

				if (width < w) {
					width = w;
				}
			}

			tableColumn.setPreferredWidth(width);
		}
	}

	/**
	 * @param jtable
	 * @param columnCnt
	 */
	static private void resizeHeader(JTable jtable, int columnCnt, int margin) {
		for (int col = 0; col < columnCnt; col++) {
			TableColumn tableColumn = jtable.getColumnModel().getColumn(col);

			TableCellRenderer tcr = tableColumn.getHeaderRenderer();
			if (tcr == null) {
				tcr = jtable.getTableHeader().getDefaultRenderer();
			}

			String columnName = jtable.getColumnName(col);
			Component c = tcr.getTableCellRendererComponent(jtable, columnName,
					false, false, -1, col);
			int width = c.getFontMetrics(c.getFont()).stringWidth(columnName)
					+ margin;

			tableColumn.setPreferredWidth(width);
		}
	}

}
