package jdbcacsess.gui.common;

import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.List;

import jdbcacsess.LogOutput;

public class ConstEncoding {
	static private List<ConstEncoding> list;
	static {
		list= new ArrayList<ConstEncoding>();
		
		list.add(new ConstEncoding("実行環境デフォルト", Charset.defaultCharset()));
		
		for (Charset c : Charset.availableCharsets().values()) {
			list.add(new ConstEncoding(c.toString().toUpperCase(),c));
		}
		
	}
 	
	private String name;
	private Charset value;
	
	public ConstEncoding(String name , Charset value){
		this.name = name;
		this.value = value;
	}
	@Override
	public String toString(){
		return name;
	}
	public Charset getValue(){
		return value;
	}
	
	public static Object[] values(){
		return list.toArray();
	}

	public static ConstEncoding searchName(String name) {
		if (name.equals("EUC_JP")){
			name = "EUC-JP";
		}
		for (ConstEncoding item : list) {
			if (item.name.equals(name)){
				return item;
			}
		}
		
		LogOutput.info("不明なエンコード名称：" + name);
		return list.get(0);
	}
	
	public static String getEnumName(){
		return "エンコード";
	}

}
