package jdbcacsess.gui.common;

import java.awt.GraphicsEnvironment;
import java.util.ArrayList;
import java.util.List;

import jdbcacsess.LogOutput;

public class ConstFontFamilyName {
	static private List<ConstFontFamilyName> list;
	static {
		list= new ArrayList<ConstFontFamilyName>();
		
		list.add(new ConstFontFamilyName("Dialog", "Dialog"));
		list.add(new ConstFontFamilyName("DialogInput", "DialogInput"));
		list.add(new ConstFontFamilyName("Monospaced", "Monospaced"));
		list.add(new ConstFontFamilyName("SansSerif", "SansSerif"));
		list.add(new ConstFontFamilyName("Serif", "Serif"));
		
		GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
		for (String str : ge.getAvailableFontFamilyNames()) {
			list.add(new ConstFontFamilyName(str,str));
		}
		
	}
 	
	private String name;
	private String value;
	
	public ConstFontFamilyName(String name , String value){
		this.name = name;
		this.value = value;
	}
	@Override
	public String toString(){
		return name;
	}
	public String getValue(){
		return value;
	}
	
	public static Object[] values(){
		return list.toArray();
	}

	public static ConstFontFamilyName searchName(String name) {
		for (ConstFontFamilyName item : list) {
			if (item.name.equals(name)){
				return item;
			}
		}
		
		LogOutput.info("不明なフォントファミリ名称：" + name);
		return list.get(0);
	}
	
	public static String getEnumName(){
		return "フォントファミリ";
	}

}
