/**
 * 
 */
package jdbcacsess.gui.common;

import javax.swing.UIDefaults;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.plaf.FontUIResource;

import jdbcacsess.gui.JFrameSetting;

/**
 * @author sima
 *
 */
public class GUIManager {
	public static void setUIManager() throws ClassNotFoundException, InstantiationException, IllegalAccessException, UnsupportedLookAndFeelException {
		// UIの設定
		String className = new ComponentProperty().getToString(UIManager.class, "className");
		if (!"".equals(className)) {
			// java6にて何故かわからないが、UIManager.setLookAndFeel
			// でDefault以外を設定するとnullexception発生
			// linux gtk で発生する
			
			boolean flg = false;
			for (UIManager.LookAndFeelInfo info : UIManager.getInstalledLookAndFeels()) {
				if (info.getClassName().equals(className)) {
					flg = true;
					break;
				}
			}
			if (!flg) {
				className = "";
			}
		}

		if ("".equals(className)) {
			className = "javax.swing.plaf.metal.MetalLookAndFeel";
			new ComponentProperty().put(UIManager.class, "className", className);
		}

		UIManager.setLookAndFeel(className);
			
		FontUIResource fontUIResource = new FontUIResource(JFrameSetting.getGuiFont());
		UIDefaults defaultTable = UIManager.getLookAndFeelDefaults();
			  for(Object o: defaultTable.keySet()) {
			    if(o.toString().toLowerCase().endsWith("font")) {
			      UIManager.put(o, fontUIResource);
			    }
			  }
			
	}

}
