/**
 * 
 */
package jdbcacsess.gui.common;

import java.awt.Component;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JComboBox;
import javax.swing.JList;

/**
 * @author sima
 * 
 */
public class JComboBoxLineSeparator extends JComboBox {

	private static final long serialVersionUID = 7268550569825420249L;

	public enum LineSeparator {
		DEFAULT(System.getProperty("line.separator")), CRLF("\r\n"), LF("\n"), CR(
				"\r");

		String lineSeparator;

		LineSeparator(String str) {
			lineSeparator = str;
		}

		public String getLineSeparator() {
			return lineSeparator;
		}

		public static LineSeparator defaultValueOf(String str) {
			try {
				return LineSeparator.valueOf(str);
			} catch (IllegalArgumentException e) {
			}
			return LineSeparator.DEFAULT;
		}
	}

	public JComboBoxLineSeparator() {
		super(LineSeparator.values());
		setRenderer(new DefaultListCellRenderer() {
			private static final long serialVersionUID = -1674905058123547205L;

			@Override
			public Component getListCellRendererComponent(JList list,
					Object value, int index, boolean isSelected,
					boolean cellHasFocus) {
				super.getListCellRendererComponent(list, value, index,
						isSelected, cellHasFocus);
				LineSeparator v = (LineSeparator) value;
				switch (v) {
				case DEFAULT:
					setText("実行環境デフォルト");
					break;
				case CRLF:
					setText("CrLf");
					break;
				case LF:
					setText("Lf");
					break;
				case CR:
					setText("Cr");
					break;
				}
				return this;
			}
		});
	}

	@Override
	public LineSeparator getSelectedItem() {
		return (LineSeparator) super.getSelectedItem();
	}

	public void setSelectedItem(LineSeparator lineSeparator) {
		super.setSelectedItem(lineSeparator);
	}

}
