/**
 * 
 */
package jdbcacsess.gui.common;

import java.lang.reflect.Method;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Arrays;

import javax.swing.JComboBox;

/**
 * @author sima
 * 
 */
public class JComboboxGetResultSetMethod extends JComboBox {

	/**
	 * 
	 */
	private static final String NOUSE = "独自getter実装クラスを使用";

	private static final long serialVersionUID = 7067288248851720367L;

	public JComboboxGetResultSetMethod() {
		super();
		initialize();
	}

	/**
	 * 
	 */
	private void initialize() {
		ArrayList<String> list = new ArrayList<String>();

		// getXXXX(int)のメソッド名を探し出す。
		Method[] methods = ResultSet.class.getMethods();
		for (int i = 0; i < methods.length; i++) {
			if (methods[i].getName().substring(0, 3).equals("get")) {
				Class<?>[] parms = methods[i].getParameterTypes();
				if (parms.length == 1 && parms[0] == int.class) {
					list.add(methods[i].getName());
				}
			}
		}

		addItem(NOUSE);

		// メソッド名の配列を作成しソートしてから、項目追加する
		String[] array = list.toArray(new String[0]);
		Arrays.sort(array);
		for (int i = 0; i < array.length; i++) {
			addItem(array[i]);
		}
	}

	public String getSelectMethodName() {
		String rtn = (String) getSelectedItem();
		if (NOUSE.equals(rtn)) {
			return "";
		}
		return rtn;
	}

	public void setSelectMethodName(String methodName) {
		if (methodName == null || "".equals(methodName)) {
			setSelectedItem(NOUSE);
		} else {
			setSelectedItem(methodName);
		}
	}

}
