package jdbcacsess.sql;

import java.sql.DatabaseMetaData;
import java.sql.SQLException;

import javax.swing.Icon;

abstract public class DBObject {

	/**
	 * 
	 * @return
	 */
	abstract public String[] getHeader();

	/**
	 * 
	 * @return
	 */
	abstract public String[] getDetail();

	/**
	 * 
	 */
	@Override
	abstract public String toString();

	/**
	 * 
	 * @param dmd
	 * @return
	 * @throws SQLException
	 */
	abstract public DBObjects getChildren(DatabaseMetaData dmd ) throws SQLException;

	/**
	 *  TABLE系の場合のみスキーマ名とテーブル名の組み合わせをSchemaTableNameで返却する。
	 *  TABLE系以外の場合、空のSchemaTableNameを返却する
	 * @return
	 */
	public SchemaTableName getSchemaTableName() {
		return new SchemaTableName();
	}

	/**
	 * 
	 * @return
	 */
	abstract public String getName() ;

	/**
	 * 
	 * @return
	 */
	abstract public Icon getIconImage() ;

	/**
	 *  強調表示する内容であるかを返却する。
	 * @return
	 */
	abstract public boolean isStrong() ;
	
	/**
	 * 設計上で最終階層なのかを返却する。
	 * JDBCの実装とは関係なく、下位階層を保持する可能性が有るかである
	 * @return
	 */
	abstract public boolean isBottom() ;
	
	/**
	 * 概要
	 * @return
	 */
	abstract public String getSummary();
}
