package jdbcacsess.sql;

import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import javax.swing.Icon;

import jdbcacsess.gui.icons.IconImage;
import jdbcacsess.sql.DBObjectSchemas.DBObjectSchema;

public class DBObjectTableTypes extends DBObjects {

	static final String[] header = { "TABLE_TYPE" };

	private ArrayList<DBObject> tableTypes = new ArrayList<DBObject>();

	DBObjectSchema dbObjectSchema;
	public DBObjectTableTypes(DBObjectSchema schema,DatabaseMetaData dmd) throws SQLException {
		dbObjectSchema = schema;
		ResultSet rs = dmd.getTableTypes();
		while (rs.next()) {
			tableTypes.add(new DBObjectTableType(rs));
		}
		rs.close();
	}
	public DBObjectTableTypes(DatabaseMetaData dmd) throws SQLException {
		dbObjectSchema = null;
		ResultSet rs = dmd.getTableTypes();
		while (rs.next()) {
			tableTypes.add(new DBObjectTableType(rs));
		}
		rs.close();
	}

	@Override
	public ArrayList<DBObject> getDBObjects() {
		return tableTypes;
	}

	public class DBObjectTableType extends DBObject {

		private String tableTypeName;

		public DBObjectTableType(ResultSet rs) throws SQLException {
			tableTypeName = rs.getString(1);
		}

		@Override
		public String[] getDetail() {
			String[] rtn = new String[10];
			rtn[0] = tableTypeName;
			return rtn;
		}

		@Override
		public String toString() {
			return tableTypeName;
		}

		@Override
		public String[] getHeader() {
			return header;
		}

		public String getTableTypeName() {
			return tableTypeName;
		}

		@Override
		public DBObjects getChildren(DatabaseMetaData dmd) throws SQLException {
			
			return new DBObjectTables(dbObjectSchema,this, dmd);
		}

		@Override
		public String getName() {
			return tableTypeName;
		}

		@Override
		public Icon getIconImage() {
			return IconImage.TABLETYPE.getValue();
		}

		@Override
		public boolean isStrong() {
			return false;
		}

		@Override
		public boolean isBottom() {
			return false;
		}

		@Override
		public String getSummary() {
			return "";
		}

	}

	@Override
	public String toString() {
		return "TABLETYPE";
	}
}
