package jdbcacsess.sql;

import java.sql.DatabaseMetaData;
import java.sql.SQLException;
import java.util.ArrayList;

import javax.swing.Icon;

import jdbcacsess.gui.icons.IconImage;

public class DBObjectsRoot extends DBObjects {

	static final String[] header = { "ROOT" };

	private ArrayList<DBObject> root = new ArrayList<DBObject>();

	public DBObjectsRoot(DatabaseMetaData dmd)  throws SQLException{
		root.add(new DBObjectRoot(dmd));
	}

	@Override
	public ArrayList<DBObject> getDBObjects() {
		
		return root;
	}

	public static class DBObjectRoot extends DBObject {
		String name;

		DBObjectRoot(DatabaseMetaData dmd) throws SQLException{
			name = dmd.getURL();
		}

		@Override
		public DBObjects getChildren(DatabaseMetaData dmd) throws SQLException {
			DBObjects rtn = new DBObjectCatalogs(dmd);
			if (rtn.getDBObjects().size()==0){
				rtn = new DBObjectSchemas(dmd);
				if (rtn.getDBObjects().size()==0){
					rtn = new DBObjectTableTypes(dmd);
				}
			}
			return rtn;
		}

		@Override
		public String[] getDetail() {
			// TODO 自動生成されたメソッド・スタブ
			return null;
		}

		@Override
		public String[] getHeader() {
			// TODO 自動生成されたメソッド・スタブ
			return null;
		}

		@Override
		public Icon getIconImage() {
			return IconImage.ROOT.getValue();
		}

		@Override
		public String getName() {
			return name;
		}

		@Override
		public String toString() {
			return getName();
		}

		@Override
		public boolean isStrong() {
			return false;
		}

		@Override
		public boolean isBottom() {
			return false;
		}

		@Override
		public String getSummary() {
			return "";
		}
		
	}
	@Override
	public String toString() {
		// TODO 自動生成されたメソッド・スタブ
		return "ROOTS";
	}

}
