package jdbcacsess.sql;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import jdbcacsess.JdbcacsessException;

 class ExecuteStatement extends ExecuteSqlFactory{

	private ResultSet resultSet = null;
	private ArrayList<Object> rowData;

	private SqlAnalyze sqlAnalyze;
	private Connection connection;

	private PrepareExecuteStatement prepareExecute = null;
	
	//ExecuteSqResultStatement用のコンストラクタ
	ExecuteStatement(Object source, SqlAnalyze SqlAnalyze, Connection connection) throws JdbcacsessException{
		super(source);
		this.sqlAnalyze = SqlAnalyze;
		this.connection = connection;
	}
	
	/* (non-Javadoc)
	 * @see jdbcacsess.sql.ExecuteSqlFactory#initMethod()
	 */
	@Override boolean initMethod() throws Exception {

		prepareExecute = new PrepareExecuteStatement();

		prepareExecute.addStm(getSqlAnalyze().getSqlStatement());
		
		prepareExecute.prepare(connection);
		
		if (!solveParameter(prepareExecute)){
			return false;
		}
		
		this.resultSet = prepareExecute.executeQuery();
		

		getHeaderFromResultSet(resultSet, selectColmunInfos);
		
		rowData = new ArrayList<Object>(selectColmunInfos.size());

		return true;
	}
	
	/* (non-Javadoc)
	 * @see jdbcacsess.sql.ExecuteSqlFactory#getResultDetail()
	 */
	@Override
	ArrayList<Object> getResultDetail() throws IllegalArgumentException, IllegalAccessException, InvocationTargetException,
			SQLException, IOException {

		rowData.clear();
		
		getDetailFromResultSet(resultSet, rowData);
		return rowData;

		
		
	}
	
	/* (non-Javadoc)
	 * @see jdbcacsess.sql.ExecuteSqlFactory#hasNext()
	 */
	@Override
	boolean hasNext() throws SQLException {
		if (resultSet == null) {
			return false;
		}
		if (resultSet.next()) {
			return true;
		}else{
			return false;
		}
	}

	/* (non-Javadoc)
	 * @see jdbcacsess.sql.ExecuteSqlFactory#endMethod()
	 */
	@Override void endMethod() {
		try {
			if (resultSet != null) {
				resultSet.close();
			}
			if (prepareExecute != null) {
				prepareExecute.close();
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	@Override
	SqlAnalyze getSqlAnalyze() {
		return sqlAnalyze;
	}
	

}
