/**
 *
 */
package jdbcacsess.sql;

/**
 * 検索系ＳＱＬの実行状況に関するステータス情報を纏めたクラス。 検索スレッドから通知する時に使用され、途中経過の件数や最終結果の件数が判断可能
 * 
 * @author sima
 */
public class QueryExecuteStatus {

	private Object source;

	private int cnt;

	private boolean complete;

	private boolean err = false;

	public QueryExecuteStatus(Object source, int cnt, boolean complete, boolean err) {
		this.source = source;
		this.cnt = cnt;
		this.complete = complete;
		this.err = err;
	}

	/**
	 * @return cnt を戻します。
	 * @uml.property name="cnt"
	 */
	public int getCnt() {
		return cnt;
	}

	public Object getSource() {
		return source;
	}

	/**
	 * @return 最後までデータを読み込んだ(true)か、それ以外(false)
	 * @uml.property name="isComplete"
	 */
	public boolean isComplete() {
		return complete;
	}

	public boolean isErr() {
		return err;
	}

	@Override
	public String toString() {
		return "[QueryExecuteStatus]" + " source=" + source + " cnt=" + cnt + " complete=" + complete + " err=" + err;
	}
}
