/**
 * 
 */
package jdbcacsess.sql.column;

import java.io.ByteArrayOutputStream;

import jdbcacsess.gui.common.JDialogMessage;

/**
 * @author sima
 * 
 */
public class Binary {
	private byte[] binary;

	public Binary() {
		binary = new byte[0];
	}

	public Binary(byte[] bytes) {
		binary = bytes;
	}

	public Binary(String source) {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();

		// 空文字列なら何もしない
		if (source.length() != 0) {
			int start = 0;
			if ((source.length() & 1) == 1) {
				// 文字数が奇数なら先頭の１桁分だけを最初に変換
				start = 1;
				int b = Integer.parseInt(source.substring(0, 1), 16);
				baos.write(b);
				JDialogMessage.infoDialog("桁数が奇数だったので、先頭にゼロを付加しました",
						"データを加工しました");
			}
			// ２桁ずつ変換
			for (int i = start; i < source.length(); i += 2) {
				int b = Integer.parseInt(source.substring(i, i + 2), 16);
				baos.write(b);
			}
		}
		binary = baos.toByteArray();
	}

	public byte[] getValue() {
		return binary;
	}

	public int getSize() {
		return binary.length;
	}

	@Override
	public String toString() {
		if (binary == null) {
			return "";
		}
		StringBuilder builder = new StringBuilder();
		for (byte bb : binary) {
			builder.append(byteToHexString(bb));
		}
		return builder.toString();
	}

	/**
	 * １バイトを１６進文字列２桁に変換
	 * 
	 * @param b
	 * @return
	 */
    final static char[] digits = {
    	'0' , '1' , '2' , '3' , '4' , '5' ,
    	'6' , '7' , '8' , '9' , 'A' , 'B' ,
    	'C' , 'D' , 'E' , 'F'  };	
	static public String byteToHexString(byte b) {
		// 符号なし１０進数に変換
		int i = b & 0xFF;

		char[] c = { digits[(i & 0xF0)>>4] , digits[i & 0x0F] };
			
		return new String( c );
	}

	public String debug() {
		if (binary != null) {
			return "["
					+ Binary.class.getName()
					+ ",binary.length="
					+ binary.length
					+ ((binary.length > 0) ? ",binary[0]="
							+ Binary.byteToHexString(binary[0]) : "") + "]";
		}
		return "[" + Binary.class.getName() + "]";
	}

}
