package jdbcacsess.sql.column;

import java.sql.Array;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Struct;
import java.util.ArrayList;
import java.util.List;

import jdbcacsess.sql.ConstSqlTypes;

/**
 * Arrayを扱う。参照は可能だが、java.sql.Arrayのインスタンス生成が出来ないので、更新は不可
 * @author sss
 *
 */
public class GetColumnArray implements GetColumnResultSet {

	ConstSqlTypes sqlTypes;

	String sqlTypeName;

	List<Object> list;

	public GetColumnArray() {
	}

	public GetColumnArray(List<Object> list, ConstSqlTypes sqlTypes,
			String sqlTypeName) {
		this.sqlTypes = sqlTypes;
		this.sqlTypeName = sqlTypeName;
		this.list = list;
	}

	public Object getData(ResultSet resultSet, int i) throws Exception {
		Array array = resultSet.getArray(i);
		if (resultSet.wasNull() || array == null) {
			return null;
		}

		ConstSqlTypes sqlTypes = ConstSqlTypes.searchTypes(array.getBaseType());
		String sqlTypeName = array.getBaseTypeName();

		// ResultSetListener rsl = new ResultSetListener(array.getResultSet());

		Object o = array.getArray();
		if (!o.getClass().isArray()) {
			// 有り得ないがそのまま返す
			return o;
		}

		List<Object> list = new ArrayList<Object>();
		for (int j = 0; j < java.lang.reflect.Array.getLength(o); j++) {
			Object obj = java.lang.reflect.Array.get(o, j);
			list.add(obj);
			
			if (obj instanceof Struct) {
				Struct struct = (Struct) obj;
				try {
					System.out.println(struct.getSQLTypeName());
					for (Object e : struct.getAttributes()) {
						System.out.println(e);
					}
				} catch (SQLException e) {
					// TODO 自動生成された catch ブロック
					e.printStackTrace();
				}
			}
		}

		return new GetColumnArray(list, sqlTypes, sqlTypeName);
	}

	// セルの表示は、単なるlistの文字列表現
	@Override
	public String toString() {
		return list.toString();
	}

	// class ResultSetListener extends QueryExecuteAdapter{
	//
	// List<ColumnInfoResult> header;
	// List<List<Object>> detail;
	//		
	// ResultSetListener(ResultSet rs){
	// header = new ArrayList<ColumnInfoResult>();
	// detail = new ArrayList<List<Object>>();
	//			
	// QueryExecuteThread qe = new QueryExecuteThread("Array", rs);
	// qe.addQueryExecuteListener(this);
	// //スレッドで動かさず
	// qe.run();
	// }
	//		
	// public void errorException(Exception ex) {
	// JDialogMessage.errorDialog(ex);
	// }
	//
	// public void init() {
	// }
	//
	// public void setResultHeader(ArrayList<ColumnInfoResult> rowData,
	// SqlAnalyze sqlAnalyze, boolean selectUpdatable) {
	// this.header = rowData;
	// }
	//
	// public void setResultDetail(ArrayList<Object> rowData) throws IOException
	// {
	// detail.add(new ArrayList<Object>(rowData));
	// }
	//
	// public void completeQuery(QueryExecuteStatus breakStatus) {
	// }
	//
	// }

}
