/**
 * 
 */
package jdbcacsess.sql.column;


/**
 * バイナリ系データをgetするデータの基底クラス
 * 
 */
public abstract class GetColumnBinary extends Binary implements
		GetColumnResultSet {
	/**
	 * 何バイト取り込むかを示す。制限無しの時はゼロ
	 */
	protected int binaryDataSize = 0;

	/**
	 * ＤＢのデータが全て揃っているかを示す
	 */
	private boolean fullData = true;

	/**
	 * 引数無しコンストラクタ
	 */
	protected GetColumnBinary() {
		super();
	}

	/**
	 * 指定したバイト数迄を読み込むコンストラクタ
	 * 
	 * @param binaryDataSize
	 */
	protected GetColumnBinary(int binaryDataSize) {
		super();
		this.binaryDataSize = binaryDataSize;
	}

	/**
	 * 指定したバイト配列で作成するコンストラクタ
	 * 
	 * @param bytes
	 * @param fullData
	 */
	protected GetColumnBinary(byte[] bytes, boolean fullData) {
		super(bytes);
		this.fullData = fullData;
	}

	public GetColumnBinary(String data) {
		super(data);
	}

	/**
	 * ＤＢのデータが全て揃っているかを返却します
	 * 
	 * @return fullData を戻します。
	 */
	public boolean isFullData() {
		return fullData;
	}


}
