/**
 * 
 */
package jdbcacsess.sql.column;

import java.sql.Blob;
import java.sql.ResultSet;

/**
 * @author sima
 * 
 */
public class GetColumnBlob extends GetColumnBinary {

	public GetColumnBlob() {
		super();
	}

	public GetColumnBlob(String data) {
		super(data);
	}

	public GetColumnBlob(int binaryDataSize) {
		super(binaryDataSize);
	}

	private GetColumnBlob(byte[] bytes, boolean fullData) {
		super(bytes, fullData);
	}

	public GetColumnBinary getData(ResultSet resultSet, int i) throws Exception {
		Blob blob = resultSet.getBlob(i);
		if (resultSet.wasNull() || blob == null) {
			return null;
		}

		int size;
		boolean fullData = true;
		if (binaryDataSize == 0) {
			size = (int) blob.length();
		} else {
			if (binaryDataSize < blob.length()) {
				size = binaryDataSize;
				fullData = false;
			} else {
				size = (int) blob.length();
			}
		}
		return new GetColumnBlob(blob.getBytes(1, size), fullData);
	}
}