/**
 * 
 */
package jdbcacsess.sql.column;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.ResultSet;

/**
 * @author sima
 * 
 */
public class GetColumnBytesOrBinaryStream extends GetColumnBinary {

	public GetColumnBytesOrBinaryStream() {
		super();
	}

	public GetColumnBytesOrBinaryStream(String data) {
		super(data);
	}

	public GetColumnBytesOrBinaryStream(int binaryDataSize) {
		super(binaryDataSize);
	}

	private GetColumnBytesOrBinaryStream(byte[] bytes, boolean fullData) {
		super(bytes, fullData);
	}

	public GetColumnBytesOrBinaryStream getData(ResultSet resultSet, int i)
			throws Exception {
		byte[] b = null;
		boolean fullData = true;
		if (binaryDataSize == 0) {
			b = resultSet.getBytes(i);
			if (resultSet.wasNull() || b == null) {
				return null;
			}
		} else {
			// 打ち切り読み込みはbinaryStreamを使用する
			InputStream is = resultSet.getBinaryStream(i);
			if (resultSet.wasNull() || is == null) {
				return null;
			}

			BufferedInputStream bis = new BufferedInputStream(is);
			try {
				b = BinaryInputStream.readBytes(bis, binaryDataSize);
				if (bis.read() != -1) {
					fullData = false;
				}
			} catch (IOException e) {
				throw e;
			} finally {
				try {
					bis.close();
				} catch (IOException e) {
					throw e;
				}
			}
		}
		return new GetColumnBytesOrBinaryStream(b, fullData);
	}

}
