/**
 * 
 */
package jdbcacsess.sql.column;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.TimeZone;

import jdbcacsess.gui.JFrameSetting;

/**
 * @author sima
 * 
 */
public class GetColumnOracleTIMESTAMPLTZ extends Timestamp implements
		GetColumnResultSet {
	private static final long serialVersionUID = 5384457327681959271L;

	private Calendar calender = Calendar.getInstance(TimeZone
			.getTimeZone(JFrameSetting.getOracleTimeZoneOfDbserver()));

	public GetColumnOracleTIMESTAMPLTZ() {
		super(0);
	}

	/**
	 * @param time
	 */
	public GetColumnOracleTIMESTAMPLTZ(long time) {
		super(time);
	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.sql.column.getDataFromResultSet#getData(java.sql.ResultSet,
	 *      int)
	 */
	public GetColumnOracleTIMESTAMPLTZ getData(ResultSet resultSet, int i)
			throws SQLException {
		// getTimeStampにCalenderを指定しないと、sessionn time zone not set
		// エラーが発生するが、DBサーバ側のタイムゾーンを設定したCalenderを渡せば解決する。
		// 自動的に取得する事も可能だが、画面から入力してもらおう。
		Timestamp timeStamp = resultSet.getTimestamp(i, calender);

		if (resultSet.wasNull() || timeStamp == null) {
			return null;
		}
		return new GetColumnOracleTIMESTAMPLTZ(timeStamp.getTime());
	}

	@Override
	public boolean equals(Timestamp ts){
		return super.equals(ts);
	}
}
