/**
 * 
 */
package jdbcacsess.sql.column;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * 秒までの日時を表現するデータ型を扱う。
 */
public class GetColumnTimestampSS extends Timestamp implements
		GetColumnResultSet {
	/**
	 * 
	 */
	private static final long serialVersionUID = 2010682859556018849L;

	private static SimpleDateFormat sdf = new SimpleDateFormat(
			"yyyy-MM-dd HH:mm:ss");

	public GetColumnTimestampSS() {
		super(0);
	}

	/**
	 * @param time
	 */
	public GetColumnTimestampSS(long time) {
		super(time);
	}

	@Override
	public String toString() {
		String str = sdf.format(new Date(getTime()));
		return str;

	}

	/*
	 * (非 Javadoc)
	 * 
	 * @see jdbcacsess.sql.column.getDataFromResultSet#getData(java.sql.ResultSet,
	 *      int)
	 */
	public GetColumnTimestampSS getData(ResultSet resultSet, int i)
			throws SQLException {
		// Oracleではデータ型DATEの時、getObjectはjava.sql.Dateが返る。
		// java.sql.Dateでは時刻部分が表現されないので問題となる。
		// よって、getTimeStamp型で取得する
		Timestamp ts = resultSet.getTimestamp(i);

		if (resultSet.wasNull() || ts == null) {
			return null;
		}
		return new GetColumnTimestampSS(ts.getTime());
	}

}
